(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.1'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     26160,        773]*)
(*NotebookOutlinePosition[     27212,        807]*)
(*  CellTagsIndexPosition[     27168,        803]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["SetFaceAndFont2 Palette", "ObjectName"],

Cell["This loads the palette:", "Usage"],

Cell[BoxData[
    \(NotebookOpen["\<SetFaceAndFont2.nb\>"]\)], "Input"],

Cell[TextData[{
  "\[FilledSmallSquare] The \"",
  StyleBox["CopyAsInputFormK", "TI",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  StyleBox["\"", "TI",
    FontFamily->"Times",
    FontSlant->"Plain"],
  " button copies the selected text and removes formatting, leaving an \
expression suitable for pasting into for example an email. Instead of \
omitting comments inside (* *) as the menu command \"",
  Cell[BoxData[
      StyleBox[\(Convert\ To\ InputForm\),
        FontFamily->"Helvetica",
        FontWeight->"Plain",
        FontSlant->"Plain"]], "Text"],
  "\", such comments are put inside a wrapper ",
  StyleBox["Comment[\"\"];",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  " .  Please check that this does not break the code.\n\[FilledSmallSquare] \
The \"",
  StyleBox["*\[Rule]\[SpaceIndicator]",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  "\" button converts \"*\"signs to spaces. Using the \"",
  StyleBox["CopyAsInputFormK", "TI",
    FontFamily->"Courier",
    FontSlant->"Plain"],
  StyleBox["\"", "TI",
    FontFamily->"Times",
    FontSlant->"Plain"],
  " button sometimes introduces \"*\" signs. This is not always wanted, and \
then this button can be used to convert back. The combinations \"",
  StyleBox["(*",
    FontFamily->"Courier",
    FontSlant->"Plain"],
  "\", \"",
  StyleBox["*)",
    FontFamily->"Courier",
    FontSlant->"Plain"],
  "\", \"",
  StyleBox["*^",
    FontFamily->"Courier",
    FontSlant->"Plain"],
  "\", \"",
  StyleBox["**",
    FontFamily->"Courier",
    FontSlant->"Plain"],
  "\" and \"",
  StyleBox["*=",
    FontFamily->"Courier",
    FontSlant->"Plain"],
  "\" are not affected.\n\[FilledSmallSquare] The \"\[FilledSmallSquare], \
\[FilledSmallSquare]\" button pastes a copy of the selection after the \
selection, with a comma in between. If whole cells are chosen, new cells are \
inserted, without commas. \n\[FilledSmallSquare] The \[FilledSmallSquare], \
\[FilledSmallSquare] button can be used after interactive choice of points in \
a plot (See menu item ",
  StyleBox["Get Graphics Coordinates...",
    FontFamily->"Helvetica",
    FontSlant->"Plain"],
  "). The coordiantes will be pasted as a new Input cell after the plot cell.\
\n\[FilledSmallSquare] The",
  StyleBox[" ",
    FontFamily->"Times",
    FontWeight->"Plain",
    FontSlant->"Plain",
    FontTracking->"Plain",
    FontColor->Automatic,
    Background->RGBColor[0.964706, 0.929412, 0.839216]],
  StyleBox["B",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain",
    FontTracking->"Plain",
    FontColor->Automatic,
    Background->RGBColor[0.964706, 0.929412, 0.839216]],
  StyleBox["(",
    FontFamily->"Courier",
    FontWeight->"Plain",
    FontSlant->"Plain",
    FontTracking->"Plain",
    FontColor->Automatic,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FontVariations->{"Underline"->False}],
  StyleBox["Bold",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain",
    FontTracking->"Plain",
    FontColor->Automatic,
    Background->RGBColor[0.964706, 0.929412, 0.839216]],
  StyleBox[")",
    FontFamily->"Courier",
    FontWeight->"Plain",
    FontSlant->"Plain",
    FontTracking->"Plain",
    FontColor->Automatic,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FontVariations->{"Underline"->False}],
  StyleBox[", ",
    FontFamily->"Times",
    FontWeight->"Plain",
    FontSlant->"Plain",
    FontTracking->"Plain",
    FontColor->Automatic,
    Background->RGBColor[0.964706, 0.929412, 0.839216]],
  StyleBox["I",
    FontFamily->"Times",
    FontWeight->"Plain",
    FontSlant->"Italic",
    FontTracking->"Plain",
    FontColor->Automatic,
    Background->RGBColor[0.964706, 0.929412, 0.839216]],
  StyleBox["(",
    FontFamily->"Courier",
    FontWeight->"Plain",
    FontSlant->"Plain",
    FontTracking->"Plain",
    FontColor->Automatic,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FontVariations->{"Underline"->False}],
  StyleBox["Italic",
    FontFamily->"Courier",
    FontWeight->"Plain",
    FontSlant->"Italic",
    FontTracking->"Plain",
    FontColor->Automatic,
    Background->RGBColor[0.964706, 0.929412, 0.839216]],
  StyleBox[")",
    FontFamily->"Courier",
    FontWeight->"Plain",
    FontSlant->"Plain",
    FontTracking->"Plain",
    FontColor->Automatic,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FontVariations->{"Underline"->False}],
  StyleBox[", and ",
    FontFamily->"Times",
    FontWeight->"Plain",
    FontSlant->"Plain",
    FontTracking->"Plain",
    FontColor->Automatic,
    Background->RGBColor[0.964706, 0.929412, 0.839216]],
  StyleBox["U",
    FontFamily->"Times",
    FontWeight->"Plain",
    FontSlant->"Plain",
    FontTracking->"Plain",
    FontColor->Automatic,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FontVariations->{"Underline"->True}],
  StyleBox[" ",
    FontFamily->"Times",
    FontWeight->"Plain",
    FontSlant->"Plain",
    FontTracking->"Plain",
    FontColor->Automatic,
    Background->RGBColor[0.964706, 0.929412, 0.839216]],
  StyleBox["(",
    FontFamily->"Courier",
    FontWeight->"Plain",
    FontSlant->"Plain",
    FontTracking->"Plain",
    FontColor->Automatic,
    Background->RGBColor[0.964706, 0.929412, 0.839216]],
  StyleBox["Underline",
    FontFamily->"Courier",
    FontWeight->"Plain",
    FontSlant->"Plain",
    FontTracking->"Plain",
    FontColor->Automatic,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FontVariations->{"Underline"->True}],
  StyleBox[")",
    FontFamily->"Courier",
    FontWeight->"Plain",
    FontSlant->"Plain",
    FontTracking->"Plain",
    FontColor->Automatic,
    Background->RGBColor[0.964706, 0.929412, 0.839216]],
  " buttons change corresponding option of the selected text, but no other. \
The ",
  StyleBox["Plain",
    FontFamily->"Courier",
    FontSlant->"Plain"],
  " button turns these three options to \"",
  StyleBox["Plain",
    FontFamily->"Courier",
    FontSlant->"Plain"],
  "\", \"",
  StyleBox["Plain",
    FontFamily->"Courier",
    FontWeight->"Plain",
    FontSlant->"Plain",
    FontVariations->{"Underline"->False}],
  "\" and \"",
  StyleBox["False",
    FontFamily->"Courier",
    FontWeight->"Plain",
    FontSlant->"Plain",
    FontVariations->{"Underline"->False}],
  "\". \n\[FilledSmallSquare] The (*\[FilledSmallSquare]*), (\
\[FilledSmallSquare] ), {\[FilledSmallSquare] }, [\[FilledSmallSquare] ], \
\[LeftDoubleBracket]\[FilledSmallSquare]\[RightDoubleBracket] and \"\
\[FilledSmallSquare]\" buttons wrap parentheses, brackets or quotes around \
the selection, or inserts parentheses wrapping a placeholder. \n\
\[FilledSmallSquare] The \"\[FilledSmallSquare]\" button changes ",
  StyleBox["\"",
    FontFamily->"Courier",
    FontSlant->"Plain"],
  " and ",
  StyleBox["\\",
    FontFamily->"Courier",
    FontSlant->"Plain"],
  " inside the selected text to ",
  StyleBox["\\\"",
    FontFamily->"Courier",
    FontSlant->"Plain"],
  " and ",
  StyleBox["\\\\",
    FontFamily->"Courier",
    FontSlant->"Plain"],
  ", in accordance with the way ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " handles strings within strings. The \"",
  StyleBox["Peel",
    FontWeight->"Bold"],
  "\" button does the reverse transformation if it removes quotation marks of \
this kind.\n\[FilledSmallSquare] The font size buttons just change the font \
size of the selected text.\n\[FilledSmallSquare] The five font-change buttons \
",
  StyleBox["\"Courier\", \"",
    FontFamily->"Courier",
    FontSlant->"Plain"],
  StyleBox["Courier B",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  StyleBox["\", ",
    FontFamily->"Courier",
    FontSlant->"Plain"],
  StyleBox["\"Helvetica Plain\"",
    FontFamily->"Helvetica",
    FontSlant->"Plain"],
  StyleBox[", \"Times Plain\" and ",
    FontFamily->"Times",
    FontSlant->"Plain"],
  StyleBox["\"Times Italic\"",
    FontFamily->"Times",
    FontSlant->"Italic"],
  "  change font, slant and fontweight of the selected text, but not the \
Underline property. These font buttons are intended for the needs when \
writing help texts (like this).\n\[FilledSmallSquare]  The ",
  StyleBox["\"",
    FontWeight->"Plain",
    FontSlant->"Plain",
    FontVariations->{"Underline"->False}],
  StyleBox["Peel",
    FontWeight->"Bold"],
  StyleBox["\"",
    FontWeight->"Plain",
    FontSlant->"Plain",
    FontVariations->{"Underline"->False}],
  " button performs a number of different actions, one at a time, depending \
on the selection:\n    ",
  StyleBox["Peel",
    FontWeight->"Bold"],
  " removes the outer brackets or quotation marks from the selected text, and \
acts as an undo buton for the (*\[FilledSmallSquare]*), (\[FilledSmallSquare] \
), {\[FilledSmallSquare] }, [\[FilledSmallSquare] ], [[\[FilledSmallSquare] \
]] and \"\[FilledSmallSquare]\"  buttons. Also less common bracket types are \
supported. For square brackets [  ] also text preceeding the left bracket is \
removed, which means that ",
  StyleBox["2*Sin[x+y]",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  " will be reduced to ",
  StyleBox["x+y",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  ". The text preceeding the left bracket should not contain any formatting \
box of type ",
  StyleBox["SqrtBox ",
    FontFamily->"Courier",
    FontSlant->"Plain"],
  "or similar. \n    If there are leading or trailing space characters, these \
are removed.\n    Trailing operators and punctuation marks are removed, one \
at a time. If the leading characters represents the same operator or \
punctuation mark as the trailing characters, they are also removed\n    If \
the selection is a single box expression of the SqrtBox type or similar, it \
is reduced to Input Form. ",
  Cell[BoxData[
      StyleBox[\(\@\(\@\(x + 2\)\)\),
        FontFamily->"Courier",
        FontWeight->"Bold",
        FontSlant->"Plain"]]],
  " is transformed into ",
  Cell[BoxData[
      StyleBox[\(Sqrt[Sqrt[x\  + \ 2]]\),
        FontWeight->"Bold"]]],
  "\n    If the selection is a whole cell, selected by the cell bracket, the \
cell is converted to a text cell. Box expressions are kept.\n    Multiple \
cell selections are converted to one Text cell with the selected cells \
embedded. Next click on Peel will unpack the embedded cells (except graphic \
cells) and transform them into text.\n    Two\[Hyphen]dimensional input of \
the type ",
  StyleBox["\\!\\(x\\^y\\)",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  Cell[BoxData[
      RowBox[{" ", 
        StyleBox[\(\(is\)\(\ \)\(converted\)\(\ \)\),
          FontFamily->"Times",
          FontSlant->"Plain"]}]], "Text"],
  "to one -dimensional input inside parentheses: ",
  StyleBox["(x^y)",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  ". Two\[Hyphen]dimensional input of the type ",
  StyleBox["\\(x\\^y\\)",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  Cell[BoxData[
      RowBox[{" ", 
        StyleBox[\(\(is\)\(\ \)\(converted\)\(\ \)\),
          FontFamily->"Times",
          FontSlant->"Plain"]}]], "Text"],
  "to one -dimensional input inside string delimiters: ",
  StyleBox["\"x^y\"",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  ". \n    Peel applied to a GraphicsData cell displays the PostScript code \
in a way that is posssible to reload. Embedded GraphicsData cells are left \
unchanged.\n    Peel applied to a Graphics3D cell or a SurfaceGraphics cell \
rendered as RealTime3D graphics displays the code in a way that is posssible \
to reload. Embedded such cells are left unchanged. For more information about \
RealTime3D graphics start looking at  ",
  ButtonBox["http://forums.wolfram.com/mathgroup/archive/2001/Apr/msg00346.\
html",
    ButtonData:>{
      URL[ 
      "http://forums.wolfram.com/mathgroup/archive/2001/Apr/msg00346.html"], 
      None},
    ButtonStyle->"Hyperlink"],
  ".\n\[FilledSmallSquare]  The ",
  StyleBox["\"",
    FontWeight->"Plain",
    FontSlant->"Plain",
    FontVariations->{"Underline"->False}],
  StyleBox["StyleRemove",
    FontWeight->"Bold"],
  StyleBox["\"",
    FontWeight->"Plain",
    FontSlant->"Plain",
    FontVariations->{"Underline"->False}],
  " button removes Style formatting of the selection, in a way similar to the \
",
  StyleBox["\"Remove Options...\" ",
    FontFamily->"Helvetica",
    FontWeight->"Plain",
    FontSlant->"Plain"],
  "menu item or the ",
  StyleBox["CopyAsInputFormK",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  " button, but will not",
  StyleBox[" change 2D mathematical expressions to Input Form, and will not \
turn spaces into multiplication signs. Due to the structure of Mathematica e",
    
    FontFamily->"Times New Roman"],
  "xpressions, the SetOptions command, utilizes by the buttons in this \
palette, does not always manage to change options further down in the tree \
structure representing the expression, so therefore the buttons will not work \
correctly if the expressions are too cluttered. Then it might be possible to \
clean up by using this button. Alternatively, the ",
  StyleBox["CopyAsInputFormK",
    FontWeight->"Bold"],
  " button might be used to convert the expression into InputForm. Then this \
expression might be pasted back. The button calls the ",
  StyleBox["\"Remove Options...\" ",
    FontFamily->"Helvetica",
    FontWeight->"Plain",
    FontSlant->"Plain"],
  "menu item for multiple cell selections or for selections that contain an \
InterpretationBox. The ",
  StyleBox["Peel",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  " button and the ",
  StyleBox["StyleRemove ",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  "button are based on similar mechanisms.\n\[FilledSmallSquare] The \"",
  StyleBox["Search",
    FontWeight->"Bold"],
  "\" button searches for information in the ",
  ButtonBox["online Mathematica help",
    ButtonData:>{
      URL[ "http://documents.wolfram.com/mathematica/book/"], None},
    ButtonStyle->"Hyperlink"],
  ". Words are extracted from the selection and are then used to perform a \
Google search. Words are any letter-digit combination except pure numbers and \
one-letter strings. Duplicate words are ignores. \n\[FilledSmallSquare] The \
\"",
  StyleBox["MG",
    FontWeight->"Bold"],
  "\" button searches in the same way in the ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " forums (especially ",
  ButtonBox["MathGroup",
    ButtonData:>{
      URL[ "http://forums.wolfram.com/mathgroup/"], None},
    ButtonStyle->"Hyperlink"],
  ") for information. Also ",
  ButtonBox["Wiki-webMathematica",
    ButtonData:>{
      URL[ 
      "http://www.mathematica-users.org/webMathematica/wiki/wiki.jsp?pageName=\
Main_Page"], None},
    ButtonStyle->"Hyperlink"],
  " is searched. \n\[FilledSmallSquare] The \"",
  StyleBox["Web",
    FontWeight->"Bold"],
  "\" button makes an unrestricted Google search for the selected words. This \
is especially useful if you have installed Google Desktop search with the ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " notebook plug-in on your computer: then you can search your own notebooks \
for the selected words.\n\[FilledSmallSquare] The nine buttons with the text \
\"BACKGROUND\" change the background color to that indicated. \n\
\[FilledSmallSquare] The \"",
  StyleBox["Get Font Options",
    FontFamily->"Helvetica",
    FontSlant->"Plain"],
  "\" button reads the font options ",
  StyleBox["FontColor",
    FontFamily->"Courier",
    FontSlant->"Plain"],
  ", ",
  StyleBox["FontFamily",
    FontFamily->"Courier",
    FontSlant->"Plain"],
  ", ",
  StyleBox["FontProperties",
    FontFamily->"Courier",
    FontSlant->"Plain"],
  ", ",
  StyleBox["FontSize",
    FontFamily->"Courier",
    FontSlant->"Plain"],
  ", ",
  StyleBox["FontSlant",
    FontFamily->"Courier",
    FontSlant->"Plain"],
  ", ",
  StyleBox["FontTracking",
    FontFamily->"Courier",
    FontSlant->"Plain"],
  ", ",
  StyleBox["FontVariations",
    FontFamily->"Courier",
    FontSlant->"Plain"],
  ", ",
  StyleBox["FontWeight",
    FontFamily->"Courier",
    FontSlant->"Plain"],
  " and ",
  StyleBox["Background",
    FontFamily->"Courier",
    FontSlant->"Plain"],
  " into the variable ",
  StyleBox["$FontPaintOptions",
    FontFamily->"Courier",
    FontSlant->"Plain"],
  " from the selection. You might manually edit the settings for this \
variable to fit special needs and also add other options.\n\
\[FilledSmallSquare] The \"",
  StyleBox["Paint Font Options",
    FontFamily->"Helvetica",
    FontSize->12,
    FontWeight->"Plain",
    FontSlant->"Plain",
    FontTracking->"Plain",
    FontColor->Automatic,
    Background->RGBColor[0.964706, 0.929412, 0.839216],
    FontVariations->{"Underline"->False,
    "Outline"->False,
    "Shadow"->False,
    "StrikeThrough"->False,
    "Masked"->False,
    "CompatibilityType"->"Normal",
    "RotationAngle"->0},
    FontProperties->{"FontSerifed"->Automatic,
    "FontMonospaced"->Automatic}],
  "\" button sets these options for the selections. These buttons are thus \
analogous to the Format Painter feature in Microsoft Word. If the \"",
  StyleBox["Get Font Options",
    FontFamily->"Helvetica",
    FontSlant->"Plain"],
  "\" has not been pressed first, the \"",
  StyleBox["Paint Font Options",
    FontFamily->"Helvetica",
    FontSlant->"Plain"],
  "\" button will act as this button the first time it is pressed. The font \
and background of the button will reflect the settings of the variable ",
  StyleBox["$FontPaintOptions",
    FontFamily->"Courier",
    FontSlant->"Plain"],
  ", except for the font size.  "
}], "Usage"],

Cell[TextData[{
  "\[FilledSmallSquare] The \"",
  StyleBox["CopyAsInputFormK",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  "\" , \"",
  StyleBox["*\[Rule]\[SpaceIndicator]",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  "\", \"",
  StyleBox["\[FilledSmallSquare], \[FilledSmallSquare]",
    FontFamily->"Helvetica",
    FontSlant->"Plain"],
  "\", \"\[FilledSmallSquare]\" , \"",
  StyleBox["Peel",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  "\",  \"",
  StyleBox["StyleRemove",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  "\",  \"",
  StyleBox["MG",
    FontWeight->"Bold"],
  "\",  \"",
  StyleBox["Search",
    FontWeight->"Bold"],
  "\", \"",
  StyleBox["Web",
    FontWeight->"Bold"],
  "\",\"",
  StyleBox["Get Font Options",
    FontFamily->"Helvetica",
    FontSlant->"Plain"],
  "\" and \"",
  StyleBox["Paint Font Options",
    FontFamily->"Helvetica",
    FontSlant->"Plain"],
  "\" buttons use the kernel for the evaluation. The other buttons use the \
FrontEnd."
}], "Notes"],

Cell[TextData[{
  "\[FilledSmallSquare] The \"",
  StyleBox["CopyAsInputForm",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  "\" button can be very useful when copying from Help."
}], "Notes"],

Cell[TextData[{
  "\[FilledSmallSquare] The \"",
  StyleBox["CopyAsInputForm",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  "\" button can turn PostScript graphics into ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " Graphics, as a set of 2D lines, polygons and text. The button uses the \
ImportString[psstring,\"APS\"] command for that purpose, but unlike this \
command the button is at least in some cases able to recover the original \
coordinates. This mechanism is destroyed if the PlotRange is set to Automatic \
and there is text at the borders. The button also cannot handle the insertion \
point of text in a proper way in some cases. The command can become slow for \
complicated figures. For sound cells, the \"Convert to InputForm\" mechanism \
is used to convert the cell into a reloadable Input cell."
}], "Notes"],

Cell[TextData[{
  "\[FilledSmallSquare] ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " internally can represent text in two ways, as TextData or as BoxData. The \
",
  StyleBox["\"",
    FontWeight->"Plain",
    FontSlant->"Plain",
    FontVariations->{"Underline"->False}],
  StyleBox["StyleRemove",
    FontWeight->"Bold"],
  StyleBox["\"",
    FontWeight->"Plain",
    FontSlant->"Plain",
    FontVariations->{"Underline"->False}],
  " button try to transform as much as possible to the TextData \
representation before writing it back. This tranformation is not easy to \
accomplish by using the supplied menu commands. If you convert a cell from \
style \"Input\" to style \"Text\", the result is not always satisfying. Try \
then to apply",
  StyleBox[" ",
    FontFamily->"Times",
    FontSlant->"Plain"],
  StyleBox["\"",
    FontFamily->"Times",
    FontWeight->"Plain",
    FontSlant->"Plain",
    FontVariations->{"Underline"->False}],
  StyleBox["StyleRemove",
    FontFamily->"Times",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  StyleBox["\".",
    FontFamily->"Times",
    FontWeight->"Plain",
    FontSlant->"Plain",
    FontVariations->{"Underline"->False}],
  StyleBox[" ",
    FontFamily->"Times",
    FontSlant->"Plain"]
}], "Notes"],

Cell["\<\
\[FilledSmallSquare] The buttons for adding and removing brackets do not \
perform any balance check. Use Shift-Ctrl-B to perform balance check.\
\>", "Notes"],

Cell[TextData[{
  "\[FilledSmallSquare] Remember to save often. ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " might crash, and please do not blame me. Face and font changes applied to \
unbalanced expressions probably increase the crash risk."
}], "Notes"],

Cell[TextData[{
  "\[FilledSmallSquare] If you want to reposition the opening position of the \
palette, change the properties of the file SetFaceAndFont2.nb from read-only. \
Open ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  ", reposition the palette and close ",
  StyleBox["Mathematica",
    FontSlant->"Italic"],
  " again, without using the GetFontOptions or PaintFontOptions buttons. \
Change the properties of the file SetFaceAndFont2.nb back to read-only again.\
\n\[FilledSmallSquare] ",
  StyleBox["Credits:",
    FontSlant->"Italic"],
  " A similar button as mine, CopyAsInputForm, was initially written by Omega \
Consulting, ",
  ButtonBox["http://omegaconsultinggroup.com/",
    ButtonData:>{
      URL[ "http://omegaconsultinggroup.com/"], None},
    ButtonStyle->"Hyperlink"],
  ", presented in the MathGroup message mg34943 in June 2002. The code has \
here been completely rewritten as a Kernel command, to enable tailoring in \
special cases. It avoids leaving a variable cpynb defined, and has better \
behaviour together with TextData and GraphicData.\n  The font size buttons \
are inspired by the FormattingTools palette (from an early version of \
Publicon?), but do not work in exactly the same way. (For me the \
FormattingTools palette only works on the first character in the selection)\n \
  The parentheses buttons were suggested by DrBob but the idea has appeared \
earlier in MathGroup. The text color buttons were created by Murray \
Eisenberg, who also have provided many good suggestions."
}], "Notes"],

Cell[TextData[{
  "\[FilledSmallSquare] ",
  StyleBox["Version 2.0.4,",
    FontSlant->"Italic"],
  " ",
  StyleBox["created 2005-09-13 ",
    FontFamily->"Times",
    FontSlant->"Italic"]
}], "Notes"],

Cell[TextData[{
  "If you have any comments or suggestions, please email them. Or, if you \
just find the palette useful and want to get informed about updates, send an \
email telling just this.\nIngolf Dahl, Sweden\ningolf.dahl@telia.com \nWeb \
page for updates: ",
  ButtonBox["http://web.telia.com/~u31815170/Mathematica",
    ButtonData:>{
      URL[ "http://web.telia.com/~u31815170/Mathematica"], None},
    ButtonStyle->"Hyperlink"]
}], "Notes"],

Cell["\[Copyright]  IngolfDahl, Sweden 2005\[IndentingNewLine]", "Text"]
}, Open  ]]
},
FrontEndVersion->"5.1 for Microsoft Windows",
ScreenRectangle->{{0, 1280}, {0, 933}},
Editable->True,
ScreenStyleEnvironment->"Brackets",
WindowToolbars->{},
Selectable->True,
WindowSize->{790, 884},
WindowMargins->{{Automatic, 66}, {Automatic, -1}},
WindowClickSelect->True,
IndexCreationOptions->{"Format"->"Hyperlinks"},
TaggingRules:>{"NextIndexingNumber" -> 3, "IndexEntries" -> {{"i:1", \
"ExpressionToTaggedCell"}, {"i:2", "ExpressionToTaggedCell"}}},
CellLabelAutoDelete->True,
Background->GrayLevel[1],
Magnification->1,
StyleDefinitions -> "HelpBrowser.nb"
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 45, 0, 41, "ObjectName"],
Cell[1824, 55, 40, 0, 33, "Usage"],
Cell[1867, 57, 71, 1, 29, "Input"],
Cell[1941, 60, 17966, 525, 1195, "Usage"],
Cell[19910, 587, 1124, 44, 43, "Notes"],
Cell[21037, 633, 224, 7, 26, "Notes"],
Cell[21264, 642, 874, 17, 94, "Notes"],
Cell[22141, 661, 1271, 41, 59, "Notes"],
Cell[23415, 704, 169, 3, 25, "Notes"],
Cell[23587, 709, 269, 6, 42, "Notes"],
Cell[23859, 717, 1549, 30, 196, "Notes"],
Cell[25411, 749, 201, 8, 25, "Notes"],
Cell[25615, 759, 454, 9, 111, "Notes"],
Cell[26072, 770, 72, 0, 25, "Text"]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

