(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.1'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    250392,       4705]*)
(*NotebookOutlinePosition[    251730,       4755]*)
(*  CellTagsIndexPosition[    251651,       4749]*)
(*WindowFrame->Palette*)



Notebook[{
Cell[BoxData[GridBox[{
        {GridBox[{
              {
                ButtonBox[
                  StyleBox["CopyAsInputFormK",
                    FontFamily->"Courier",
                    FontSize->11,
                    FontWeight->"Bold",
                    FontColor->GrayLevel[0]],
                  ButtonFunction:>Module[ {readitem, tws}, 
                      CompoundExpression[ 
                        Set[ readitem, 
                          NotebookRead[ 
                            InputNotebook[ ]]], 
                        Catch[ 
                          CompoundExpression[ 
                            Which[ 
                              SameQ[ readitem, {}], 
                              Throw[ Null], 
                              UnsameQ[ 
                                Cases[ readitem, 
                                  FormBox[ 
                                    BoxData[ 
                                      BlankNullSequence[ ]], 
                                    BlankNullSequence[ ]]], {}], 
                              Throw[ Null], 
                              ListQ[ readitem], 
                              If[ 
                                UnsameQ[ 
                                  ReplaceAll[ "CursorPosition", 
                                    Flatten[ 
                                      CompoundExpression[ 
                                        LinkWrite[ $ParentLink, 
                                        CellInformation[ 
                                        InputNotebook[ ]]], 
                                        LinkRead[ $ParentLink]]]], 
                                  "CellBracket"], 
                                Set[ readitem, 
                                  Cell[ 
                                    TextData[ readitem], "Input", 
                                    ShowSpecialCharacters -> False]]], 
                              MatchQ[ readitem, 
                                Alternatives[ 
                                  BoxData[ 
                                    Blank[ Graphics3D]], 
                                  BoxData[ 
                                    Blank[ SurfaceGraphics]], 
                                  Blank[ GraphicsData]]], 
                              CompoundExpression[ 
                                SelectionMove[ 
                                  InputNotebook[ ], All, Cell], 
                                Set[ readitem, 
                                  NotebookRead[ 
                                    InputNotebook[ ]]]]], 
                            If[ 
                              StringQ[ readitem], 
                              Set[ readitem, 
                                Cell[ 
                                  TextData[ {readitem}], "Input", 
                                  ShowSpecialCharacters -> False]]], 
                            Set[ readitem, 
                              ReplaceRepeated[ 
                                ReplaceAll[ readitem, {TextData[ 
                                    Pattern[ a, 
                                      Blank[ String]]] :> TextData[ {a}], 
                                  Cell[ 
                                    Pattern[ a, 
                                      Blank[ String]], 
                                    BlankNullSequence[ ]] :> Cell[ 
                                    TextData[ {a}], "Input", 
                                    ShowSpecialCharacters -> False], 
                                  Condition[ 
                                    BoxData[ 
                                      Pattern[ x, 
                                        Blank[ ]]], 
                                    And[ 
                                      UnsameQ[ 
                                        Head[ x], List], 
                                      UnsameQ[ 
                                        Head[ x], Graphics3D], 
                                      UnsameQ[ 
                                        Head[ x], SurfaceGraphics]]] :> 
                                  BoxData[ {x}]}], {TextData[ {
                                  Pattern[ a1, 
                                    BlankNullSequence[ ]], 
                                  Pattern[ b1, 
                                    Blank[ ButtonBox]], 
                                  Pattern[ c1, 
                                    BlankNullSequence[ ]]}] :> 
                                TextData[ {a1, 
                                  Cell[ 
                                    BoxData[ {b1}], "Input"], c1}]}]], 
                            Set[ readitem, 
                              ReplaceAll[ readitem, {RowBox[ {"(*", 
                                  Pattern[ a1, 
                                    BlankNullSequence[ ]], "*)"}] :> 
                                RowBox[ {
                                  RowBox[ {"Comment", "[", 
                                    FromCharacterCode[ 34], 
                                    Apply[ Sequence, 
                                      ReplaceAll[ {a1}, {Pattern[ x, 
                                        Blank[ String]] :> StringReplace[ 
                                        x, {FromCharacterCode[ 34] -> "\\\"", 
                                        "\\" -> "\\\\"}]}]], 
                                    FromCharacterCode[ 34], "]"}], ";"}]}]], 
                            Set[ readitem, 
                              ReplaceAll[ readitem, {Cell[ 
                                  BoxData[ 
                                    Pattern[ a1, 
                                      Alternatives[ 
                                        Blank[ Graphics3D], 
                                        Blank[ SurfaceGraphics]]]], 
                                  Pattern[ a2, 
                                    BlankNullSequence[ ]]] :> Cell[ 
                                  BoxData[ 
                                    RowBox[ {"NotebookWrite", "[", 
                                      RowBox[ {
                                        RowBox[ {"InputNotebook", "[", "]"}], 
                                        ",", 
                                        ToBoxes[ 
                                        FullForm[ 
                                        Cell[ 
                                        BoxData[ a1], a2]]]}], "]"}]], 
                                  "Input"]}]], 
                            Set[ readitem, 
                              ReplaceAll[ readitem, {BoxData[ {
                                  Pattern[ a1, 
                                    BlankNullSequence[ ]], 
                                  "\[IndentingNewLine]", 
                                  Pattern[ b1, 
                                    BlankNullSequence[ ]]}] :> ReplaceAll[ 
                                  BoxData[ {
                                    
                                    RowBox[ {a1, "\[IndentingNewLine]", 
                                      b1}]}], {"\[IndentingNewLine]" -> 
                                  "\n"}]}]], 
                            Set[ readitem, 
                              ReplaceAll[ readitem, {Condition[ 
                                  BoxData[ {
                                    Pattern[ a1, 
                                      Blank[ ]], 
                                    Pattern[ b1, 
                                      BlankNullSequence[ ]], 
                                    Pattern[ c1, 
                                      Blank[ ]], 
                                    Pattern[ d1, 
                                      BlankNullSequence[ ]]}], 
                                  And[ 
                                    Not[ 
                                      MemberQ[ {b1}, "\n"]], 
                                    Not[ 
                                      MemberQ[ {b1}, "\[IndentingNewLine]"]], 
                                    
                                    MemberQ[ {"\n", "\[IndentingNewLine]"}, 
                                      c1]]] :> BoxData[ {
                                  RowBox[ {a1, 
                                    Apply[ Sequence, 
                                      Map[ 
                                      Apply[ Sequence, {"\n", #}]&, {b1}]], 
                                    c1, d1}]}], BoxData[ {
                                  Pattern[ a1, 
                                    Blank[ ]], 
                                  Pattern[ b1, 
                                    BlankSequence[ ]]}] :> BoxData[ {
                                  RowBox[ {a1, 
                                    Apply[ Sequence, 
                                      Map[ 
                                      Apply[ Sequence, {"\n", #}]&, {
                                        b1}]]}]}], BoxData[ {
                                  RowBox[ 
                                    Pattern[ a1, 
                                      BlankSequence[ ]]]}] :> BoxData[ {
                                  RowBox[ a1]}], BoxData[ {
                                  Pattern[ a1, 
                                    Blank[ ]]}] :> BoxData[ {
                                  RowBox[ {a1}]}]}]], 
                            Set[ readitem, 
                              ReplaceRepeated[ 
                                ReplaceRepeated[ 
                                  ReplaceRepeated[ readitem, {StyleBox[ 
                                      Pattern[ a1, 
                                        Blank[ ]], 
                                      BlankNullSequence[ ]] :> a1, FormBox[ 
                                      Pattern[ a1, 
                                        Blank[ List]], 
                                      Pattern[ b1, 
                                        Blank[ ]]] :> RowBox[ a1], FormBox[ 
                                      Pattern[ a1, 
                                        BlankSequence[ ]], 
                                      Pattern[ b1, 
                                        Blank[ ]]] :> RowBox[ {a1}]}], {
                                  Condition[ 
                                    RowBox[ {
                                      Pattern[ g1, 
                                        Blank[ ]], 
                                      Pattern[ g2, 
                                        BlankNullSequence[ ]]}], 
                                    Not[ 
                                      
                                      MemberQ[ {String, List, RowBox, 
                                        FormBox}, 
                                        Head[ g1]]]] :> Block[ {
                                    Set[ $Messages, {}]}, 
                                    Check[ 
                                      StringDrop[ 
                                        StringDrop[ 
                                        ToString[ 
                                        InputForm[ 
                                        FullForm[ 
                                        ToExpression[ 
                                        StringJoin[ "\!", 
                                        ToString[ 
                                        RowBox[ {"HoldComplete", "[", 
                                        RowBox[ {g1, g2}], "]"}], 
                                        InputForm]]]]]], 22], -2], 
                                      RowBox[ {g1, g2}]]]}], {RowBox[ {
                                  Pattern[ g1, 
                                    BlankNullSequence[ ]], {
                                  Pattern[ g2, 
                                    Blank[ ]]}, 
                                  Pattern[ g3, 
                                    BlankNullSequence[ ]]}] :> 
                                RowBox[ {g1, g2, g3}]}]], 
                            Set[ readitem, 
                              ReplaceRepeated[ readitem, {RowBox[ {
                                  Pattern[ c1, 
                                    BlankNullSequence[ ]], 
                                  Pattern[ a1, 
                                    Blank[ String]], 
                                  Pattern[ b1, 
                                    Blank[ String]], 
                                  Pattern[ d1, 
                                    BlankNullSequence[ ]]}] :> RowBox[ {c1, 
                                  StringJoin[ a1, b1], d1}], BoxData[ {
                                  Pattern[ a1, 
                                    Blank[ String]]}] :> TextData[ {a1}]}]], 
                            Set[ readitem, 
                              ReplaceRepeated[ readitem, {BoxData[ {
                                  Pattern[ x, 
                                    Blank[ ]]}, 
                                  BlankNullSequence[ ]] :> Block[ {
                                  Set[ $Messages, {}]}, 
                                  Check[ 
                                    TextData[ {
                                      StringDrop[ 
                                        StringDrop[ 
                                        ToString[ 
                                        InputForm[ 
                                        FullForm[ 
                                        ToExpression[ 
                                        StringJoin[ "\!", 
                                        ToString[ 
                                        
                                        RowBox[ {"HoldComplete", "[", x, 
                                        "]"}], InputForm]]]]]], 22], -2]}], 
                                    ReplaceRepeated[ 
                                      ReplaceRepeated[ 
                                        ReplaceRepeated[ 
                                        BoxData[ {x}], {(Condition[ 
                                        Pattern[ x1, 
                                        Blank[ ]], 
                                        MemberQ[ {FontColor, FontFamily, 
                                        FontProperties, FontSize, FontSlant, 
                                        FontTracking, FontVariations, 
                                        FontWeight, Background}, x1]] -> 
                                        Blank[ ]) :> Sequence[ ], StyleBox[ 
                                        Pattern[ l1, 
                                        Blank[ ]], 
                                        BlankNullSequence[ ]] :> l1, 
                                        RowBox[ {
                                        Pattern[ c1, 
                                        BlankNullSequence[ ]], 
                                        Pattern[ a1, 
                                        Blank[ String]], 
                                        Pattern[ b1, 
                                        Blank[ String]], 
                                        Pattern[ d1, 
                                        BlankNullSequence[ ]]}] :> 
                                        RowBox[ {c1, 
                                        StringJoin[ a1, b1], d1}], RowBox[ {
                                        Pattern[ a1, 
                                        BlankNullSequence[ ]], 
                                        RowBox[ {
                                        Pattern[ b1, 
                                        BlankNullSequence[ ]]}], 
                                        Pattern[ c1, 
                                        BlankNullSequence[ ]]}] :> 
                                        RowBox[ {a1, " ", b1, c1}], BoxData[ 
                                        Pattern[ a1, 
                                        Blank[ String]]] :> TextData[ {a1}], 
                                        ButtonBox[ 
                                        Pattern[ a1, 
                                        BlankSequence[ ]]] :> Button[ a1], 
                                        FrameBox[ 
                                        Pattern[ a1, 
                                        Blank[ ]], 
                                        Blank[ ]] :> a1, FormBox[ 
                                        Pattern[ a1, 
                                        Blank[ List]], 
                                        Pattern[ b1, 
                                        Blank[ ]]] :> RowBox[ a1], FormBox[ 
                                        Pattern[ a1, 
                                        BlankSequence[ ]], 
                                        Pattern[ b1, 
                                        Blank[ ]]] :> RowBox[ {a1}], 
                                        GridBox[ {
                                        Pattern[ a1, 
                                        BlankNullSequence[ ]], {
                                        Pattern[ c1, 
                                        BlankNullSequence[ ]], {
                                        Pattern[ d1, 
                                        BlankNullSequence[ ]]}, 
                                        Pattern[ e1, 
                                        BlankNullSequence[ ]]}, 
                                        Pattern[ b1, 
                                        BlankNullSequence[ ]]}, 
                                        Pattern[ f1, 
                                        BlankNullSequence[ ]]] :> 
                                        GridBox[ {a1, {c1, 
                                        RowBox[ {d1}], e1}, b1}, f1]}], {
                                        BoxData[ {
                                        RowBox[ 
                                        Pattern[ a1, 
                                        Blank[ List]]]}] :> TextData[ 
                                        Map[ Cell[ 
                                        BoxData[ {#}], "Text"]&, a1]]}], {
                                      TextData[ {
                                        Pattern[ b1, 
                                        BlankNullSequence[ ]], 
                                        Cell[ 
                                        BoxData[ {
                                        Pattern[ a1, 
                                        Blank[ String]]}], 
                                        BlankNullSequence[ ]], 
                                        Pattern[ c1, 
                                        BlankNullSequence[ ]]}] :> 
                                      TextData[ {b1, a1, c1}], TextData[ 
                                        Cell[ 
                                        BoxData[ {
                                        Pattern[ a1, 
                                        Blank[ String]]}], 
                                        BlankNullSequence[ ]]] :> 
                                      TextData[ {a1}]}]]]}]], 
                            Set[ readitem, 
                              ReplaceRepeated[ readitem, {BoxData[ {
                                  Pattern[ x, 
                                    Blank[ ]]}, 
                                  BlankNullSequence[ ]] :> TextData[ {
                                  ToString[ 
                                    ReplacePart[ x, 
                                      ReplaceAll[ 
                                        Extract[ x, 
                                        Position[ x, 
                                        Blank[ String]]], {Pattern[ a1, 
                                        Blank[ String]] :> StringJoin[ "\"", 
                                        StringReplace[ 
                                        a1, {FromCharacterCode[ 34] -> "\\\"",
                                         "\\" -> "\\\\"}], "\""]}], 
                                      Position[ x, 
                                        Blank[ String]], 
                                      Transpose[ {
                                        Range[ 
                                        Length[ 
                                        Position[ x, 
                                        Blank[ String]]]]}]]]}]}]], 
                            Set[ readitem, 
                              ReplaceAll[ readitem, {Cell[ 
                                  GraphicsData[ "PostScript", 
                                    Pattern[ psstring, 
                                      Blank[ String]]], "Graphics", 
                                  Pattern[ opts, 
                                    BlankNullSequence[ ]]] :> 
                                Module[ {cpynb, scale, aspectratio, graph, 
                                  xmin, xmax, ymin, ymax}, 
                                  If[ 
                                    GreaterEqual[ 
                                      StringCount[ psstring, "sampledsound"], 
                                      1], 
                                    CompoundExpression[ 
                                      Set[ cpynb, 
                                        NotebookCreate[ 
                                        Visible -> False, WindowTitle -> 
                                        "Palette Scrap"]], 
                                      NotebookWrite[ cpynb, 
                                        Cell[ 
                                        GraphicsData[ "PostScript", psstring],
                                         "Graphics", opts]], 
                                      SelectionMove[ cpynb, All, Notebook], 
                                      FrontEndExecute[ 
                                        FrontEndToken[ 
                                        cpynb, "SelectionConvert", 
                                        "InputForm"]], 
                                      SelectionMove[ cpynb, All, Notebook], 
                                      Set[ graph, 
                                        NotebookRead[ cpynb]], 
                                      NotebookClose[ cpynb], 
                                      Cell[ 
                                        Part[ graph, 1], "Input"]], 
                                    CompoundExpression[ 
                                      Set[ scale, 
                                        Flatten[ 
                                        StringCases[ 
                                        psstring, StringExpression[ 
                                        "% Scaling calculations\n", 
                                        Pattern[ s1, 
                                        Repeated[ 
                                        Characters[ "1234567890+-e. "]]]] :> 
                                        ImportString[ s1, "List"]]]], 
                                      If[ 
                                        Unequal[ 
                                        Length[ scale], 4], 
                                        Set[ scale, {0, 1, 0, 1}]], 
                                      Set[ aspectratio, 
                                        StringCases[ 
                                        psstring, StringExpression[ 
                                        "%%AspectRatio: ", 
                                        Pattern[ s1, NumberString]] :> 
                                        ToExpression[ s1]]], 
                                      Set[ aspectratio, 
                                        If[ 
                                        MatchQ[ aspectratio, {
                                        Alternatives[ 
                                        Blank[ Integer], 
                                        Blank[ Real]]}], 
                                        Part[ aspectratio, 1], 
                                        Times[ 1, 
                                        Power[ GoldenRatio, -1]], 
                                        Times[ 1, 
                                        Power[ GoldenRatio, -1]]]], 
                                      Set[ xmin, 
                                        Times[ 
                                        Times[ -1, 
                                        Part[ scale, 1]], 
                                        Power[ 
                                        Part[ scale, 2], -1]]], 
                                      Set[ xmax, 
                                        Times[ 
                                        Plus[ 1, 
                                        Times[ -1, 
                                        Part[ scale, 1]]], 
                                        Power[ 
                                        Part[ scale, 2], -1]]], 
                                      Set[ ymin, 
                                        Times[ 
                                        Times[ -1, 
                                        Part[ scale, 3]], 
                                        Power[ 
                                        Part[ scale, 4], -1]]], 
                                      Set[ ymax, 
                                        Times[ 
                                        Plus[ aspectratio, 
                                        Times[ -1, 
                                        Part[ scale, 3]]], 
                                        Power[ 
                                        Part[ scale, 4], -1]]], 
                                      Set[ graph, 
                                        ReplaceAll[ 
                                        ImportString[ psstring, "APS"], {
                                        Point[ 
                                        Pattern[ a, 
                                        Blank[ ]]] :> Point[ 
                                        ReplaceAll[ a, {{
                                        PatternTest[ 
                                        Pattern[ a1, 
                                        Blank[ ]], NumberQ], 
                                        PatternTest[ 
                                        Pattern[ b1, 
                                        Blank[ ]], NumberQ]} :> {
                                        Times[ 
                                        Plus[ 
                                        Times[ a1, 
                                        Power[ 288, -1]], 
                                        Times[ -1, 
                                        Part[ scale, 1]]], 
                                        Power[ 
                                        Part[ scale, 2], -1]], 
                                        Times[ 
                                        Plus[ 
                                        Times[ b1, 
                                        Power[ 288, -1]], 
                                        Times[ -1, 
                                        Part[ scale, 3]], 
                                        Times[ -1, 
                                        Times[ 
                                        Plus[ 1, 
                                        Times[ -1, aspectratio]], 
                                        Power[ 2, -1]]]], 
                                        Power[ 
                                        Part[ scale, 4], -1]]}}]], Line[ 
                                        Pattern[ a, 
                                        Blank[ ]]] :> Line[ 
                                        ReplaceAll[ a, {{
                                        PatternTest[ 
                                        Pattern[ a1, 
                                        Blank[ ]], NumberQ], 
                                        PatternTest[ 
                                        Pattern[ b1, 
                                        Blank[ ]], NumberQ]} :> {
                                        Times[ 
                                        Plus[ 
                                        Times[ a1, 
                                        Power[ 288, -1]], 
                                        Times[ -1, 
                                        Part[ scale, 1]]], 
                                        Power[ 
                                        Part[ scale, 2], -1]], 
                                        Times[ 
                                        Plus[ 
                                        Times[ b1, 
                                        Power[ 288, -1]], 
                                        Times[ -1, 
                                        Part[ scale, 3]], 
                                        Times[ -1, 
                                        Times[ 
                                        Plus[ 1, 
                                        Times[ -1, aspectratio]], 
                                        Power[ 2, -1]]]], 
                                        Power[ 
                                        Part[ scale, 4], -1]]}}]], Polygon[ 
                                        Pattern[ a, 
                                        Blank[ ]]] :> Polygon[ 
                                        ReplaceAll[ a, {{
                                        PatternTest[ 
                                        Pattern[ a1, 
                                        Blank[ ]], NumberQ], 
                                        PatternTest[ 
                                        Pattern[ b1, 
                                        Blank[ ]], NumberQ]} :> {
                                        Times[ 
                                        Plus[ 
                                        Times[ a1, 
                                        Power[ 288, -1]], 
                                        Times[ -1, 
                                        Part[ scale, 1]]], 
                                        Power[ 
                                        Part[ scale, 2], -1]], 
                                        Times[ 
                                        Plus[ 
                                        Times[ b1, 
                                        Power[ 288, -1]], 
                                        Times[ -1, 
                                        Part[ scale, 3]], 
                                        Times[ -1, 
                                        Times[ 
                                        Plus[ 1, 
                                        Times[ -1, aspectratio]], 
                                        Power[ 2, -1]]]], 
                                        Power[ 
                                        Part[ scale, 4], -1]]}}]], Text[ 
                                        Pattern[ a, 
                                        Blank[ ]], {
                                        Pattern[ a1, 
                                        Blank[ ]], 
                                        Pattern[ b1, 
                                        Blank[ ]]}, 
                                        Pattern[ c, 
                                        BlankNullSequence[ ]]] :> Part[ 
                                        Join[ 
                                        Cases[ 
                                        FullForm[ 
                                        ImportString[ 
                                        DisplayString[ 
                                        Graphics[ {
                                        Line[ {{0, 0}, {1, 1}}], 
                                        Text[ a, {0.0, 0.0}, c]}]], "APS"]], {
                                        
                                        BlankNullSequence[ ], 
                                        Line[ {{
                                        Pattern[ a2, 
                                        Blank[ ]], 
                                        Pattern[ b2, 
                                        Blank[ ]]}, 
                                        Blank[ ]}], 
                                        Text[ 
                                        Blank[ ], {
                                        Pattern[ e2, 
                                        Blank[ ]], 
                                        Pattern[ f2, 
                                        Blank[ ]]}, 
                                        BlankNullSequence[ ]], 
                                        BlankNullSequence[ ]} :> Text[ a, {
                                        Times[ 
                                        Plus[ 
                                        Times[ 
                                        Plus[ a1, 
                                        Times[ -1, e2], a2], 
                                        Power[ 288, -1]], 
                                        Times[ -1, 
                                        Part[ scale, 1]]], 
                                        Power[ 
                                        Part[ scale, 2], -1]], 
                                        Times[ 
                                        Plus[ 
                                        Times[ 
                                        Plus[ b1, 
                                        Times[ -1, f2], b2], 
                                        Power[ 288, -1]], 
                                        Times[ -1, 
                                        Part[ scale, 3]], 
                                        Times[ -1, 
                                        Times[ 
                                        Plus[ 1, 
                                        Times[ -1, aspectratio]], 
                                        Power[ 2, -1]]]], 
                                        Power[ 
                                        Part[ scale, 4], -1]]}, c], 
                                        Infinity], {
                                        Text[ a, {
                                        Times[ 
                                        Plus[ 
                                        Times[ a1, 
                                        Power[ 288, -1]], 
                                        Times[ -1, 
                                        Part[ scale, 1]]], 
                                        Power[ 
                                        Part[ scale, 2], -1]], 
                                        Times[ 
                                        Plus[ 
                                        Times[ b1, 
                                        Power[ 288, -1]], 
                                        Times[ -1, 
                                        Part[ scale, 3]], 
                                        Times[ -1, 
                                        Times[ 
                                        Plus[ 1, 
                                        Times[ -1, aspectratio]], 
                                        Power[ 2, -1]]]], 
                                        Power[ 
                                        Part[ scale, 4], -1]]}, c]}], 1]}]], 
                                      Set[ graph, 
                                        Join[ graph, 
                                        Graphics[ 
                                        AspectRatio -> aspectratio, 
                                        PlotRange -> {{xmin, xmax}, {ymin, 
                                        ymax}}]]], 
                                      (Cell[ 
                                        TextData[ {#}], "Input"]&)[ 
                                        StringJoin[ "Show[", 
                                        ToString[ 
                                        FullForm[ graph]], "]"]]]]]}]], 
                            If[ 
                              MatchQ[ readitem, 
                                Blank[ TextData]], 
                              Set[ readitem, 
                                Cell[ 
                                readitem, "Input", ShowSpecialCharacters -> 
                                  False]]], 
                            If[ 
                              MatchQ[ readitem, 
                                Blank[ String]], 
                              Set[ readitem, 
                                Cell[ 
                                  TextData[ {readitem}], "Input", 
                                  ShowSpecialCharacters -> False]]], 
                            Set[ readitem, 
                              ReplaceRepeated[ readitem, {(Condition[ 
                                  Pattern[ x1, 
                                    Blank[ ]], 
                                  
                                  MemberQ[ {FontColor, FontFamily, 
                                    FontProperties, FontSize, FontSlant, 
                                    FontTracking, FontVariations, FontWeight, 
                                    Background}, x1]] -> Blank[ ]) :> 
                                Sequence[ ], StyleBox[ 
                                  Pattern[ l1, 
                                    Blank[ ]], 
                                  BlankNullSequence[ ]] :> l1, TextData[ {
                                  Pattern[ a1, 
                                    BlankNullSequence[ ]], 
                                  Cell[ 
                                    TextData[ {
                                      Pattern[ b1, 
                                        BlankSequence[ ]]}], 
                                    BlankNullSequence[ ]], 
                                  Pattern[ c1, 
                                    BlankNullSequence[ ]]}] :> 
                                TextData[ {a1, b1, c1}], TextData[ 
                                  Cell[ 
                                    TextData[ {
                                      Pattern[ a1, 
                                        BlankSequence[ ]]}], 
                                    BlankNullSequence[ ]]] :> TextData[ {a1}],
                                 Cell[ 
                                  CellGroupData[ {
                                    Cell[ 
                                      Pattern[ a, 
                                        BlankSequence[ ]]]}, 
                                    BlankNullSequence[ ]]] :> Cell[ a], {
                                Pattern[ a1, 
                                  BlankNullSequence[ ]], 
                                Cell[ 
                                  TextData[ {
                                    Pattern[ b1, 
                                      BlankSequence[ ]]}], 
                                  BlankNullSequence[ ]], 
                                Cell[ 
                                  TextData[ {
                                    Pattern[ c1, 
                                      BlankSequence[ ]]}], 
                                  BlankNullSequence[ ]], 
                                Pattern[ d1, 
                                  BlankNullSequence[ ]]} :> {a1, 
                                Cell[ 
                                  TextData[ {b1, "\n", c1}], "Input", 
                                  ShowSpecialCharacters -> False], d1}}]], 
                            Set[ readitem, 
                              ReplaceRepeated[ readitem, {TextData[ {
                                  Pattern[ b1, 
                                    BlankNullSequence[ ]], 
                                  Pattern[ a1, 
                                    Blank[ String]], 
                                  Pattern[ d1, 
                                    Blank[ String]], 
                                  Pattern[ c1, 
                                    BlankNullSequence[ ]]}] :> 
                                TextData[ {b1, 
                                  StringJoin[ a1, d1], c1}]}]], 
                            Set[ readitem, 
                              ReplaceRepeated[ readitem, {Pattern[ a, 
                                  Blank[ String]] :> Block[ {
                                  Set[ $Messages, {}]}, 
                                  StringReplace[ a, StringExpression[ 
                                      Pattern[ b1, 
                                        Condition[ 
                                        Alternatives[ StartOfString, 
                                        StringExpression[ StartOfString, 
                                        Blank[ ]], 
                                        StringExpression[ 
                                        Pattern[ x, 
                                        Blank[ ]], 
                                        Pattern[ y, 
                                        Blank[ ]]]], 
                                        Unequal[ 
                                        StringJoin[ x, y], "\\!"]]], 
                                      ShortestMatch[ 
                                        Condition[ 
                                        Pattern[ b, 
                                        StringExpression[ "\\(", 
                                        StringExpression[ 
                                        BlankSequence[ ], "\\)"]]], 
                                        Check[ 
                                        CompoundExpression[ 
                                        Set[ tws, 
                                        ToString[ 
                                        InputForm[ 
                                        ToExpression[ 
                                        StringJoin[ "HoldComplete", "[\!", 
                                        StringReplace[ 
                                        b, {"\\\"" -> FromCharacterCode[ 34], 
                                        "\\\\" -> "\\"}], "]"]]]]], True], 
                                        False]]]] :> StringJoin[ b1, "\\\"", 
                                      StringReplace[ 
                                        StringDrop[ 
                                        StringDrop[ tws, 13], -1], {
                                        FromCharacterCode[ 34] -> "\\\"", 
                                        "\\" -> "\\\\"}], "\\\""]]]}]], 
                            Set[ readitem, 
                              ReplaceRepeated[ readitem, {Pattern[ a, 
                                  Blank[ String]] :> Block[ {
                                  Set[ $Messages, {}]}, 
                                  StringReplace[ a, {ShortestMatch[ 
                                      Condition[ 
                                        Pattern[ b, 
                                        StringExpression[ "\\!\\(", 
                                        StringExpression[ 
                                        BlankSequence[ ], "\\)"]]], 
                                        Check[ 
                                        CompoundExpression[ 
                                        Set[ tws, 
                                        ToString[ 
                                        InputForm[ 
                                        ToExpression[ 
                                        StringJoin[ "HoldComplete", "[", 
                                        StringReplace[ 
                                        b, {"\\*" -> "", "\\\"" -> 
                                        FromCharacterCode[ 34], "\\\\" -> 
                                        "\\"}], "]"]]]]], True], False]]] :> 
                                    StringReplace[ 
                                      StringJoin[ "(", 
                                        StringDrop[ 
                                        StringDrop[ tws, 13], -1], ")"], {
                                      FromCharacterCode[ 34] -> "\\\"", "\\" -> 
                                      "\\\\"}]}]]}]], 
                            Set[ readitem, 
                              ReplaceRepeated[ 
                                ReplaceAll[ readitem, {Pattern[ a, 
                                    Blank[ String]] :> StringReplace[ 
                                  a, {"\[LeftDoubleBracket]" -> "[[", 
                                    "\[RightDoubleBracket]" -> "]]", 
                                    "\[Equal]" -> "==", "\[LessEqual]" -> 
                                    "<=", "\[GreaterEqual]" -> ">=", 
                                    "\[NotEqual]" -> "!=", "\[Rule]" -> "->", 
                                    "\[RuleDelayed]" -> ":>", 
                                    "\[Continuation]" -> " ", 
                                    FromCharacterCode[ 1] -> " ", "\t" -> " ",
                                     "\[InvisibleSpace]" -> " "}]}], {Pattern[
                                 a, 
                                  Blank[ String]] :> StringReplace[ 
                                a, {"  " -> " "}]}]], 
                            Set[ readitem, 
                              ReplaceAll[ readitem, {Cell[ 
                                  Pattern[ a, 
                                    Blank[ ]], 
                                  Pattern[ b, 
                                    BlankSequence[ ]]] :> Cell[ 
                                a, "Input", ShowSpecialCharacters -> 
                                  False]}]], 
                            FrontEndExecute[ 
                              FrontEndToken[ "Copy"]], 
                            SelectionMove[ 
                              ClipboardNotebook[ ], All, Notebook], 
                            NotebookWrite[ 
                              ClipboardNotebook[ ], readitem, All], 
                            SelectionMove[ 
                              ClipboardNotebook[ ], All, Notebook], 
                            FrontEndExecute[ {
                              FrontEndToken[ 
                                ClipboardNotebook[ ], "CopySpecial", 
                                "PlainText"]}], Null]]]],
                  ButtonEvaluator->Automatic,
                  Active->True,
                  ButtonFrame->"DialogBox",
                  Background->RGBColor[0.949996, 0.949996, 1]], 
                ButtonBox[
                  StyleBox[\(\(*\)\(\[Rule]\)\(\[SpaceIndicator]\)\),
                    FontFamily->"Helvetica",
                    FontSize->11,
                    FontWeight->"Bold",
                    FontColor->GrayLevel[0]],
                  ButtonFunction:>Module[ {readitem}, 
                      CompoundExpression[ 
                        Set[ readitem, 
                          NotebookRead[ 
                            InputNotebook[ ]]], 
                        Catch[ 
                          CompoundExpression[ 
                            Which[ 
                              SameQ[ readitem, {}], 
                              Throw[ Null], 
                              ListQ[ readitem], 
                              CompoundExpression[ 
                                If[ 
                                  UnsameQ[ 
                                    ReplaceAll[ "CursorPosition", 
                                      Flatten[ 
                                        CompoundExpression[ 
                                        LinkWrite[ $ParentLink, 
                                        CellInformation[ 
                                        InputNotebook[ ]]], 
                                        LinkRead[ $ParentLink]]]], 
                                    "CellBracket"], 
                                  Set[ readitem, 
                                    Cell[ 
                                      TextData[ readitem], "Text"]]], 
                                If[ 
                                  MatchQ[ readitem, {
                                    Blank[ Cell]}], 
                                  Set[ readitem, 
                                    Part[ readitem, 1]]], 
                                If[ 
                                  MatchQ[ readitem, {
                                    Pattern[ a1, 
                                      Blank[ Cell]], 
                                    Pattern[ b1, 
                                      BlankNullSequence[ ]]}], 
                                  Throw[ Null]]], 
                              MatchQ[ readitem, 
                                Blank[ String]], 
                              If[ 
                                
                                MemberQ[ {{"Graphics"}, "Graphics3D", {
                                  "SurfaceGraphics"}, {"DensityGraphics"}, {
                                  "ContourGraphics"}}, 
                                  Cases[ 
                                    CompoundExpression[ 
                                      LinkWrite[ $ParentLink, 
                                        CellInformation[ 
                                        InputNotebook[ ]]], 
                                      LinkRead[ $ParentLink]], ("Style" -> 
                                    Pattern[ x, 
                                      Blank[ ]]) -> x, 2]], 
                                Throw[ Null], 
                                Set[ readitem, 
                                  Cell[ 
                                    TextData[ {readitem}], "Text"]]], 
                              StringMatchQ[ 
                                ToString[ 
                                  Head[ readitem]], 
                                StringExpression[ 
                                  BlankSequence[ ], "Box"]], 
                              Set[ readitem, 
                                Cell[ 
                                  BoxData[ {readitem}], "Text"]]], 
                            NotebookWrite[ 
                              InputNotebook[ ], 
                              ReplaceAll[ readitem, {Pattern[ a1, 
                                  Blank[ GraphicsData]] :> a1, Pattern[ a1, 
                                  Blank[ String]] :> StringReplace[ 
                                a1, {"(*" -> "(*", "*)" -> "*)", "*^" -> "*^",
                                   "**" -> "**", "*=" -> "*=", "*" -> " "}]}],
                               All]]]]],
                  ButtonEvaluator->Automatic,
                  Active->True,
                  ButtonFrame->"DialogBox",
                  Background->GrayLevel[0.900008]], 
                ButtonBox[
                  
                  StyleBox[\(\[SelectionPlaceholder], \[SelectionPlaceholder]\
\),
                    FontFamily->"Courier",
                    FontSize->11,
                    FontWeight->"Bold",
                    FontColor->GrayLevel[0]],
                  ButtonFunction:>Module[ {readitem, cpynb}, 
                      CompoundExpression[ 
                        Set[ readitem, 
                          NotebookRead[ 
                            InputNotebook[ ]]], 
                        Catch[ 
                          CompoundExpression[ 
                            Which[ 
                              SameQ[ readitem, {}], 
                              CompoundExpression[ 
                                NotebookWrite[ 
                                  InputNotebook[ ], 
                                  
                                  RowBox[ {"\[SelectionPlaceholder]", ",", 
                                    "\[SelectionPlaceholder]"}], All], 
                                Throw[ Null]], 
                              ListQ[ readitem], 
                              If[ 
                                UnsameQ[ 
                                  ReplaceAll[ "CursorPosition", 
                                    Flatten[ 
                                      CompoundExpression[ 
                                        LinkWrite[ $ParentLink, 
                                        CellInformation[ 
                                        InputNotebook[ ]]], 
                                        LinkRead[ $ParentLink]]]], 
                                  "CellBracket"], 
                                Set[ readitem, 
                                  TextData[ readitem]]]], 
                            If[ 
                              MatchQ[ readitem, 
                                Blank[ String]], 
                              If[ 
                                MemberQ[ {{"Graphics"}}, 
                                  Cases[ 
                                    CompoundExpression[ 
                                      LinkWrite[ $ParentLink, 
                                        CellInformation[ 
                                        InputNotebook[ ]]], 
                                      LinkRead[ $ParentLink]], ("Style" -> 
                                    Pattern[ x, 
                                      Blank[ ]]) :> x, 2]], 
                                Set[ readitem, 
                                  Cell[ readitem, "Input"]], 
                                Set[ readitem, 
                                  TextData[ {readitem}]]]], 
                            If[ 
                              MatchQ[ readitem, 
                                TextData[ 
                                  Pattern[ a1, 
                                    Blank[ String]]]], 
                              Set[ readitem, 
                                TextData[ {
                                  Part[ readitem, 1]}]]], 
                            Which[ 
                              Or[ 
                                MatchQ[ readitem, 
                                  Pattern[ a1, 
                                    Blank[ Cell]]], 
                                MatchQ[ readitem, {
                                  Pattern[ a1, 
                                    Blank[ Cell]], 
                                  Pattern[ b1, 
                                    BlankNullSequence[ ]]}]], 
                              CompoundExpression[ 
                                SelectionMove[ 
                                  InputNotebook[ ], After, Cell], 
                                NotebookWrite[ 
                                  InputNotebook[ ], readitem, All]], 
                              MatchQ[ readitem, 
                                TextData[ 
                                  Pattern[ a1, 
                                    Blank[ List]]]], 
                              NotebookWrite[ 
                                InputNotebook[ ], 
                                TextData[ 
                                  Join[ 
                                    Part[ readitem, 1], {","}, 
                                    Part[ readitem, 1]]], All], True, 
                              CompoundExpression[ 
                                Set[ cpynb, 
                                  NotebookCreate[ 
                                  Visible -> False, WindowTitle -> 
                                    "Palette Scrap"]], 
                                NotebookWrite[ cpynb, readitem], 
                                NotebookWrite[ cpynb, ","], 
                                NotebookWrite[ cpynb, readitem], 
                                SelectionMove[ cpynb, All, Notebook], 
                                NotebookWrite[ 
                                  InputNotebook[ ], 
                                  NotebookRead[ cpynb], All], 
                                NotebookClose[ cpynb]]]]]]],
                  ButtonEvaluator->Automatic,
                  Active->True,
                  ButtonFrame->"DialogBox",
                  Background->GrayLevel[0.900008]], 
                ButtonBox[
                  StyleBox[\(\*"\"\<\>" \[SelectionPlaceholder] \*"\"\<\>"\),
                    FontFamily->"Courier",
                    FontSize->11,
                    FontWeight->"Bold",
                    FontColor->GrayLevel[0]],
                  ButtonFunction:>Module[ {readitem, success}, 
                      CompoundExpression[ 
                        Set[ readitem, 
                          NotebookRead[ 
                            InputNotebook[ ]]], 
                        Set[ success, False], 
                        Catch[ 
                          CompoundExpression[ 
                            Which[ 
                              SameQ[ readitem, {}], 
                              CompoundExpression[ 
                                NotebookWrite[ 
                                  InputNotebook[ ], 
                                  Cell[ 
                                    TextData[ {"\"\[Placeholder]\""}], 
                                    "Input"], All], 
                                Throw[ Null]], 
                              Greater[ 
                                Count[ readitem, 
                                  Blank[ InterpretationBox], Infinity], 0], 
                              Throw[ Null], 
                              UnsameQ[ 
                                Cases[ readitem, 
                                  FormBox[ 
                                    BoxData[ 
                                      BlankNullSequence[ ]], 
                                    BlankNullSequence[ ]]], {}], 
                              Throw[ Null], 
                              ListQ[ readitem], 
                              CompoundExpression[ 
                                If[ 
                                  UnsameQ[ 
                                    ReplaceAll[ "CursorPosition", 
                                      Flatten[ 
                                        CompoundExpression[ 
                                        LinkWrite[ $ParentLink, 
                                        CellInformation[ 
                                        InputNotebook[ ]]], 
                                        LinkRead[ $ParentLink]]]], 
                                    "CellBracket"], 
                                  Set[ readitem, 
                                    Cell[ 
                                      TextData[ readitem], "Text"]]], 
                                If[ 
                                  MatchQ[ readitem, {
                                    Blank[ Cell]}], 
                                  Set[ readitem, 
                                    Part[ readitem, 1]]], 
                                If[ 
                                  MatchQ[ readitem, {
                                    Pattern[ a1, 
                                      Blank[ Cell]], 
                                    Pattern[ b1, 
                                      BlankNullSequence[ ]]}], 
                                  Throw[ Null]]]], 
                            Which[ 
                              MatchQ[ readitem, 
                                Blank[ String]], 
                              If[ 
                                
                                MemberQ[ {{"Graphics"}, "Graphics3D", {
                                  "SurfaceGraphics"}, {"DensityGraphics"}, {
                                  "ContourGraphics"}}, 
                                  Cases[ 
                                    CompoundExpression[ 
                                      LinkWrite[ $ParentLink, 
                                        CellInformation[ 
                                        InputNotebook[ ]]], 
                                      LinkRead[ $ParentLink]], ("Style" -> 
                                    Pattern[ x, 
                                      Blank[ ]]) -> x, 2]], 
                                Throw[ Null], 
                                Set[ readitem, 
                                  TextData[ {readitem}]]], 
                              StringMatchQ[ 
                                ToString[ 
                                  Head[ readitem]], 
                                StringExpression[ 
                                  BlankSequence[ ], "Box"]], 
                              Set[ readitem, 
                                Cell[ 
                                  BoxData[ {readitem}], "Text"]], 
                              MatchQ[ readitem, 
                                Alternatives[ 
                                  Blank[ GraphicsData], 
                                  BoxData[ 
                                    Alternatives[ 
                                      Blank[ Graphics3D], 
                                      Blank[ SurfaceGraphics]]]]], 
                              Throw[ Null]], 
                            Set[ readitem, 
                              ReplaceRepeated[ readitem, {TextData[ {
                                  Pattern[ a1, 
                                    BlankNullSequence[ ]], 
                                  Cell[ 
                                    TextData[ {
                                      Pattern[ b1, 
                                        BlankSequence[ ]]}], 
                                    BlankNullSequence[ ]], 
                                  Pattern[ c1, 
                                    BlankNullSequence[ ]]}] :> 
                                TextData[ {a1, b1, c1}], TextData[ 
                                  Cell[ 
                                    TextData[ {
                                      Pattern[ a1, 
                                        BlankSequence[ ]]}], 
                                    BlankNullSequence[ ]]] :> TextData[ {a1}],
                                 Cell[ 
                                  Pattern[ a1, 
                                    Blank[ String]], 
                                  Pattern[ b1, 
                                    BlankNullSequence[ ]]] :> Cell[ 
                                  TextData[ {a1}], b1]}]], 
                            If[ 
                              Not[ 
                                MatchQ[ readitem, 
                                  Blank[ Cell]]], 
                              Set[ readitem, 
                                Cell[ readitem, "Text"]]], 
                            Set[ readitem, 
                              ReplaceAll[ readitem, {Condition[ 
                                  BoxData[ 
                                    Pattern[ x, 
                                      Blank[ ]]], 
                                  And[ 
                                    UnsameQ[ 
                                      Head[ x], List], 
                                    UnsameQ[ 
                                      Head[ x], Graphics3D], 
                                    UnsameQ[ 
                                      Head[ x], SurfaceGraphics]]] :> 
                                BoxData[ {x}]}]], 
                            If[ 
                              MatchQ[ readitem, 
                                Cell[ 
                                  BoxData[ {
                                    BlankNullSequence[ ]}], 
                                  BlankNullSequence[ ]]], 
                              Set[ readitem, 
                                Cell[ 
                                  TextData[ {readitem}], 
                                  Apply[ Sequence, 
                                    Drop[ readitem, 1]]]]], 
                            Set[ readitem, 
                              ReplaceAll[ readitem, {Pattern[ x, 
                                  Blank[ GraphicsData]] :> x, Pattern[ x, 
                                  Blank[ String]] :> StringReplace[ 
                                x, {"\"" -> "\\\"", "\\" -> "\\\\"}]}]], 
                            Which[ 
                              UnsameQ[ 
                                Head[ 
                                  Part[ readitem, 1]], TextData], Null, 
                              UnsameQ[ 
                                Head[ 
                                  Part[ readitem, 1, 1]], List], Null, True, 
                              CompoundExpression[ 
                                Set[ 
                                  Part[ readitem, 1, 1], 
                                  Join[ {"\""}, 
                                    Part[ readitem, 1, 1], {"\""}]], 
                                Set[ success, True]]], 
                            If[ success, 
                              NotebookWrite[ 
                                InputNotebook[ ], readitem, All]]]]]],
                  ButtonEvaluator->Automatic,
                  Active->True,
                  ButtonFrame->"DialogBox",
                  Background->GrayLevel[0.900008]], " ", 
                StyleBox[
                  ButtonBox[
                    StyleBox["?",
                      FontFamily->"Helvetica",
                      FontWeight->"Bold",
                      FontSlant->"Plain",
                      FontColor->GrayLevel[0]],
                    ButtonData:>{"SetFaceAndFont2"},
                    ButtonStyle->"AddOnsLink",
                    ButtonMargins->4,
                    ButtonFrame->"DialogBox"],
                  FontColor->GrayLevel[0],
                  Background->GrayLevel[0.900008]]}
              },
            ColumnSpacings->0]},
        {GridBox[{
              {
                StyleBox[
                  ButtonBox["Plain",
                    ButtonFunction:>SetOptions[ 
                        NotebookSelection[ 
                          InputNotebook[ ]], FontSlant -> "Plain", FontWeight -> 
                        "Plain", FontVariations -> {"Underline" -> False}],
                    ButtonEvaluator->None,
                    Active->True,
                    ButtonFrame->"DialogBox",
                    Background->GrayLevel[0.900008]],
                  FontFamily->"Courier",
                  FontSlant->"Plain"], 
                StyleBox[
                  ButtonBox["B",
                    ButtonFunction:>SetOptions[ 
                        NotebookSelection[ 
                          InputNotebook[ ]], FontWeight -> "Bold"],
                    ButtonEvaluator->None,
                    Active->True,
                    ButtonFrame->"DialogBox",
                    Background->GrayLevel[0.900008]],
                  FontWeight->"Bold"], 
                StyleBox[
                  ButtonBox["I",
                    ButtonFunction:>SetOptions[ 
                        NotebookSelection[ 
                          InputNotebook[ ]], FontSlant -> "Italic"],
                    ButtonEvaluator->None,
                    Active->True,
                    ButtonFrame->"DialogBox",
                    Background->GrayLevel[0.900008]],
                  FontFamily->"Courier",
                  FontSlant->"Italic"], 
                StyleBox[
                  ButtonBox["U",
                    ButtonFunction:>SetOptions[ 
                        NotebookSelection[ 
                          InputNotebook[ ]], FontVariations -> {"Underline" -> 
                        True}],
                    ButtonEvaluator->None,
                    Active->True,
                    ButtonFrame->"DialogBox",
                    Background->GrayLevel[0.900008]],
                  FontFamily->"Courier",
                  FontVariations->{"Underline"->True}], " ", 
                ButtonBox[
                  StyleBox[\((\[SelectionPlaceholder])\),
                    FontFamily->"Helvetica",
                    FontSize->11,
                    FontWeight->"Bold",
                    FontColor->GrayLevel[0]],
                  ButtonFunction:>NotebookApply[ 
                      InputNotebook[ ], 
                      RowBox[ {"(", "\[SelectionPlaceholder]", ")"}], All],
                  ButtonData:>"(\[SelectionPlaceholder])",
                  ButtonFrame->"DialogBox",
                  Background->GrayLevel[0.900008]], 
                ButtonBox[
                  StyleBox[\({\[SelectionPlaceholder]}\),
                    FontFamily->"Helvetica",
                    FontSize->11,
                    FontWeight->"Bold",
                    FontColor->GrayLevel[0]],
                  ButtonFunction:>NotebookApply[ 
                      InputNotebook[ ], 
                      RowBox[ {"{", "\[SelectionPlaceholder]", "}"}], All],
                  ButtonData:>"{\[SelectionPlaceholder]}",
                  ButtonFrame->"DialogBox",
                  Background->GrayLevel[0.900008]], 
                ButtonBox[
                  StyleBox[\(\([\)\(\[SelectionPlaceholder]\)\(]\)\),
                    FontFamily->"Helvetica",
                    FontSize->11,
                    FontWeight->"Bold",
                    FontColor->GrayLevel[0]],
                  ButtonFunction:>NotebookApply[ 
                      InputNotebook[ ], 
                      RowBox[ {"[", "\[SelectionPlaceholder]", "]"}], All],
                  ButtonData:>"[\[SelectionPlaceholder]]",
                  ButtonFrame->"DialogBox",
                  Background->GrayLevel[0.900008]], 
                ButtonBox[
                  
                  StyleBox[\(\(\[LeftDoubleBracket]\)\(\[SelectionPlaceholder]\
\)\(\[RightDoubleBracket]\)\),
                    FontFamily->"Helvetica",
                    FontSize->11,
                    FontWeight->"Bold",
                    FontColor->GrayLevel[0]],
                  ButtonFunction:>NotebookApply[ 
                      InputNotebook[ ], 
                      
                      RowBox[ {"\[LeftDoubleBracket]", 
                        "\[SelectionPlaceholder]", "\[RightDoubleBracket]"}], 
                      All],
                  
                  ButtonData:>
                    "\[LeftDoubleBracket]\[SelectionPlaceholder]\
\[RightDoubleBracket]",
                  ButtonFrame->"DialogBox",
                  Background->GrayLevel[0.900008]], 
                ButtonBox[
                  
                  StyleBox[\((\(*\)\(\ \) \[SelectionPlaceholder] \(\ \
\)\(*\))\),
                    FontFamily->"Helvetica",
                    FontSize->11,
                    FontWeight->"Bold",
                    FontColor->GrayLevel[0]],
                  ButtonFunction:>NotebookApply[ 
                      InputNotebook[ ], 
                      
                      RowBox[ {"(", "*", " ", "\[SelectionPlaceholder]", " ", 
                        "*", ")"}], All],
                  ButtonData:>"(* \[SelectionPlaceholder] *)",
                  ButtonFrame->"DialogBox",
                  Background->GrayLevel[0.900008]]}
              },
            ColumnSpacings->0]},
        {GridBox[{
              {
                ButtonBox[
                  StyleBox[\(\(\[ThinSpace]\)\(9\)\),
                    FontFamily->"Helvetica",
                    FontSize->10,
                    FontWeight->"Bold",
                    FontColor->GrayLevel[0]],
                  ButtonFunction:>SetOptions[ 
                      NotebookSelection[ 
                        InputNotebook[ ]], FontSize -> 9],
                  ButtonEvaluator->None,
                  ButtonData:>"Text",
                  ButtonFrame->"DialogBox",
                  Background->GrayLevel[0.900008]], 
                ButtonBox[
                  StyleBox[\(\(\[ThinSpace]\)\(10\)\(\[ThinSpace]\)\),
                    FontFamily->"Helvetica",
                    FontSize->10,
                    FontWeight->"Bold",
                    FontColor->GrayLevel[0]],
                  ButtonFunction:>SetOptions[ 
                      NotebookSelection[ 
                        InputNotebook[ ]], FontSize -> 10],
                  ButtonEvaluator->None,
                  ButtonData:>"Text",
                  ButtonFrame->"DialogBox",
                  Background->GrayLevel[0.900008]], 
                ButtonBox[
                  StyleBox[\(\(\[ThinSpace]\)\(12\)\(\[ThinSpace]\)\),
                    FontFamily->"Helvetica",
                    FontSize->10,
                    FontWeight->"Bold",
                    FontColor->GrayLevel[0]],
                  ButtonFunction:>SetOptions[ 
                      NotebookSelection[ 
                        InputNotebook[ ]], FontSize -> 12],
                  ButtonEvaluator->None,
                  ButtonData:>"Text",
                  ButtonFrame->"DialogBox",
                  Background->GrayLevel[0.900008]], 
                ButtonBox[
                  StyleBox[\(\(\[ThinSpace]\)\(14\)\(\[ThinSpace]\)\),
                    FontFamily->"Helvetica",
                    FontSize->10,
                    FontWeight->"Bold",
                    FontColor->GrayLevel[0]],
                  ButtonFunction:>SetOptions[ 
                      NotebookSelection[ 
                        InputNotebook[ ]], FontSize -> 14],
                  ButtonEvaluator->None,
                  ButtonData:>"Text",
                  ButtonFrame->"DialogBox",
                  Background->GrayLevel[0.900008]], 
                ButtonBox[
                  StyleBox[\(\(\[ThinSpace]\)\(16\)\(\[ThinSpace]\)\),
                    FontFamily->"Helvetica",
                    FontSize->10,
                    FontWeight->"Bold",
                    FontColor->GrayLevel[0]],
                  ButtonFunction:>SetOptions[ 
                      NotebookSelection[ 
                        InputNotebook[ ]], FontSize -> 16],
                  ButtonEvaluator->None,
                  ButtonData:>"Text",
                  ButtonFrame->"DialogBox",
                  Background->GrayLevel[0.900008]], 
                ButtonBox[
                  StyleBox[\(\(\[ThinSpace]\)\(18\)\(\[ThinSpace]\)\),
                    FontFamily->"Helvetica",
                    FontSize->10,
                    FontWeight->"Bold",
                    FontColor->GrayLevel[0]],
                  ButtonFunction:>SetOptions[ 
                      NotebookSelection[ 
                        InputNotebook[ ]], FontSize -> 18],
                  ButtonEvaluator->None,
                  ButtonData:>"Text",
                  ButtonFrame->"DialogBox",
                  Background->GrayLevel[0.900008]], 
                ButtonBox[
                  StyleBox[\(\(\[ThinSpace]\)\(24\)\(\[ThinSpace]\)\),
                    FontFamily->"Helvetica",
                    FontSize->10,
                    FontWeight->"Bold",
                    FontColor->GrayLevel[0]],
                  ButtonFunction:>SetOptions[ 
                      NotebookSelection[ 
                        InputNotebook[ ]], FontSize -> 24],
                  ButtonEvaluator->None,
                  ButtonData:>"Text",
                  ButtonFrame->"DialogBox",
                  Background->GrayLevel[0.900008]], 
                ButtonBox[
                  StyleBox[\(\(\[ThinSpace]\)\(36\)\),
                    FontFamily->"Helvetica",
                    FontSize->10,
                    FontWeight->"Bold",
                    FontColor->GrayLevel[0]],
                  ButtonFunction:>SetOptions[ 
                      NotebookSelection[ 
                        InputNotebook[ ]], FontSize -> 36],
                  ButtonEvaluator->None,
                  ButtonData:>"Text",
                  ButtonFrame->"DialogBox",
                  Background->GrayLevel[0.900008]], 
                ButtonBox[
                  StyleBox["72",
                    FontFamily->"Helvetica",
                    FontSize->10,
                    FontWeight->"Bold",
                    FontColor->GrayLevel[0]],
                  ButtonFunction:>SetOptions[ 
                      NotebookSelection[ 
                        InputNotebook[ ]], FontSize -> 72],
                  ButtonEvaluator->None,
                  ButtonData:>"Text",
                  ButtonFrame->"DialogBox",
                  Background->GrayLevel[0.900008]]}
              },
            ColumnSpacings->0]},
        {GridBox[{
              {
                ButtonBox["Courier",
                  ButtonFunction:>SetOptions[ 
                      NotebookSelection[ 
                        InputNotebook[ ]], FontSlant -> "Plain", FontFamily -> 
                      "Courier", FontWeight -> "Plain"],
                  ButtonEvaluator->None,
                  Active->True,
                  ButtonFrame->"DialogBox",
                  Background->GrayLevel[0.900008]], 
                ButtonBox[
                  StyleBox[\(Courier\ B\),
                    FontFamily->"Courier",
                    FontWeight->"Bold"],
                  ButtonFunction:>SetOptions[ 
                      NotebookSelection[ 
                        InputNotebook[ ]], FontSlant -> "Plain", FontFamily -> 
                      "Courier", FontWeight -> "Bold"],
                  ButtonEvaluator->None,
                  Active->True,
                  ButtonFrame->"DialogBox",
                  Background->GrayLevel[0.900008]], 
                StyleBox[
                  ButtonBox["Helvetica",
                    ButtonFunction:>SetOptions[ 
                        NotebookSelection[ 
                          InputNotebook[ ]], FontSlant -> "Plain", FontFamily -> 
                        "Helvetica", FontWeight -> "Plain"],
                    ButtonEvaluator->None,
                    Active->True,
                    ButtonFrame->"DialogBox",
                    Background->GrayLevel[0.900008]],
                  FontFamily->"Helvetica"], " ", 
                ButtonBox[
                  StyleBox["Peel",
                    FontFamily->"Courier",
                    FontSize->11,
                    FontWeight->"Bold",
                    FontColor->GrayLevel[0]],
                  ButtonFunction:>Module[ {readitem, success, tws, onecell}, 
                      CompoundExpression[ 
                        Set[ readitem, 
                          NotebookRead[ 
                            InputNotebook[ ]]], 
                        Set[ success, False], 
                        Set[ onecell, 
                          SameQ[ 
                            Head[ readitem], Cell]], 
                        Catch[ 
                          CompoundExpression[ 
                            Set[ readitem, 
                              ReplaceAll[ readitem, {Cell[ 
                                  Pattern[ a1, 
                                    Blank[ String]], 
                                  Pattern[ b1, 
                                    BlankNullSequence[ ]]] :> Cell[ 
                                  TextData[ {a1}], "Text"]}]], 
                            Which[ 
                              SameQ[ readitem, {}], 
                              Throw[ Null], 
                              Greater[ 
                                Count[ readitem, 
                                  Blank[ InterpretationBox], Infinity], 0], 
                              Throw[ Null], 
                              UnsameQ[ 
                                Cases[ readitem, 
                                  FormBox[ 
                                    BoxData[ 
                                      BlankNullSequence[ ]], 
                                    BlankNullSequence[ ]]], {}], 
                              Throw[ Null], 
                              ListQ[ readitem], 
                              CompoundExpression[ 
                                If[ 
                                  UnsameQ[ 
                                    ReplaceAll[ "CursorPosition", 
                                      Flatten[ 
                                        CompoundExpression[ 
                                        LinkWrite[ $ParentLink, 
                                        CellInformation[ 
                                        InputNotebook[ ]]], 
                                        LinkRead[ $ParentLink]]]], 
                                    "CellBracket"], 
                                  Set[ readitem, 
                                    Cell[ 
                                      TextData[ readitem], "Text"]]], 
                                If[ 
                                  MatchQ[ readitem, {
                                    Blank[ Cell]}], 
                                  CompoundExpression[ 
                                    Set[ readitem, 
                                      Part[ readitem, 1]], 
                                    Set[ onecell, True]]], 
                                If[ 
                                  MatchQ[ readitem, {
                                    Pattern[ a1, 
                                      Blank[ Cell]], 
                                    Pattern[ b1, 
                                      BlankNullSequence[ ]]}], 
                                  CompoundExpression[ 
                                    Set[ readitem, 
                                      ReplaceRepeated[ 
                                        Cell[ 
                                        TextData[ readitem], "Text"], {Cell[ 
                                        CellGroupData[ {
                                        Pattern[ a1, 
                                        BlankSequence[ ]]}, 
                                        BlankNullSequence[ ]], 
                                        BlankNullSequence[ ]] :> Sequence[ 
                                        a1]}]], 
                                    Set[ success, True]]]], 
                              MatchQ[ readitem, 
                                Blank[ String]], 
                              If[ 
                                
                                MemberQ[ {{"Graphics"}, "Graphics3D", {
                                  "SurfaceGraphics"}, {"DensityGraphics"}, {
                                  "ContourGraphics"}}, 
                                  Cases[ 
                                    CompoundExpression[ 
                                      LinkWrite[ $ParentLink, 
                                        CellInformation[ 
                                        InputNotebook[ ]]], 
                                      LinkRead[ $ParentLink]], ("Style" -> 
                                    Pattern[ x, 
                                      Blank[ ]]) -> x, 2]], 
                                Throw[ Null], 
                                Set[ readitem, 
                                  Cell[ 
                                    TextData[ {readitem}], "Text"]]], 
                              StringMatchQ[ 
                                ToString[ 
                                  Head[ readitem]], 
                                StringExpression[ 
                                  BlankSequence[ ], "Box"]], 
                              Set[ readitem, 
                                Cell[ 
                                  TextData[ {
                                    Cell[ 
                                      BoxData[ {readitem}], "Text"]}], 
                                  "Text"]], 
                              MatchQ[ readitem, 
                                BoxData[ 
                                  Alternatives[ 
                                    Blank[ Graphics3D], 
                                    Blank[ SurfaceGraphics]]]], 
                              CompoundExpression[ 
                                SelectionMove[ 
                                  InputNotebook[ ], All, Cell], 
                                Set[ readitem, 
                                  NotebookRead[ 
                                    InputNotebook[ ]]]], 
                              MatchQ[ readitem, 
                                Blank[ BoxData]], 
                              Set[ readitem, 
                                Cell[ 
                                  TextData[ {
                                    Cell[ readitem]}], "Text"]], 
                              MatchQ[ readitem, 
                                Blank[ GraphicsData]], 
                              CompoundExpression[ 
                                SelectionMove[ 
                                  InputNotebook[ ], All, Cell], 
                                Set[ readitem, 
                                  NotebookRead[ 
                                    InputNotebook[ ]]]]], 
                            Which[ 
                              MatchQ[ readitem, 
                                Cell[ 
                                  BoxData[ 
                                    Alternatives[ 
                                      Blank[ Graphics3D], 
                                      Blank[ SurfaceGraphics]]], 
                                  BlankNullSequence[ ]]], 
                              CompoundExpression[ 
                                SelectionMove[ 
                                  InputNotebook[ ], All, Cell], 
                                If[ 
                                  SameQ[ readitem, 
                                    NotebookRead[ 
                                      InputNotebook[ ]]], 
                                  CompoundExpression[ 
                                    Set[ readitem, 
                                      Cell[ 
                                        BoxData[ 
                                        RowBox[ {"NotebookWrite", "[", 
                                        RowBox[ {
                                        RowBox[ {"InputNotebook", "[", "]"}], 
                                        ",", 
                                        ToBoxes[ 
                                        FullForm[ readitem]]}], "]"}]], 
                                        "Input"]], 
                                    Set[ success, True]], 
                                  Throw[ Null], 
                                  Throw[ Null]]], 
                              MatchQ[ readitem, 
                                Cell[ 
                                  Blank[ BoxData], 
                                  BlankNullSequence[ ]]], 
                              Set[ readitem, 
                                Cell[ 
                                  TextData[ {readitem}], "Text"]], 
                              MatchQ[ readitem, 
                                Cell[ 
                                  Blank[ GraphicsData], 
                                  BlankNullSequence[ ]]], 
                              CompoundExpression[ 
                                SelectionMove[ 
                                  InputNotebook[ ], All, Cell], 
                                If[ 
                                  SameQ[ readitem, 
                                    NotebookRead[ 
                                      InputNotebook[ ]]], 
                                  CompoundExpression[ 
                                    Set[ readitem, 
                                      Cell[ 
                                        BoxData[ 
                                        RowBox[ {"NotebookWrite", "[", 
                                        RowBox[ {
                                        RowBox[ {"InputNotebook", "[", "]"}], 
                                        ",", 
                                        ToBoxes[ readitem]}], "]"}]], 
                                        "Input"]], 
                                    Set[ success, True]], 
                                  Throw[ Null], 
                                  Throw[ Null]]], 
                              MatchQ[ readitem, 
                                Cell[ 
                                  Blank[ CellGroupData], 
                                  BlankNullSequence[ ]]], 
                              CompoundExpression[ 
                                Set[ readitem, 
                                  Cell[ 
                                    TextData[ 
                                      Part[ readitem, 1, 1]], "Text"]], 
                                Set[ onecell, False], 
                                Set[ success, True]]], 
                            If[ success, 
                              Set[ readitem, 
                                ReplaceRepeated[ readitem, {{
                                  Pattern[ a1, 
                                    BlankNullSequence[ ]], 
                                  Cell[ 
                                    Pattern[ b1, 
                                      BlankSequence[ ]]], 
                                  Cell[ 
                                    Pattern[ c1, 
                                      BlankSequence[ ]]], 
                                  Pattern[ d1, 
                                    BlankNullSequence[ ]]} :> {a1, 
                                  Cell[ b1], "\n", 
                                  Cell[ c1], d1}}]]], 
                            If[ 
                              Not[ success], 
                              CompoundExpression[ 
                                Set[ readitem, 
                                  ReplaceAll[ readitem, {BoxData[ {
                                      Pattern[ a1, 
                                        BlankNullSequence[ ]], 
                                      "\[IndentingNewLine]", 
                                      Pattern[ b1, 
                                        BlankNullSequence[ ]]}] :> ReplaceAll[
                                     
                                      BoxData[ {
                                        
                                        RowBox[ {a1, "\[IndentingNewLine]", 
                                        b1}]}], {"\[IndentingNewLine]" -> 
                                      "\n"}]}]], 
                                Set[ readitem, 
                                  ReplaceAll[ readitem, {Condition[ 
                                      BoxData[ {
                                        Pattern[ a1, 
                                        Blank[ ]], 
                                        Pattern[ b1, 
                                        BlankNullSequence[ ]], 
                                        Pattern[ c1, 
                                        Blank[ ]], 
                                        Pattern[ d1, 
                                        BlankNullSequence[ ]]}], 
                                      And[ 
                                        Not[ 
                                        MemberQ[ {b1}, "\n"]], 
                                        Not[ 
                                        
                                        MemberQ[ {b1}, 
                                        "\[IndentingNewLine]"]], 
                                        
                                        MemberQ[ {"\n", 
                                        "\[IndentingNewLine]"}, c1]]] :> 
                                    BoxData[ {
                                      RowBox[ {a1, 
                                        Apply[ Sequence, 
                                        Map[ 
                                        Apply[ Sequence, {"\n", #}]&, {b1}]], 
                                        c1, d1}]}], BoxData[ {
                                      Pattern[ a1, 
                                        Blank[ ]], 
                                      Pattern[ b1, 
                                        BlankSequence[ ]]}] :> BoxData[ {
                                      RowBox[ {a1, 
                                        Apply[ Sequence, 
                                        Map[ 
                                        Apply[ Sequence, {"\n", #}]&, {
                                        b1}]]}]}], BoxData[ {
                                      RowBox[ 
                                        Pattern[ a1, 
                                        BlankSequence[ ]]]}] :> BoxData[ {
                                      RowBox[ a1]}], BoxData[ {
                                      Pattern[ a1, 
                                        Blank[ ]]}] :> BoxData[ {
                                      RowBox[ {a1}]}]}]], 
                                Set[ readitem, 
                                  ReplaceRepeated[ readitem, {(Condition[ 
                                      Pattern[ x1, 
                                        Blank[ ]], 
                                      
                                      MemberQ[ {FontColor, FontFamily, 
                                        FontProperties, FontSize, FontSlant, 
                                        FontTracking, FontVariations, 
                                        FontWeight, Background}, x1]] -> 
                                    Blank[ ]) -> Sequence[ ], StyleBox[ 
                                      Pattern[ l1, 
                                        Blank[ ]], 
                                      BlankNullSequence[ ]] :> l1, RowBox[ {
                                      Pattern[ c1, 
                                        BlankNullSequence[ ]], 
                                      Pattern[ a1, 
                                        Blank[ String]], 
                                      Pattern[ b1, 
                                        Blank[ String]], 
                                      Pattern[ d1, 
                                        BlankNullSequence[ ]]}] :> 
                                    RowBox[ {c1, 
                                      StringJoin[ a1, b1], d1}], RowBox[ {
                                      Pattern[ a1, 
                                        BlankNullSequence[ ]], 
                                      RowBox[ {
                                        Pattern[ b1, 
                                        BlankNullSequence[ ]]}], 
                                      Pattern[ c1, 
                                        BlankNullSequence[ ]]}] :> 
                                    RowBox[ {a1, b1, c1}], BoxData[ 
                                      Pattern[ a1, 
                                        Blank[ String]]] :> TextData[ {a1}], 
                                    BoxData[ 
                                      RowBox[ 
                                        Pattern[ a1, 
                                        BlankSequence[ ]]]] :> BoxData[ {
                                      RowBox[ a1]}], FormBox[ 
                                      Pattern[ a1, 
                                        Blank[ List]], 
                                      Pattern[ b1, 
                                        Blank[ ]]] :> RowBox[ a1], FormBox[ 
                                      Pattern[ a1, 
                                        BlankSequence[ ]], 
                                      Pattern[ b1, 
                                        Blank[ ]]] :> RowBox[ {a1}], 
                                    GridBox[ {
                                      Pattern[ a1, 
                                        BlankNullSequence[ ]], {
                                      Pattern[ c1, 
                                        BlankNullSequence[ ]], {
                                      Pattern[ d1, 
                                        BlankNullSequence[ ]]}, 
                                      Pattern[ e1, 
                                        BlankNullSequence[ ]]}, 
                                      Pattern[ b1, 
                                        BlankNullSequence[ ]]}, 
                                      Pattern[ f1, 
                                        BlankNullSequence[ ]]] :> 
                                    GridBox[ {a1, {c1, 
                                      RowBox[ {d1}], e1}, b1}, f1], 
                                    TextData[ {
                                      Pattern[ a1, 
                                        BlankNullSequence[ ]], 
                                      Cell[ 
                                        TextData[ {
                                        Pattern[ b1, 
                                        BlankSequence[ ]]}], 
                                        BlankNullSequence[ ]], 
                                      Pattern[ c1, 
                                        BlankNullSequence[ ]]}] :> 
                                    TextData[ {a1, b1, c1}], TextData[ 
                                      Cell[ 
                                        TextData[ {
                                        Pattern[ a1, 
                                        BlankSequence[ ]]}], 
                                        BlankNullSequence[ ]]] :> 
                                    TextData[ {a1}]}]], 
                                Set[ readitem, 
                                  ReplaceRepeated[ readitem, {Cell[ 
                                      BoxData[ {
                                        RowBox[ 
                                        Pattern[ a1, 
                                        Blank[ List]]]}], 
                                      BlankNullSequence[ ]] :> Apply[ 
                                    Sequence, 
                                      Map[ Cell[ 
                                        BoxData[ {#}], "Text"]&, a1]]}]], 
                                Set[ readitem, 
                                  ReplaceRepeated[ readitem, {TextData[ {
                                      Pattern[ b1, 
                                        BlankNullSequence[ ]], 
                                      Cell[ 
                                        BoxData[ {
                                        Pattern[ a1, 
                                        Blank[ String]]}], 
                                        BlankNullSequence[ ]], 
                                      Pattern[ c1, 
                                        BlankNullSequence[ ]]}] :> 
                                    TextData[ {b1, a1, c1}], TextData[ 
                                      Cell[ 
                                        BoxData[ 
                                        Pattern[ a1, 
                                        Blank[ String]]], 
                                        BlankNullSequence[ ]]] :> 
                                    TextData[ {a1}]}]], 
                                Set[ readitem, 
                                  ReplaceRepeated[ readitem, {TextData[ {
                                      Pattern[ b1, 
                                        BlankNullSequence[ ]], 
                                      Pattern[ a1, 
                                        Blank[ String]], 
                                      Pattern[ d1, 
                                        Blank[ String]], 
                                      Pattern[ c1, 
                                        BlankNullSequence[ ]]}] :> 
                                    TextData[ {b1, 
                                      StringJoin[ a1, d1], c1}]}]], 
                                If[ 
                                  Not[ 
                                    MatchQ[ readitem, 
                                      Blank[ Cell]]], 
                                  Set[ readitem, 
                                    Cell[ readitem, "Text"]]], 
                                Set[ readitem, 
                                  ReplaceAll[ readitem, {Cell[ 
                                      TextData[ {
                                        Cell[ 
                                        BoxData[ 
                                        Pattern[ al, 
                                        BlankSequence[ ]]], 
                                        BlankNullSequence[ ]]}], 
                                      BlankNullSequence[ ]] :> Cell[ 
                                      BoxData[ al], "Text"]}]], 
                                Set[ readitem, 
                                  ReplaceAll[ readitem, {Condition[ 
                                      BoxData[ 
                                        Pattern[ x, 
                                        Blank[ ]]], 
                                      And[ 
                                        UnsameQ[ 
                                        Head[ x], List], 
                                        UnsameQ[ 
                                        Head[ x], Graphics3D], 
                                        UnsameQ[ 
                                        Head[ x], SurfaceGraphics]]] :> 
                                    BoxData[ {x}]}]]]], 
                            Which[ success, Null, onecell, 
                              Set[ success, True], 
                              Or[ 
                                And[ 
                                  SameQ[ 
                                    Head[ 
                                      Part[ readitem, 1, 1, -1]], String], 
                                  GreaterEqual[ 
                                    StringLength[ 
                                      Part[ readitem, 1, 1, -1]], 1], 
                                  StringMatchQ[ 
                                    StringTake[ 
                                      Part[ readitem, 1, 1, -1], -1], 
                                    Whitespace]], 
                                And[ 
                                  SameQ[ 
                                    Head[ 
                                      Part[ readitem, 1, 1, 1]], String], 
                                  GreaterEqual[ 
                                    StringLength[ 
                                      Part[ readitem, 1, 1, 1]], 1], 
                                  StringMatchQ[ 
                                    StringTake[ 
                                      Part[ readitem, 1, 1, 1], 1], 
                                    Whitespace]]], 
                              CompoundExpression[ 
                                If[ 
                                  SameQ[ 
                                    Head[ 
                                      Part[ readitem, 1, 1, -1]], String], 
                                  Set[ 
                                    Part[ readitem, 1, 1, -1], 
                                    StringReplace[ 
                                      Part[ readitem, 1, 1, -1], {
                                      StringExpression[ StartOfString, 
                                        StringExpression[ 
                                        ShortestMatch[ 
                                        Pattern[ a1, 
                                        BlankNullSequence[ ]]], 
                                        StringExpression[ 
                                        Whitespace, EndOfString]]] :> a1}]]], 
                                
                                If[ 
                                  SameQ[ 
                                    Head[ 
                                      Part[ readitem, 1, 1, 1]], String], 
                                  Set[ 
                                    Part[ readitem, 1, 1, 1], 
                                    StringReplace[ 
                                      Part[ readitem, 1, 1, 1], {
                                      StringExpression[ StartOfString, 
                                        StringExpression[ Whitespace, 
                                        StringExpression[ 
                                        Pattern[ a1, 
                                        BlankNullSequence[ ]], EndOfString]]] :> 
                                      a1}]]], 
                                Set[ success, True]], 
                              And[ 
                                SameQ[ 
                                  Head[ 
                                    Part[ readitem, 1, 1, -1]], String], 
                                GreaterEqual[ 
                                  StringLength[ 
                                    Part[ readitem, 1, 1, -1]], 3], 
                                
                                MemberQ[ {"@@@", "//@", "//.", ";", "&", 
                                  "\n"}, 
                                  StringTake[ 
                                    Part[ readitem, 1, 1, -1], -3]]], 
                              CompoundExpression[ 
                                Set[ tws, 
                                  StringTake[ 
                                    Part[ readitem, 1, 1, -1], -3]], 
                                Set[ 
                                  Part[ readitem, 1, 1, -1], 
                                  StringDrop[ 
                                    Part[ readitem, 1, 1, -1], -3]], 
                                If[ 
                                  And[ 
                                    SameQ[ 
                                      Head[ 
                                        Part[ readitem, 1, 1, 1]], String], 
                                    GreaterEqual[ 
                                      StringLength[ 
                                        Part[ readitem, 1, 1, 1]], 3], 
                                    SameQ[ tws, 
                                      StringTake[ 
                                        Part[ readitem, 1, 1, 1], 3]]], 
                                  Set[ 
                                    Part[ readitem, 1, 1, 1], 
                                    StringDrop[ 
                                      Part[ readitem, 1, 1, 1], 3]]], 
                                Set[ success, True]], 
                              And[ 
                                SameQ[ 
                                  Head[ 
                                    Part[ readitem, 1, 1, -1]], String], 
                                GreaterEqual[ 
                                  StringLength[ 
                                    Part[ readitem, 1, 1, -1]], 2], 
                                MemberQ[ {"/.", "/;", "//", "@@", 
                                  Times[ "/@", "&&"], "**", "~~", 
                                  "\!\(\* StyleBox[\"||\",\n\"MR\"]\)", "<>"},
                                   
                                  StringTake[ 
                                    Part[ readitem, 1, 1, -1], -2]]], 
                              CompoundExpression[ 
                                Set[ tws, 
                                  StringTake[ 
                                    Part[ readitem, 1, 1, -1], -2]], 
                                Set[ 
                                  Part[ readitem, 1, 1, -1], 
                                  StringDrop[ 
                                    Part[ readitem, 1, 1, -1], -2]], 
                                If[ 
                                  And[ 
                                    SameQ[ 
                                      Head[ 
                                        Part[ readitem, 1, 1, 1]], String], 
                                    GreaterEqual[ 
                                      StringLength[ 
                                        Part[ readitem, 1, 1, 1]], 2], 
                                    SameQ[ tws, 
                                      StringTake[ 
                                        Part[ readitem, 1, 1, 1], 2]]], 
                                  Set[ 
                                    Part[ readitem, 1, 1, 1], 
                                    StringDrop[ 
                                      Part[ readitem, 1, 1, 1], 2]]], 
                                Set[ success, True]], 
                              And[ 
                                SameQ[ 
                                  Head[ 
                                    Part[ readitem, 1, 1, -1]], String], 
                                GreaterEqual[ 
                                  StringLength[ 
                                    Part[ readitem, 1, 1, -1]], 2], 
                                MemberQ[ {"->", ":>", ":=", "/=", "!="}, 
                                  StringTake[ 
                                    Part[ readitem, 1, 1, -1], -2]]], 
                              CompoundExpression[ 
                                Set[ 
                                  Part[ readitem, 1, 1, -1], 
                                  StringDrop[ 
                                    Part[ readitem, 1, 1, -1], -2]], 
                                Set[ success, True]], 
                              And[ 
                                SameQ[ 
                                  Head[ 
                                    Part[ readitem, 1, 1, -1]], String], 
                                GreaterEqual[ 
                                  StringLength[ 
                                    Part[ readitem, 1, 1, -1]], 1], 
                                
                                MemberQ[ {".", ",", ":", ";", "+", "-", "*", 
                                  "^", "/", "\n", "@", "~", 
                                  FromCharacterCode[ 96], 
                                  "\!\(\* StyleBox[\"|\",\n\"MR\"]\)", "\\", 
                                  "<", 
                                  FromCharacterCode[ 8804], 
                                  FromCharacterCode[ 8805], "_", 
                                  FromCharacterCode[ 63336]}, 
                                  StringTake[ 
                                    Part[ readitem, 1, 1, -1], -1]]], 
                              CompoundExpression[ 
                                Set[ tws, 
                                  StringTake[ 
                                    Part[ readitem, 1, 1, -1], -1]], 
                                Set[ 
                                  Part[ readitem, 1, 1, -1], 
                                  StringDrop[ 
                                    Part[ readitem, 1, 1, -1], -1]], 
                                If[ 
                                  And[ 
                                    SameQ[ 
                                      Head[ 
                                        Part[ readitem, 1, 1, 1]], String], 
                                    GreaterEqual[ 
                                      StringLength[ 
                                        Part[ readitem, 1, 1, 1]], 1], 
                                    SameQ[ tws, 
                                      StringTake[ 
                                        Part[ readitem, 1, 1, 1], 1]]], 
                                  Set[ 
                                    Part[ readitem, 1, 1, 1], 
                                    StringDrop[ 
                                      Part[ readitem, 1, 1, 1], 1]]], 
                                Set[ success, True]], 
                              And[ 
                                SameQ[ 
                                  Head[ 
                                    Part[ readitem, 1, 1, -1]], String], 
                                GreaterEqual[ 
                                  StringLength[ 
                                    Part[ readitem, 1, 1, -1]], 1], 
                                MemberQ[ {"?", "!", "&", "=", "\[NotEqual]", 
                                  ":", 
                                  FromCharacterCode[ 39], 
                                  FromCharacterCode[ 62754], 
                                  FromCharacterCode[ 62751]}, 
                                  StringTake[ 
                                    Part[ readitem, 1, 1, -1], -1]]], 
                              CompoundExpression[ 
                                Set[ 
                                  Part[ readitem, 1, 1, -1], 
                                  StringDrop[ 
                                    Part[ readitem, 1, 1, -1], -1]], 
                                Set[ success, True]], 
                              And[ 
                                Greater[ 
                                  Length[ 
                                    Part[ readitem, 1, 1]], 1], 
                                Or[ 
                                  Not[ 
                                    SameQ[ 
                                      Head[ 
                                        Part[ readitem, 1, 1, 1]], String]], 
                                  Not[ 
                                    SameQ[ 
                                      Head[ 
                                        Part[ readitem, 1, 1, -1]], 
                                      String]]]], Null, 
                              And[ 
                                SameQ[ 
                                  Head[ 
                                    Part[ readitem, 1]], BoxData], 
                                SameQ[ 
                                  Head[ 
                                    Part[ readitem, 1, 1, 1]], FrameBox]], 
                              CompoundExpression[ 
                                Set[ 
                                  Part[ readitem, 1, 1, 1], 
                                  Part[ readitem, 1, 1, 1, 1]], 
                                Set[ success, True]], 
                              And[ 
                                SameQ[ 
                                  Head[ 
                                    Part[ readitem, 1]], BoxData], 
                                UnsameQ[ 
                                  Head[ 
                                    Part[ readitem, 1, 1]], Graphics3D], 
                                UnsameQ[ 
                                  Head[ 
                                    Part[ readitem, 1, 1]], SurfaceGraphics]],
                               
                              CompoundExpression[ 
                                Set[ readitem, 
                                  ReplaceRepeated[ readitem, {BoxData[ {
                                      Pattern[ x, 
                                        Blank[ ]]}, 
                                      BlankNullSequence[ ]] :> Block[ {
                                      Set[ $Messages, {}]}, 
                                      Check[ 
                                        TextData[ {
                                        StringDrop[ 
                                        StringDrop[ 
                                        ToString[ 
                                        InputForm[ 
                                        FullForm[ 
                                        ToExpression[ 
                                        StringJoin[ "\!", 
                                        ToString[ 
                                        
                                        RowBox[ {"HoldComplete", "[", x, 
                                        "]"}], InputForm]]]]]], 22], -2]}], 
                                        ReplaceAll[ 
                                        BoxData[ {x}], {ButtonBox[ 
                                        Pattern[ a1, 
                                        BlankSequence[ ]]] :> Button[ 
                                        a1]}]]]}]], 
                                Set[ readitem, 
                                  ReplaceRepeated[ readitem, {BoxData[ {
                                      Pattern[ x, 
                                        Blank[ ]]}, 
                                      BlankNullSequence[ ]] :> TextData[ {
                                      ToString[ 
                                        ReplacePart[ x, 
                                        ReplaceAll[ 
                                        Extract[ x, 
                                        Position[ x, 
                                        Blank[ String]]], {Pattern[ a1, 
                                        Blank[ String]] :> StringJoin[ "\"", 
                                        StringReplace[ 
                                        a1, {FromCharacterCode[ 10] -> "\\n>",
                                         FromCharacterCode[ 34] -> "\\\"", 
                                        "\\" -> "\\\\"}], "\""]}], 
                                        Position[ x, 
                                        Blank[ String]], 
                                        Transpose[ {
                                        Range[ 
                                        Length[ 
                                        Position[ x, 
                                        Blank[ String]]]]}]]]}]}]], 
                                Set[ success, True]], 
                              And[ 
                                GreaterEqual[ 
                                  StringLength[ 
                                    Part[ readitem, 1, 1, 1]], 2], 
                                GreaterEqual[ 
                                  StringLength[ 
                                    Part[ readitem, 1, 1, -1]], 2], 
                                SameQ[ "\\(\\)", 
                                  StringJoin[ 
                                    StringTake[ 
                                      Part[ readitem, 1, 1, 1], 2], 
                                    StringTake[ 
                                      Part[ readitem, 1, 1, -1], -2]]]], 
                              CompoundExpression[ 
                                Set[ readitem, 
                                  ReplaceRepeated[ readitem, {Pattern[ a, 
                                      Blank[ String]] :> Block[ {
                                      Set[ $Messages, {}]}, 
                                      StringReplace[ a, StringExpression[ 
                                        Pattern[ b1, 
                                        Condition[ 
                                        Alternatives[ StartOfString, 
                                        StringExpression[ StartOfString, 
                                        Blank[ ]], 
                                        StringExpression[ 
                                        Pattern[ x, 
                                        Blank[ ]], 
                                        Pattern[ y, 
                                        Blank[ ]]]], 
                                        Unequal[ 
                                        StringJoin[ x, y], "\\!"]]], 
                                        ShortestMatch[ 
                                        Condition[ 
                                        Pattern[ b, 
                                        StringExpression[ "\\(", 
                                        StringExpression[ 
                                        BlankSequence[ ], "\\)"]]], 
                                        Check[ 
                                        CompoundExpression[ 
                                        Set[ tws, 
                                        ToString[ 
                                        InputForm[ 
                                        ToExpression[ 
                                        StringJoin[ "HoldComplete", "[\!", 
                                        StringReplace[ 
                                        b, {"\\\"" -> FromCharacterCode[ 34], 
                                        "\\\\" -> "\\"}], "]"]]]]], True], 
                                        False]]]] :> StringJoin[ b1, "\"", 
                                        StringReplace[ 
                                        StringDrop[ 
                                        StringDrop[ tws, 13], -1], {
                                        FromCharacterCode[ 34] -> "\\\"", 
                                        "\\" -> "\\\\"}], "\""]]]}]], 
                                Set[ success, True]], 
                              And[ 
                                GreaterEqual[ 
                                  StringLength[ 
                                    Part[ readitem, 1, 1, 1]], 4], 
                                GreaterEqual[ 
                                  StringLength[ 
                                    Part[ readitem, 1, 1, -1]], 2], 
                                SameQ[ "\\!\\(\\)", 
                                  StringJoin[ 
                                    StringTake[ 
                                      Part[ readitem, 1, 1, 1], 4], 
                                    StringTake[ 
                                      Part[ readitem, 1, 1, -1], -2]]]], 
                              CompoundExpression[ 
                                Set[ readitem, 
                                  ReplaceRepeated[ readitem, {Pattern[ a, 
                                      Blank[ String]] :> Block[ {
                                      Set[ $Messages, {}]}, 
                                      StringReplace[ a, {ShortestMatch[ 
                                        Condition[ 
                                        Pattern[ b, 
                                        StringExpression[ "\\!\\(", 
                                        StringExpression[ 
                                        BlankSequence[ ], "\\)"]]], 
                                        Check[ 
                                        CompoundExpression[ 
                                        Set[ tws, 
                                        ToString[ 
                                        InputForm[ 
                                        ToExpression[ 
                                        StringJoin[ "HoldComplete", "[", 
                                        StringReplace[ 
                                        b, {"\\*" -> "", "\\\"" -> 
                                        FromCharacterCode[ 34], "\\\\" -> 
                                        "\\"}], "]"]]]]], True], False]]] :> 
                                        StringReplace[ 
                                        StringJoin[ "(", 
                                        StringDrop[ 
                                        StringDrop[ tws, 13], -1], ")"], {
                                        FromCharacterCode[ 34] -> "\\\"", 
                                        "\\" -> "\\\\"}]}]]}]], 
                                Set[ success, True]], 
                              UnsameQ[ 
                                Head[ 
                                  Part[ readitem, 1]], TextData], Null, 
                              UnsameQ[ 
                                Head[ 
                                  Part[ readitem, 1, 1]], List], Null, 
                              Or[ 
                                UnsameQ[ 
                                  Head[ 
                                    Part[ readitem, 1, 1, 1]], String], 
                                UnsameQ[ 
                                  Head[ 
                                    Part[ readitem, 1, 1, -1]], String]], 
                              Null, 
                              And[ 
                                GreaterEqual[ 
                                  StringLength[ 
                                    Part[ readitem, 1, 1, 1]], 5], 
                                GreaterEqual[ 
                                  StringLength[ 
                                    Part[ readitem, 1, 1, -1]], 5], 
                                MemberQ[ {"\\\"\\\\<\\\\>\\\""}, 
                                  StringJoin[ 
                                    StringTake[ 
                                      Part[ readitem, 1, 1, 1], 5], 
                                    StringTake[ 
                                      Part[ readitem, 1, 1, -1], -5]]]], 
                              CompoundExpression[ 
                                Set[ 
                                  Part[ readitem, 1, 1, 1], 
                                  StringDrop[ 
                                    Part[ readitem, 1, 1, 1], 5]], 
                                If[ 
                                  GreaterEqual[ 
                                    StringLength[ 
                                      Part[ readitem, 1, 1, -1]], 5], 
                                  CompoundExpression[ 
                                    Set[ 
                                      Part[ readitem, 1, 1, -1], 
                                      StringDrop[ 
                                        Part[ readitem, 1, 1, -1], -5]], 
                                    Set[ readitem, 
                                      ReplaceAll[ readitem, {Pattern[ x, 
                                        Blank[ String]] :> StringReplace[ 
                                        x, {"\\\"" -> FromCharacterCode[ 34], 
                                        "\\\\" -> "\\"}]}]], 
                                    Set[ success, True]]]], 
                              And[ 
                                GreaterEqual[ 
                                  StringLength[ 
                                    Part[ readitem, 1, 1, 1]], 4], 
                                GreaterEqual[ 
                                  StringLength[ 
                                    Part[ readitem, 1, 1, -1]], 4], 
                                MemberQ[ {"\\\\\\\"\\\\\\\""}, 
                                  StringJoin[ 
                                    StringTake[ 
                                      Part[ readitem, 1, 1, 1], 4], 
                                    StringTake[ 
                                      Part[ readitem, 1, 1, -1], -4]]]], 
                              CompoundExpression[ 
                                Set[ 
                                  Part[ readitem, 1, 1, 1], 
                                  StringDrop[ 
                                    Part[ readitem, 1, 1, 1], 4]], 
                                If[ 
                                  GreaterEqual[ 
                                    StringLength[ 
                                      Part[ readitem, 1, 1, -1]], 4], 
                                  CompoundExpression[ 
                                    Set[ 
                                      Part[ readitem, 1, 1, -1], 
                                      StringDrop[ 
                                        Part[ readitem, 1, 1, -1], -4]], 
                                    Set[ readitem, 
                                      ReplaceAll[ readitem, {Pattern[ x, 
                                        Blank[ String]] :> StringReplace[ 
                                        x, {"\\\"" -> FromCharacterCode[ 34], 
                                        "\\\\" -> "\\"}]}]], 
                                    Set[ success, True]]]], 
                              And[ 
                                GreaterEqual[ 
                                  StringLength[ 
                                    Part[ readitem, 1, 1, 1]], 3], 
                                GreaterEqual[ 
                                  StringLength[ 
                                    Part[ readitem, 1, 1, -1]], 3], 
                                MemberQ[ {"\"\\<\\>\""}, 
                                  StringJoin[ 
                                    StringTake[ 
                                      Part[ readitem, 1, 1, 1], 3], 
                                    StringTake[ 
                                      Part[ readitem, 1, 1, -1], -3]]]], 
                              CompoundExpression[ 
                                Set[ 
                                  Part[ readitem, 1, 1, 1], 
                                  StringDrop[ 
                                    Part[ readitem, 1, 1, 1], 3]], 
                                If[ 
                                  GreaterEqual[ 
                                    StringLength[ 
                                      Part[ readitem, 1, 1, -1]], 3], 
                                  CompoundExpression[ 
                                    Set[ 
                                      Part[ readitem, 1, 1, -1], 
                                      StringDrop[ 
                                        Part[ readitem, 1, 1, -1], -3]], 
                                    Set[ readitem, 
                                      ReplaceAll[ readitem, {Pattern[ x, 
                                        Blank[ String]] :> StringReplace[ 
                                        x, {"\\\"" -> FromCharacterCode[ 34], 
                                        "\\\\" -> "\\"}]}]], 
                                    Set[ success, True]]]], 
                              And[ 
                                GreaterEqual[ 
                                  StringLength[ 
                                    Part[ readitem, 1, 1, 1]], 2], 
                                GreaterEqual[ 
                                  StringLength[ 
                                    Part[ readitem, 1, 1, -1]], 2], 
                                MemberQ[ {"\\\"\\\""}, 
                                  StringJoin[ 
                                    StringTake[ 
                                      Part[ readitem, 1, 1, 1], 2], 
                                    StringTake[ 
                                      Part[ readitem, 1, 1, -1], -2]]]], 
                              CompoundExpression[ 
                                Set[ 
                                  Part[ readitem, 1, 1, 1], 
                                  StringDrop[ 
                                    Part[ readitem, 1, 1, 1], 2]], 
                                If[ 
                                  GreaterEqual[ 
                                    StringLength[ 
                                      Part[ readitem, 1, 1, -1]], 2], 
                                  CompoundExpression[ 
                                    Set[ 
                                      Part[ readitem, 1, 1, -1], 
                                      StringDrop[ 
                                        Part[ readitem, 1, 1, -1], -2]], {
                                    Pattern[ x, 
                                      Blank[ String]] :> StringReplace[ 
                                    x, {"\\\"" -> FromCharacterCode[ 34], 
                                      "\\\\" -> "\\"}]}, 
                                    Set[ success, True]]]], 
                              And[ 
                                GreaterEqual[ 
                                  StringLength[ 
                                    Part[ readitem, 1, 1, 1]], 2], 
                                GreaterEqual[ 
                                  StringLength[ 
                                    Part[ readitem, 1, 1, -1]], 2], 
                                MemberQ[ {"(**)", "[[]]", "\\(\\)", "<<>>"}, 
                                  StringJoin[ 
                                    StringTake[ 
                                      Part[ readitem, 1, 1, 1], 2], 
                                    StringTake[ 
                                      Part[ readitem, 1, 1, -1], -2]]]], 
                              CompoundExpression[ 
                                Set[ 
                                  Part[ readitem, 1, 1, 1], 
                                  StringDrop[ 
                                    Part[ readitem, 1, 1, 1], 2]], 
                                If[ 
                                  GreaterEqual[ 
                                    StringLength[ 
                                      Part[ readitem, 1, 1, -1]], 2], 
                                  CompoundExpression[ 
                                    Set[ 
                                      Part[ readitem, 1, 1, -1], 
                                      StringDrop[ 
                                        Part[ readitem, 1, 1, -1], -2]], 
                                    Set[ success, True]], 
                                  If[ 
                                    SameQ[ 
                                      Part[ readitem, 1, 1, -1], ")"], 
                                    CompoundExpression[ 
                                      Set[ 
                                        Part[ readitem, 1, 1, -1], "*"], 
                                      Set[ success, True]]]]], 
                              SameQ[ 
                                StringTake[ 
                                  Part[ readitem, 1, 1, -1], -1], "]"], 
                              If[ 
                                Greater[ 
                                  Length[ 
                                    StringPosition[ 
                                      Part[ readitem, 1, 1, 1], "[", 1]], 0], 
                                
                                CompoundExpression[ 
                                  Set[ 
                                    Part[ readitem, 1, 1, 1], 
                                    StringDrop[ 
                                      Part[ readitem, 1, 1, 1], 
                                      Part[ 
                                        StringPosition[ 
                                        Part[ readitem, 1, 1, 1], "[", 1], 1, 
                                        1]]], 
                                  Set[ 
                                    Part[ readitem, 1, 1, -1], 
                                    StringDrop[ 
                                      Part[ readitem, 1, 1, -1], -1]], 
                                  Set[ success, True]]], 
                              And[ 
                                GreaterEqual[ 
                                  StringLength[ 
                                    Part[ readitem, 1, 1, 1]], 1], 
                                GreaterEqual[ 
                                  StringLength[ 
                                    Part[ readitem, 1, 1, -1]], 1], 
                                MemberQ[ {
                                  FromCharacterCode[ {34, 34}]}, 
                                  StringJoin[ 
                                    StringTake[ 
                                      Part[ readitem, 1, 1, 1], 1], 
                                    StringTake[ 
                                      Part[ readitem, 1, 1, -1], -1]]]], 
                              CompoundExpression[ 
                                Set[ 
                                  Part[ readitem, 1, 1, 1], 
                                  StringDrop[ 
                                    Part[ readitem, 1, 1, 1], 1]], 
                                If[ 
                                  GreaterEqual[ 
                                    StringLength[ 
                                      Part[ readitem, 1, 1, -1]], 1], 
                                  CompoundExpression[ 
                                    Set[ 
                                      Part[ readitem, 1, 1, -1], 
                                      StringDrop[ 
                                        Part[ readitem, 1, 1, -1], -1]], 
                                    Set[ readitem, 
                                      ReplaceAll[ readitem, {Pattern[ x, 
                                        Blank[ String]] :> StringReplace[ 
                                        x, {"\\\"" -> FromCharacterCode[ 34], 
                                        "\\\\" -> "\\"}]}]], 
                                    Set[ success, True]]]], 
                              And[ 
                                GreaterEqual[ 
                                  StringLength[ 
                                    Part[ readitem, 1, 1, 1]], 1], 
                                GreaterEqual[ 
                                  StringLength[ 
                                    Part[ readitem, 1, 1, -1]], 1], 
                                
                                MemberQ[ {"()", "{}", 
                                  "\[LeftAngleBracket]\[RightAngleBracket]", 
                                  "\[LeftFloor]\[RightFloor]", 
                                  "\[LeftCeiling]\[RightCeiling]", "<>", 
                                  "\[LeftDoubleBracket]\[RightDoubleBracket]",
                                   "\[LeftBracketingBar]\[RightBracketingBar]\
", "\[LeftDoubleBracketingBar]\[RightDoubleBracketingBar]", "~~", "''", 
                                  "\[CloseCurlyDoubleQuote]\
\[CloseCurlyDoubleQuote]", "\:201a\[CloseCurlyQuote]", 
                                  "\:201e\[OpenCurlyDoubleQuote]", 
                                  "\[LeftSkeleton]\[RightSkeleton]", 
                                  "\[LeftGuillemet]\[RightGuillemet]"}, 
                                  StringJoin[ 
                                    StringTake[ 
                                      Part[ readitem, 1, 1, 1], 1], 
                                    StringTake[ 
                                      Part[ readitem, 1, 1, -1], -1]]]], 
                              CompoundExpression[ 
                                Set[ 
                                  Part[ readitem, 1, 1, 1], 
                                  StringDrop[ 
                                    Part[ readitem, 1, 1, 1], 1]], 
                                If[ 
                                  GreaterEqual[ 
                                    StringLength[ 
                                      Part[ readitem, 1, 1, -1]], 1], 
                                  CompoundExpression[ 
                                    Set[ 
                                      Part[ readitem, 1, 1, -1], 
                                      StringDrop[ 
                                        Part[ readitem, 1, 1, -1], -1]], 
                                    Set[ success, True]]]]], 
                            If[ 
                              And[ 
                                Not[ success], 
                                SameQ[ 
                                  Head[ 
                                    Part[ readitem, 1, 1, -1]], String], 
                                GreaterEqual[ 
                                  StringLength[ 
                                    Part[ readitem, 1, 1, -1]], 1], 
                                MemberQ[ {">"}, 
                                  StringTake[ 
                                    Part[ readitem, 1, 1, -1], -1]]], 
                              CompoundExpression[ 
                                Set[ tws, 
                                  StringTake[ 
                                    Part[ readitem, 1, 1, -1], -1]], 
                                Set[ 
                                  Part[ readitem, 1, 1, -1], 
                                  StringDrop[ 
                                    Part[ readitem, 1, 1, -1], -1]], 
                                If[ 
                                  And[ 
                                    SameQ[ 
                                      Head[ 
                                        Part[ readitem, 1, 1, 1]], String], 
                                    GreaterEqual[ 
                                      StringLength[ 
                                        Part[ readitem, 1, 1, 1]], 1], 
                                    SameQ[ tws, 
                                      StringTake[ 
                                        Part[ readitem, 1, 1, 1], 1]]], 
                                  Set[ 
                                    Part[ readitem, 1, 1, 1], 
                                    StringDrop[ 
                                      Part[ readitem, 1, 1, 1], 1]]], 
                                Set[ success, True]]], 
                            If[ success, 
                              NotebookWrite[ 
                                InputNotebook[ ], readitem, All]]]]]],
                  ButtonEvaluator->Automatic,
                  Active->True,
                  ButtonFrame->"DialogBox",
                  Background->GrayLevel[0.900008]]}
              },
            ColumnSpacings->0]},
        {GridBox[{
              {"  ", 
                StyleBox[
                  ButtonBox["Times",
                    ButtonFunction:>SetOptions[ 
                        NotebookSelection[ 
                          InputNotebook[ ]], FontSlant -> "Plain", FontFamily -> 
                        "Times", FontWeight -> "Plain"],
                    ButtonEvaluator->None,
                    Active->True,
                    ButtonFrame->"DialogBox",
                    Background->GrayLevel[0.900008]],
                  FontFamily->"Times"], 
                StyleBox[
                  ButtonBox[\(Times\ Italic\),
                    ButtonFunction:>SetOptions[ 
                        NotebookSelection[ 
                          InputNotebook[ ]], FontSlant -> "Italic", 
                        FontFamily -> "Times", FontWeight -> "Plain"],
                    ButtonEvaluator->None,
                    Active->True,
                    ButtonFrame->"DialogBox",
                    Background->GrayLevel[0.900008]],
                  FontFamily->"Times",
                  FontSlant->"Italic"], "    ", 
                ButtonBox[
                  StyleBox["StyleRemove",
                    FontFamily->"Courier",
                    FontSize->11,
                    FontWeight->"Bold",
                    FontColor->GrayLevel[0]],
                  ButtonFunction:>Module[ {readitem, cellinfo}, 
                      CompoundExpression[ 
                        Set[ readitem, 
                          NotebookRead[ 
                            InputNotebook[ ]]], 
                        Set[ cellinfo, 
                          ReplaceAll[ "CursorPosition", 
                            Flatten[ 
                              CompoundExpression[ 
                                LinkWrite[ $ParentLink, 
                                  CellInformation[ 
                                    InputNotebook[ ]]], 
                                LinkRead[ $ParentLink]]]]], 
                        Set[ readitem, 
                          ReplaceAll[ readitem, {Cell[ 
                              Pattern[ a1, 
                                Blank[ String]], 
                              Pattern[ b1, 
                                BlankNullSequence[ ]]] :> Cell[ 
                              TextData[ {a1}], b1]}]], 
                        Catch[ 
                          CompoundExpression[ 
                            Which[ 
                              SameQ[ readitem, {}], 
                              Throw[ Null], 
                              Greater[ 
                                Count[ readitem, 
                                  Blank[ InterpretationBox], Infinity], 0], 
                              CompoundExpression[ 
                                FrontEndExecute[ 
                                  FrontEndToken[ "ClearCellOptions"]], 
                                Throw[ Null]], 
                              UnsameQ[ 
                                Cases[ readitem, 
                                  FormBox[ 
                                    BoxData[ 
                                      BlankNullSequence[ ]], 
                                    BlankNullSequence[ ]]], {}], 
                              Throw[ Null], 
                              ListQ[ readitem], 
                              CompoundExpression[ 
                                If[ 
                                  UnsameQ[ cellinfo, "CellBracket"], 
                                  Set[ readitem, 
                                    Cell[ 
                                      TextData[ readitem], "Text"]]], 
                                If[ 
                                  MatchQ[ readitem, {
                                    Blank[ Cell]}], 
                                  Set[ readitem, 
                                    Part[ readitem, 1]]], 
                                If[ 
                                  MatchQ[ readitem, {
                                    Pattern[ a1, 
                                      Blank[ Cell]], 
                                    Pattern[ b1, 
                                      BlankNullSequence[ ]]}], 
                                  CompoundExpression[ 
                                    FrontEndExecute[ 
                                      FrontEndToken[ "ClearCellOptions"]], 
                                    Throw[ Null]]]], 
                              MatchQ[ readitem, 
                                Cell[ 
                                  Blank[ CellGroupData], 
                                  BlankNullSequence[ ]]], 
                              CompoundExpression[ 
                                FrontEndExecute[ 
                                  FrontEndToken[ "ClearCellOptions"]], 
                                Throw[ Null]], 
                              Or[ 
                                MatchQ[ readitem, 
                                  Cell[ 
                                    Blank[ GraphicsData], 
                                    BlankNullSequence[ ]]], 
                                SameQ[ 
                                  Head[ readitem], GraphicsData]], 
                              Throw[ Null], 
                              MatchQ[ readitem, 
                                Blank[ String]], 
                              If[ 
                                
                                MemberQ[ {{"Graphics"}, "Graphics3D", {
                                  "SurfaceGraphics"}, {"DensityGraphics"}, {
                                  "ContourGraphics"}}, 
                                  Cases[ 
                                    CompoundExpression[ 
                                      LinkWrite[ $ParentLink, 
                                        CellInformation[ 
                                        InputNotebook[ ]]], 
                                      LinkRead[ $ParentLink]], ("Style" -> 
                                    Pattern[ x, 
                                      Blank[ ]]) -> x, 2]], 
                                Throw[ Null], 
                                Set[ readitem, 
                                  Cell[ 
                                    TextData[ {readitem}], "Text"]]], 
                              StringMatchQ[ 
                                ToString[ 
                                  Head[ readitem]], 
                                StringExpression[ 
                                  BlankSequence[ ], "Box"]], 
                              Set[ readitem, 
                                Cell[ 
                                  TextData[ {
                                    Cell[ 
                                      BoxData[ {readitem}], "Text"]}], 
                                  "Text"]], 
                              MatchQ[ readitem, 
                                BoxData[ 
                                  Alternatives[ 
                                    Blank[ Graphics3D], 
                                    Blank[ SurfaceGraphics]]]], 
                              Throw[ Null], 
                              MatchQ[ readitem, 
                                Alternatives[ 
                                  Blank[ BoxData], 
                                  Blank[ GraphicsData]]], 
                              Set[ readitem, 
                                Cell[ 
                                  TextData[ {
                                    Cell[ readitem]}], "Text"]]], 
                            Which[ 
                              MatchQ[ readitem, 
                                Cell[ 
                                  BoxData[ 
                                    Alternatives[ 
                                      Blank[ Graphics3D], 
                                      Blank[ SurfaceGraphics]]], 
                                  BlankNullSequence[ ]]], 
                              Throw[ Null], 
                              MatchQ[ readitem, 
                                Cell[ 
                                  Blank[ BoxData], 
                                  BlankNullSequence[ ]]], 
                              Set[ readitem, 
                                Cell[ 
                                  TextData[ {readitem}], 
                                  Apply[ Sequence, 
                                    Drop[ readitem, 1]]]]], 
                            Set[ readitem, 
                              ReplaceRepeated[ readitem, {(Condition[ 
                                  Pattern[ x1, 
                                    Blank[ ]], 
                                  
                                  MemberQ[ {FontColor, FontFamily, 
                                    FontProperties, FontSize, FontSlant, 
                                    FontTracking, FontVariations, FontWeight, 
                                    Background}, x1]] -> Blank[ ]) -> 
                                Sequence[ ], StyleBox[ 
                                  Pattern[ l1, 
                                    Blank[ ]], 
                                  BlankNullSequence[ ]] :> l1, 
                                CompoundExpression[ BoxData[ 
                                    Pattern[ a1, 
                                      Blank[ String]]] :> BoxData[ {
                                    RowBox[ a1]}], BoxData[ 
                                    RowBox[ 
                                      Pattern[ a1, 
                                        BlankSequence[ ]]]] :> BoxData[ {
                                    RowBox[ a1]}]], FormBox[ 
                                  Pattern[ a1, 
                                    Blank[ List]], 
                                  Pattern[ b1, 
                                    Blank[ ]]] :> RowBox[ a1], FormBox[ 
                                  Pattern[ a1, 
                                    BlankSequence[ ]], 
                                  Pattern[ b1, 
                                    Blank[ ]]] :> RowBox[ {a1}], ErrorBox[ 
                                  Pattern[ a1, 
                                    BlankSequence[ ]]] :> a1}]], 
                            Set[ readitem, 
                              ReplaceAll[ readitem, {BoxData[ {
                                  Pattern[ a1, 
                                    BlankNullSequence[ ]], 
                                  "\[IndentingNewLine]", 
                                  Pattern[ b1, 
                                    BlankNullSequence[ ]]}] :> ReplaceAll[ 
                                  BoxData[ {
                                    
                                    RowBox[ {a1, "\[IndentingNewLine]", 
                                      b1}]}], {"\[IndentingNewLine]" -> 
                                  Sequence[ " ", "\[IndentingNewLine]"]}]}]], 
                            
                            Set[ readitem, 
                              ReplaceAll[ readitem, {Condition[ 
                                  BoxData[ {
                                    Pattern[ a1, 
                                      Blank[ ]], 
                                    Pattern[ b1, 
                                      BlankNullSequence[ ]], 
                                    Pattern[ c1, 
                                      Blank[ ]], 
                                    Pattern[ d1, 
                                      BlankNullSequence[ ]]}], 
                                  And[ 
                                    Not[ 
                                      MemberQ[ {b1}, "\n"]], 
                                    Not[ 
                                      MemberQ[ {b1}, "\[IndentingNewLine]"]], 
                                    
                                    
                                    MemberQ[ {"\n", "\[IndentingNewLine]"}, 
                                      c1]]] :> BoxData[ {
                                  RowBox[ {a1, 
                                    Apply[ Sequence, 
                                      Map[ 
                                      Apply[ Sequence, {"\n", #}]&, {b1}]], 
                                    c1, d1}]}], BoxData[ {
                                  Pattern[ a1, 
                                    Blank[ ]], 
                                  Pattern[ b1, 
                                    BlankSequence[ ]]}] :> BoxData[ {
                                  RowBox[ {a1, 
                                    Apply[ Sequence, 
                                      Map[ 
                                      Apply[ Sequence, {"\n", #}]&, {
                                        b1}]]}]}], BoxData[ {
                                  RowBox[ 
                                    Pattern[ a1, 
                                      BlankSequence[ ]]]}] :> BoxData[ {
                                  RowBox[ a1]}], BoxData[ {
                                  Pattern[ a1, 
                                    Blank[ ]]}] :> BoxData[ {
                                  RowBox[ {a1}]}]}]], 
                            Set[ readitem, 
                              ReplaceRepeated[ readitem, {RowBox[ {
                                  Pattern[ c1, 
                                    BlankNullSequence[ ]], 
                                  Pattern[ a1, 
                                    Blank[ String]], 
                                  Pattern[ b1, 
                                    Blank[ String]], 
                                  Pattern[ d1, 
                                    BlankNullSequence[ ]]}] :> RowBox[ {c1, 
                                  StringJoin[ a1, b1], d1}], RowBox[ {
                                  Pattern[ a1, 
                                    BlankNullSequence[ ]], 
                                  RowBox[ {
                                    Pattern[ b1, 
                                      BlankNullSequence[ ]]}], 
                                  Pattern[ c1, 
                                    BlankNullSequence[ ]]}] :> 
                                RowBox[ {a1, b1, c1}], BoxData[ 
                                  Pattern[ a1, 
                                    Blank[ String]]] :> TextData[ {a1}], 
                                BoxData[ 
                                  RowBox[ 
                                    Pattern[ a1, 
                                      BlankSequence[ ]]]] :> BoxData[ {
                                  RowBox[ a1]}], GridBox[ {
                                  Pattern[ a1, 
                                    BlankNullSequence[ ]], {
                                  Pattern[ c1, 
                                    BlankNullSequence[ ]], {
                                  Pattern[ d1, 
                                    BlankNullSequence[ ]]}, 
                                  Pattern[ e1, 
                                    BlankNullSequence[ ]]}, 
                                  Pattern[ b1, 
                                    BlankNullSequence[ ]]}, 
                                  Pattern[ f1, 
                                    BlankNullSequence[ ]]] :> 
                                GridBox[ {a1, {c1, 
                                  RowBox[ {d1}], e1}, b1}, f1], TextData[ {
                                  Pattern[ a1, 
                                    BlankNullSequence[ ]], 
                                  Cell[ 
                                    TextData[ {
                                      Pattern[ b1, 
                                        BlankSequence[ ]]}], 
                                    BlankNullSequence[ ]], 
                                  Pattern[ c1, 
                                    BlankNullSequence[ ]]}] :> 
                                TextData[ {a1, b1, c1}], TextData[ 
                                  Cell[ 
                                    TextData[ {
                                      Pattern[ a1, 
                                        BlankSequence[ ]]}], 
                                    BlankNullSequence[ ]]] :> 
                                TextData[ {a1}]}]], 
                            Set[ readitem, 
                              ReplaceRepeated[ readitem, {Cell[ 
                                  BoxData[ {
                                    RowBox[ 
                                      Pattern[ a1, 
                                        Blank[ List]]]}], 
                                  BlankNullSequence[ ]] :> Apply[ Sequence, 
                                  Map[ Cell[ 
                                      BoxData[ {#}], "Text"]&, a1]]}]], 
                            Set[ readitem, 
                              ReplaceRepeated[ readitem, {TextData[ {
                                  Pattern[ b1, 
                                    BlankNullSequence[ ]], 
                                  Cell[ 
                                    BoxData[ 
                                      Pattern[ a1, 
                                        Blank[ String]]], 
                                    BlankNullSequence[ ]], 
                                  Pattern[ c1, 
                                    BlankNullSequence[ ]]}] :> 
                                TextData[ {b1, a1, c1}], TextData[ {
                                  Pattern[ b1, 
                                    BlankNullSequence[ ]], 
                                  Cell[ 
                                    BoxData[ {
                                      Pattern[ a1, 
                                        Blank[ String]]}], 
                                    BlankNullSequence[ ]], 
                                  Pattern[ c1, 
                                    BlankNullSequence[ ]]}] :> 
                                TextData[ {b1, a1, c1}], TextData[ 
                                  Cell[ 
                                    BoxData[ 
                                      Pattern[ a1, 
                                        Blank[ String]]], 
                                    BlankNullSequence[ ]]] :> 
                                TextData[ {a1}]}]], 
                            Set[ readitem, 
                              ReplaceRepeated[ readitem, {TextData[ {
                                  Pattern[ b1, 
                                    BlankNullSequence[ ]], 
                                  Pattern[ a1, 
                                    Blank[ String]], 
                                  Pattern[ d1, 
                                    Blank[ String]], 
                                  Pattern[ c1, 
                                    BlankNullSequence[ ]]}] :> 
                                TextData[ {b1, 
                                  StringJoin[ a1, d1], c1}]}]], 
                            If[ 
                              Not[ 
                                MatchQ[ readitem, 
                                  Blank[ Cell]]], 
                              Set[ readitem, 
                                Cell[ readitem, "Text"]]], 
                            Set[ readitem, 
                              ReplaceAll[ readitem, {Cell[ 
                                  TextData[ {
                                    Cell[ 
                                      BoxData[ 
                                        Pattern[ al, 
                                        BlankSequence[ ]]], 
                                      BlankNullSequence[ ]]}], 
                                  Pattern[ b1, 
                                    BlankNullSequence[ ]]] :> Cell[ 
                                  BoxData[ al], b1]}]], 
                            Set[ readitem, 
                              ReplaceAll[ readitem, {Condition[ 
                                  BoxData[ 
                                    Pattern[ x, 
                                      Blank[ ]]], 
                                  And[ 
                                    UnsameQ[ 
                                      Head[ x], List], 
                                    UnsameQ[ 
                                      Head[ x], Graphics3D], 
                                    UnsameQ[ 
                                      Head[ x], SurfaceGraphics]]] :> 
                                BoxData[ {x}]}]], 
                            NotebookWrite[ 
                              InputNotebook[ ], readitem, All], 
                            If[ 
                              SameQ[ cellinfo, "CellBracket"], 
                              CompoundExpression[ 
                                SelectionMove[ 
                                  InputNotebook[ ], All, CellContents], 
                                NotebookWrite[ 
                                  InputNotebook[ ], readitem, All]]]]]]],
                  ButtonEvaluator->Automatic,
                  Active->True,
                  ButtonFrame->"DialogBox",
                  Background->RGBColor[0.949996, 0.949996, 1]]}
              },
            ColumnSpacings->0]},
        {GridBox[{
              {
                ButtonBox[
                  
                  StyleBox[\(\(\[MediumSpace]\)\(\(Black\)\(\[MediumSpace]\)\)\
\),
                    FontFamily->"Helvetica",
                    FontSize->11,
                    FontWeight->"Bold",
                    FontColor->GrayLevel[0]],
                  ButtonFunction:>SetOptions[ 
                      NotebookSelection[ 
                        InputNotebook[ ]], FontColor -> RGBColor[ 0, 0, 0]],
                  ButtonEvaluator->None,
                  ButtonData:>"Text",
                  ButtonExpandable->True,
                  ButtonMargins->5,
                  ButtonFrame->"DialogBox",
                  Background->GrayLevel[0.900008]], 
                ButtonBox[
                  StyleBox[\(\(\[MediumSpace]\)\(Red\)\),
                    FontFamily->"Helvetica",
                    FontSize->11,
                    FontWeight->"Bold",
                    FontColor->RGBColor[1, 0, 0]],
                  ButtonFunction:>SetOptions[ 
                      NotebookSelection[ 
                        InputNotebook[ ]], FontColor -> RGBColor[ 1, 0, 0]],
                  ButtonEvaluator->None,
                  ButtonData:>"Text",
                  ButtonExpandable->True,
                  ButtonMargins->5,
                  ButtonFrame->"DialogBox",
                  Background->GrayLevel[0.900008]], 
                ButtonBox[
                  StyleBox[\(\(\ \)\(Green\)\(\ \)\),
                    FontFamily->"Helvetica",
                    FontSize->11,
                    FontWeight->"Bold",
                    FontColor->RGBColor[0, 0.6, 0]],
                  ButtonFunction:>SetOptions[ 
                      NotebookSelection[ 
                        InputNotebook[ ]], FontColor -> RGBColor[ 
                      0, .59999999999999998, 0]],
                  ButtonEvaluator->None,
                  ButtonData:>"Text",
                  ButtonExpandable->True,
                  ButtonMargins->5,
                  ButtonFrame->"DialogBox",
                  Background->GrayLevel[0.900008]], 
                ButtonBox[
                  StyleBox[\(\(Blue\)\(\ \)\),
                    FontFamily->"Helvetica",
                    FontSize->11,
                    FontWeight->"Bold",
                    FontColor->RGBColor[0, 0, 1]],
                  ButtonFunction:>SetOptions[ 
                      NotebookSelection[ 
                        InputNotebook[ ]], FontColor -> RGBColor[ 0, 0, 1]],
                  ButtonEvaluator->None,
                  ButtonData:>"Text",
                  ButtonExpandable->True,
                  ButtonMargins->5,
                  ButtonFrame->"DialogBox",
                  Background->GrayLevel[0.900008]], 
                ButtonBox[
                  StyleBox["Search",
                    FontFamily->"Courier",
                    FontSize->11,
                    FontWeight->"Bold",
                    FontColor->GrayLevel[0]],
                  ButtonEvaluator->Automatic,
                  ButtonData:>Module[ {readitem}, 
                      CompoundExpression[ 
                        Set[ readitem, 
                          NotebookRead[ 
                            InputNotebook[ ]]], 
                        Catch[ 
                          CompoundExpression[ 
                            Which[ 
                              SameQ[ readitem, {}], 
                              Throw[ Null], 
                              Greater[ 
                                Count[ readitem, 
                                  Blank[ InterpretationBox], Infinity], 0], 
                              Throw[ Null], 
                              UnsameQ[ 
                                Cases[ readitem, 
                                  FormBox[ 
                                    BoxData[ 
                                      BlankNullSequence[ ]], 
                                    BlankNullSequence[ ]]], {}], 
                              Throw[ Null], 
                              ListQ[ readitem], 
                              Set[ readitem, 
                                ReplaceRepeated[ 
                                  Cell[ 
                                    TextData[ readitem], "Text"], {Cell[ 
                                    CellGroupData[ {
                                      Pattern[ a1, 
                                        BlankSequence[ ]]}, 
                                      BlankNullSequence[ ]], 
                                    BlankNullSequence[ ]] :> Sequence[ a1]}]],
                               
                              MatchQ[ readitem, 
                                Blank[ String]], 
                              Set[ readitem, 
                                Cell[ 
                                  TextData[ {readitem}], "Text"]], 
                              StringMatchQ[ 
                                ToString[ 
                                  Head[ readitem]], 
                                StringExpression[ 
                                  BlankSequence[ ], "Box"]], 
                              Set[ readitem, 
                                Cell[ 
                                  TextData[ {
                                    Cell[ 
                                      BoxData[ {readitem}], "Text"]}], 
                                  "Text"]]], 
                            Which[ 
                              MatchQ[ readitem, 
                                Alternatives[ 
                                  Cell[ 
                                    Blank[ GraphicsData], 
                                    BlankNullSequence[ ]], 
                                  Blank[ GraphicsData]]], 
                              Throw[ Null], 
                              MatchQ[ readitem, 
                                Blank[ BoxData]], 
                              Set[ readitem, 
                                Cell[ 
                                  TextData[ {
                                    Cell[ readitem]}], "Text"]], 
                              MatchQ[ readitem, 
                                Cell[ 
                                  Blank[ BoxData], 
                                  BlankNullSequence[ ]]], 
                              Set[ readitem, 
                                Cell[ 
                                  TextData[ {readitem}], "Text"]], 
                              MatchQ[ readitem, 
                                Cell[ 
                                  Blank[ CellGroupData], 
                                  BlankNullSequence[ ]]], 
                              Set[ readitem, 
                                Cell[ 
                                  TextData[ 
                                    Part[ readitem, 1, 1]], "Text"]], 
                              MatchQ[ readitem, 
                                Blank[ TextData]], 
                              Set[ readitem, 
                                Cell[ readitem, "Text"]]], 
                            Set[ readitem, 
                              ReplaceRepeated[ 
                                ReplaceAll[ readitem, {TextData[ 
                                    Pattern[ a, 
                                      Blank[ String]]] :> TextData[ {a}], 
                                  Cell[ 
                                    Pattern[ a, 
                                      Blank[ String]], 
                                    BlankNullSequence[ ]] :> Cell[ 
                                    TextData[ {a}], "Text"], Condition[ 
                                    BoxData[ 
                                      Pattern[ x, 
                                        Blank[ ]]], 
                                    UnsameQ[ 
                                      Head[ x], List]] :> BoxData[ {x}]}], {
                                TextData[ {
                                  Pattern[ a1, 
                                    BlankNullSequence[ ]], 
                                  Pattern[ b1, 
                                    Blank[ ButtonBox]], 
                                  Pattern[ c1, 
                                    BlankNullSequence[ ]]}] :> 
                                TextData[ {a1, 
                                  Cell[ 
                                    BoxData[ {b1}], "Input"], c1}]}]], 
                            Set[ readitem, 
                              ReplaceAll[ readitem, {RowBox[ {"(*", 
                                  Pattern[ a1, 
                                    BlankNullSequence[ ]], "*)"}] :> 
                                RowBox[ {
                                  RowBox[ {"(", 
                                    FromCharacterCode[ 34], 
                                    Apply[ Sequence, 
                                      ReplaceAll[ {a1}, {Pattern[ x, 
                                        Blank[ String]] :> StringReplace[ 
                                        x, {FromCharacterCode[ 34] -> "\\\"", 
                                        "\\" -> "\\\\"}]}]], 
                                    FromCharacterCode[ 34], ")"}], ";"}]}]], 
                            Set[ readitem, 
                              ReplaceRepeated[ 
                                ReplaceRepeated[ 
                                  ReplaceRepeated[ readitem, {Condition[ 
                                      RowBox[ {
                                        Pattern[ g1, 
                                        Blank[ ]], 
                                        Pattern[ g2, 
                                        BlankNullSequence[ ]]}], 
                                      Not[ 
                                        
                                        MemberQ[ {String, List, RowBox, 
                                        FormBox}, 
                                        Head[ g1]]]] :> Block[ {
                                      Set[ $Messages, {}]}, 
                                      Check[ 
                                        StringDrop[ 
                                        StringDrop[ 
                                        ToString[ 
                                        InputForm[ 
                                        FullForm[ 
                                        ToExpression[ 
                                        StringJoin[ "\!", 
                                        ToString[ 
                                        RowBox[ {"HoldComplete", "[", 
                                        RowBox[ {g1, g2}], "]"}], 
                                        InputForm]]]]]], 22], -2], 
                                        RowBox[ {g1, g2}]]]}], {StyleBox[ 
                                    Pattern[ a1, 
                                      Blank[ ]], 
                                    BlankNullSequence[ ]] :> a1, FormBox[ 
                                    Pattern[ a1, 
                                      Blank[ List]], 
                                    Pattern[ b1, 
                                      Blank[ ]]] :> RowBox[ a1], FormBox[ 
                                    Pattern[ a1, 
                                      BlankSequence[ ]], 
                                    Pattern[ b1, 
                                      Blank[ ]]] :> RowBox[ {a1}]}], {
                                RowBox[ {
                                  Pattern[ g1, 
                                    BlankNullSequence[ ]], {
                                  Pattern[ g2, 
                                    Blank[ ]]}, 
                                  Pattern[ g3, 
                                    BlankNullSequence[ ]]}] :> 
                                RowBox[ {g1, g2, g3}]}]], 
                            Set[ readitem, 
                              ReplaceRepeated[ readitem, {RowBox[ {
                                  Pattern[ c1, 
                                    BlankNullSequence[ ]], 
                                  Pattern[ a1, 
                                    Blank[ String]], 
                                  Pattern[ b1, 
                                    Blank[ String]], 
                                  Pattern[ d1, 
                                    BlankNullSequence[ ]]}] :> RowBox[ {c1, 
                                  StringJoin[ a1, " ", b1], d1}], BoxData[ {
                                  Pattern[ a1, 
                                    Blank[ ]], 
                                  Pattern[ b1, 
                                    Blank[ ]], 
                                  Pattern[ c1, 
                                    BlankNullSequence[ ]]}] :> BoxData[ {
                                  RowBox[ {a1, "\n", b1}], c1}], BoxData[ {
                                  Pattern[ a1, 
                                    Blank[ String]]}] :> TextData[ {a1}]}]], 
                            Set[ readitem, 
                              ReplaceRepeated[ readitem, {BoxData[ {
                                  Pattern[ x, 
                                    Blank[ ]]}, 
                                  BlankNullSequence[ ]] :> Block[ {
                                  Set[ $Messages, {}]}, 
                                  Check[ 
                                    TextData[ {
                                      StringDrop[ 
                                        StringDrop[ 
                                        ToString[ 
                                        InputForm[ 
                                        FullForm[ 
                                        ToExpression[ 
                                        StringJoin[ "\!", 
                                        ToString[ 
                                        
                                        RowBox[ {"HoldComplete", "[", x, 
                                        "]"}], InputForm]]]]]], 22], -2]}], 
                                    ReplaceRepeated[ 
                                      ReplaceRepeated[ 
                                        ReplaceRepeated[ 
                                        BoxData[ {x}], {(Condition[ 
                                        Pattern[ x1, 
                                        Blank[ ]], 
                                        
                                        MemberQ[ {FontColor, FontFamily, 
                                        FontProperties, FontSize, FontSlant, 
                                        FontTracking, FontVariations, 
                                        FontWeight, Background}, x1]] -> 
                                        Blank[ ]) :> Sequence[ ], StyleBox[ 
                                        Pattern[ l1, 
                                        Blank[ ]], 
                                        BlankNullSequence[ ]] :> l1, 
                                        RowBox[ {
                                        Pattern[ c1, 
                                        BlankNullSequence[ ]], 
                                        Pattern[ a1, 
                                        Blank[ String]], 
                                        Pattern[ b1, 
                                        Blank[ String]], 
                                        Pattern[ d1, 
                                        BlankNullSequence[ ]]}] :> 
                                        RowBox[ {c1, 
                                        StringJoin[ a1, " ", b1], d1}], 
                                        RowBox[ {
                                        Pattern[ a1, 
                                        BlankNullSequence[ ]], 
                                        RowBox[ {
                                        Pattern[ b1, 
                                        BlankNullSequence[ ]]}], 
                                        Pattern[ c1, 
                                        BlankNullSequence[ ]]}] :> 
                                        RowBox[ {a1, " ", b1, " ", c1}], 
                                        BoxData[ 
                                        Pattern[ a1, 
                                        Blank[ String]]] :> TextData[ {a1}], 
                                        BoxData[ {
                                        Pattern[ a1, 
                                        Blank[ ]], 
                                        Pattern[ b1, 
                                        Blank[ ]], 
                                        Pattern[ c1, 
                                        BlankNullSequence[ ]]}] :> BoxData[ {
                                        RowBox[ {a1, "\n", b1}], c1}], 
                                        FormBox[ 
                                        Pattern[ a1, 
                                        Blank[ List]], 
                                        Pattern[ b1, 
                                        Blank[ ]]] :> RowBox[ a1], FormBox[ 
                                        Pattern[ a1, 
                                        BlankSequence[ ]], 
                                        Pattern[ b1, 
                                        Blank[ ]]] :> RowBox[ {a1}], 
                                        GridBox[ {
                                        Pattern[ a1, 
                                        BlankNullSequence[ ]], {
                                        Pattern[ c1, 
                                        BlankNullSequence[ ]], {
                                        Pattern[ d1, 
                                        BlankNullSequence[ ]]}, 
                                        Pattern[ e1, 
                                        BlankNullSequence[ ]]}, 
                                        Pattern[ b1, 
                                        BlankNullSequence[ ]]}, 
                                        Pattern[ f1, 
                                        BlankNullSequence[ ]]] :> 
                                        GridBox[ {a1, {c1, 
                                        RowBox[ {d1}], e1}, b1}, f1]}], {
                                        BoxData[ {
                                        RowBox[ 
                                        Pattern[ a1, 
                                        Blank[ List]]]}] :> TextData[ 
                                        Map[ Cell[ 
                                        BoxData[ {#}]]&, a1]]}], {TextData[ {
                                        Pattern[ b1, 
                                        BlankNullSequence[ ]], 
                                        Cell[ 
                                        BoxData[ {
                                        Pattern[ a1, 
                                        Blank[ String]]}], 
                                        BlankNullSequence[ ]], 
                                        Pattern[ c1, 
                                        BlankNullSequence[ ]]}] :> 
                                      TextData[ {b1, a1, " ", c1}]}]]]}]], 
                            Set[ readitem, 
                              ReplaceRepeated[ readitem, {BoxData[ {
                                  Pattern[ x, 
                                    Blank[ ]]}, 
                                  BlankNullSequence[ ]] :> TextData[ {
                                  ToString[ 
                                    ReplaceAll[ x, {Pattern[ a1, 
                                        Blank[ String]] :> StringJoin[ "\"", 
                                        StringReplace[ 
                                        a1, {FromCharacterCode[ 34] -> "\\\"",
                                         "\\" -> "\\\\"}], "\""]}]]}]}]], 
                            Set[ readitem, 
                              ReplaceAll[ 
                              readitem, {GraphicsData[ "PostScript", 
                                  Pattern[ graphics, 
                                    Blank[ String]]] :> TextData[ {""}]}]], 
                            Set[ readitem, 
                              ReplaceRepeated[ readitem, {(Condition[ 
                                  Pattern[ x1, 
                                    Blank[ ]], 
                                  
                                  MemberQ[ {FontColor, FontFamily, 
                                    FontProperties, FontSize, FontSlant, 
                                    FontTracking, FontVariations, FontWeight, 
                                    Background}, x1]] -> Blank[ ]) :> 
                                Sequence[ ], StyleBox[ 
                                  Pattern[ l1, 
                                    Blank[ ]], 
                                  BlankNullSequence[ ]] :> l1, TextData[ {
                                  Pattern[ a1, 
                                    BlankNullSequence[ ]], 
                                  Cell[ 
                                    TextData[ {
                                      Pattern[ b1, 
                                        BlankSequence[ ]]}], 
                                    BlankNullSequence[ ]], 
                                  Pattern[ c1, 
                                    BlankNullSequence[ ]]}] :> 
                                TextData[ {a1, " ", b1, " ", c1}], TextData[ 
                                  Cell[ 
                                    TextData[ {
                                      Pattern[ a1, 
                                        BlankSequence[ ]]}], 
                                    BlankNullSequence[ ]]] :> TextData[ {a1}],
                                 Cell[ 
                                  CellGroupData[ {
                                    Cell[ 
                                      Pattern[ a, 
                                        BlankSequence[ ]]]}, 
                                    BlankNullSequence[ ]]] :> Cell[ a], {
                                Pattern[ a1, 
                                  BlankNullSequence[ ]], 
                                Cell[ 
                                  TextData[ {
                                    Pattern[ b1, 
                                      BlankSequence[ ]]}], 
                                  BlankNullSequence[ ]], 
                                Cell[ 
                                  TextData[ {
                                    Pattern[ c1, 
                                      BlankSequence[ ]]}], 
                                  BlankNullSequence[ ]], 
                                Pattern[ d1, 
                                  BlankNullSequence[ ]]} :> {a1, 
                                Cell[ 
                                  TextData[ {b1, "\n", c1}], "Text"], d1}}]], 
                            
                            Set[ readitem, 
                              ReplaceRepeated[ readitem, {TextData[ {
                                  Pattern[ b1, 
                                    BlankNullSequence[ ]], 
                                  Pattern[ a1, 
                                    Blank[ String]], 
                                  Pattern[ d1, 
                                    Blank[ String]], 
                                  Pattern[ c1, 
                                    BlankNullSequence[ ]]}] :> 
                                TextData[ {b1, 
                                  StringJoin[ a1, " ", d1], c1}]}]], 
                            Set[ readitem, 
                              ReplaceAll[ readitem, {Cell[ 
                                  TextData[ {
                                    Pattern[ a, 
                                      Blank[ ]]}], 
                                  Pattern[ b, 
                                    BlankSequence[ ]]] :> a}]], 
                            Set[ readitem, 
                              ReplaceAll[ 
                                ReplaceAll[ 
                                  Union[ 
                                    Flatten[ 
                                      StringCases[ readitem, 
                                        Repeated[ WordCharacter]]]], {
                                  Condition[ 
                                    Pattern[ a1, 
                                      Blank[ String]], 
                                    StringMatchQ[ a1, NumberString]] :> 
                                  Sequence[ ], Condition[ 
                                    Pattern[ a1, 
                                      Blank[ String]], 
                                    Equal[ 
                                      StringLength[ a1], 1]] :> 
                                  Sequence[ ]}], {{
                                Pattern[ a, 
                                  BlankNullSequence[ String]], 
                                Pattern[ b, 
                                  Blank[ String]]} :> StringJoin[ {
                                  Apply[ Sequence, 
                                    Flatten[ 
                                      Map[ {#, "+"}&, {a}]]], b}]}]], 
                            If[ 
                              SameQ[ readitem, {}], 
                              Set[ readitem, {""}]], 
                            Set[ readitem, 
                              StringJoin[ 
                              "http://www.google.com/search?hl=en&q=", 
                                StringReplace[ readitem, " " -> "+"], 
                                "+inurl%3Amathematica+site%3Adocuments.\
wolfram.com&btnG=S%C3%B6k&meta="]], {
                            URL[ readitem], None}]]]],
                  ButtonStyle->"Hyperlink",
                  ButtonFrame->"DialogBox"]}
              },
            ColumnSpacings->0.4]},
        {GridBox[{
              {
                ButtonBox[
                  StyleBox["B",
                    FontFamily->"Helvetica",
                    FontSize->11,
                    FontWeight->"Plain",
                    FontColor->GrayLevel[0]],
                  ButtonFunction:>SetOptions[ 
                      NotebookSelection[ 
                        InputNotebook[ ]], Background -> GrayLevel[ 1]],
                  ButtonEvaluator->None,
                  ButtonData:>"Text",
                  ButtonExpandable->True,
                  ButtonMargins->4,
                  ButtonFrame->"DialogBox",
                  Background->GrayLevel[1]], 
                ButtonBox[
                  StyleBox["A",
                    FontFamily->"Helvetica",
                    FontSize->11,
                    FontWeight->"Plain",
                    FontColor->GrayLevel[0]],
                  ButtonFunction:>SetOptions[ 
                      NotebookSelection[ 
                        InputNotebook[ ]], Background -> 
                      GrayLevel[ .90000000000000002]],
                  ButtonEvaluator->None,
                  ButtonData:>"Text",
                  ButtonExpandable->True,
                  ButtonMargins->4,
                  ButtonFrame->"DialogBox",
                  Background->GrayLevel[0.900008]], 
                ButtonBox[
                  StyleBox["C",
                    FontFamily->"Helvetica",
                    FontSize->11,
                    FontWeight->"Plain",
                    FontColor->GrayLevel[0]],
                  ButtonFunction:>SetOptions[ 
                      NotebookSelection[ 
                        InputNotebook[ ]], Background -> 
                      GrayLevel[ .80000000000000004]],
                  ButtonEvaluator->None,
                  ButtonData:>"Text",
                  ButtonExpandable->True,
                  ButtonMargins->4,
                  ButtonFrame->"DialogBox",
                  Background->GrayLevel[0.8]], 
                ButtonBox[
                  StyleBox["K",
                    FontFamily->"Helvetica",
                    FontSize->11,
                    FontColor->GrayLevel[0]],
                  ButtonFunction:>SetOptions[ 
                      NotebookSelection[ 
                        InputNotebook[ ]], Background -> RGBColor[ 
                      1, .80000000000000004, .80000000000000004]],
                  ButtonEvaluator->None,
                  ButtonData:>"Text",
                  ButtonExpandable->True,
                  ButtonMargins->4,
                  ButtonFrame->"DialogBox",
                  Background->RGBColor[1, 0.8, 0.8]], 
                ButtonBox[
                  StyleBox["G",
                    FontFamily->"Helvetica",
                    FontSize->11,
                    FontColor->GrayLevel[0]],
                  ButtonFunction:>SetOptions[ 
                      NotebookSelection[ 
                        InputNotebook[ ]], Background -> 
                      RGBColor[ .80000000000000004, 1, .80000000000000004]],
                  ButtonEvaluator->None,
                  ButtonData:>"Text",
                  ButtonExpandable->True,
                  ButtonMargins->4,
                  ButtonFrame->"DialogBox",
                  Background->RGBColor[0.8, 1, 0.8]], 
                ButtonBox[
                  StyleBox["R",
                    FontFamily->"Helvetica",
                    FontSize->11,
                    FontColor->GrayLevel[0]],
                  ButtonFunction:>SetOptions[ 
                      NotebookSelection[ 
                        InputNotebook[ ]], Background -> 
                      RGBColor[ .80000000000000004, .80000000000000004, 1]],
                  ButtonEvaluator->None,
                  ButtonData:>"Text",
                  ButtonExpandable->True,
                  ButtonMargins->4,
                  ButtonFrame->"DialogBox",
                  Background->RGBColor[0.8, 0.8, 1]], 
                ButtonBox[
                  StyleBox["O",
                    FontFamily->"Helvetica",
                    FontSize->11,
                    FontColor->GrayLevel[0]],
                  ButtonFunction:>SetOptions[ 
                      NotebookSelection[ 
                        InputNotebook[ ]], Background -> 
                      RGBColor[ .80000000000000004, 1, 1]],
                  ButtonEvaluator->None,
                  ButtonData:>"Text",
                  ButtonExpandable->True,
                  ButtonMargins->4,
                  ButtonFrame->"DialogBox",
                  Background->RGBColor[0.8, 1, 1]], 
                ButtonBox[
                  StyleBox["U",
                    FontFamily->"Helvetica",
                    FontSize->11,
                    FontColor->GrayLevel[0]],
                  ButtonFunction:>SetOptions[ 
                      NotebookSelection[ 
                        InputNotebook[ ]], Background -> RGBColor[ 
                      1, .80000000000000004, 1]],
                  ButtonEvaluator->None,
                  ButtonData:>"Text",
                  ButtonExpandable->True,
                  ButtonMargins->4,
                  ButtonFrame->"DialogBox",
                  Background->RGBColor[1, 0.8, 1]], 
                ButtonBox[
                  StyleBox["N",
                    FontFamily->"Helvetica",
                    FontSize->11,
                    FontColor->GrayLevel[0]],
                  ButtonFunction:>SetOptions[ 
                      NotebookSelection[ 
                        InputNotebook[ ]], Background -> RGBColor[ 
                      1, 1, .80000000000000004]],
                  ButtonEvaluator->None,
                  ButtonData:>"Text",
                  ButtonExpandable->True,
                  ButtonMargins->4,
                  ButtonFrame->"DialogBox",
                  Background->RGBColor[1, 1, 0.8]], 
                ButtonBox[
                  StyleBox["D",
                    FontFamily->"Helvetica",
                    FontSize->11,
                    FontColor->GrayLevel[0]],
                  ButtonFunction:>SetOptions[ 
                      NotebookSelection[ 
                        InputNotebook[ ]], Background -> 
                      RGBColor[ .80000000000000004, 1, 1]],
                  ButtonEvaluator->None,
                  ButtonData:>"Text",
                  ButtonExpandable->True,
                  ButtonMargins->4,
                  ButtonFrame->"DialogBox",
                  Background->RGBColor[0.8, 1, 1]], " ", 
                ButtonBox[
                  StyleBox["MG",
                    FontFamily->"Courier",
                    FontSize->11,
                    FontWeight->"Bold",
                    FontColor->GrayLevel[0]],
                  ButtonEvaluator->Automatic,
                  ButtonData:>Module[ {readitem}, 
                      CompoundExpression[ 
                        Set[ readitem, 
                          NotebookRead[ 
                            InputNotebook[ ]]], 
                        Catch[ 
                          CompoundExpression[ 
                            Which[ 
                              SameQ[ readitem, {}], 
                              Throw[ Null], 
                              Greater[ 
                                Count[ readitem, 
                                  Blank[ InterpretationBox], Infinity], 0], 
                              Throw[ Null], 
                              UnsameQ[ 
                                Cases[ readitem, 
                                  FormBox[ 
                                    BoxData[ 
                                      BlankNullSequence[ ]], 
                                    BlankNullSequence[ ]]], {}], 
                              Throw[ Null], 
                              ListQ[ readitem], 
                              Set[ readitem, 
                                ReplaceRepeated[ 
                                  Cell[ 
                                    TextData[ readitem], "Text"], {Cell[ 
                                    CellGroupData[ {
                                      Pattern[ a1, 
                                        BlankSequence[ ]]}, 
                                      BlankNullSequence[ ]], 
                                    BlankNullSequence[ ]] :> Sequence[ a1]}]],
                               
                              MatchQ[ readitem, 
                                Blank[ String]], 
                              Set[ readitem, 
                                Cell[ 
                                  TextData[ {readitem}], "Text"]], 
                              StringMatchQ[ 
                                ToString[ 
                                  Head[ readitem]], 
                                StringExpression[ 
                                  BlankSequence[ ], "Box"]], 
                              Set[ readitem, 
                                Cell[ 
                                  TextData[ {
                                    Cell[ 
                                      BoxData[ {readitem}], "Text"]}], 
                                  "Text"]]], 
                            Which[ 
                              MatchQ[ readitem, 
                                Alternatives[ 
                                  Cell[ 
                                    Blank[ GraphicsData], 
                                    BlankNullSequence[ ]], 
                                  Blank[ GraphicsData]]], 
                              Throw[ Null], 
                              MatchQ[ readitem, 
                                Blank[ BoxData]], 
                              Set[ readitem, 
                                Cell[ 
                                  TextData[ {
                                    Cell[ readitem]}], "Text"]], 
                              MatchQ[ readitem, 
                                Cell[ 
                                  Blank[ BoxData], 
                                  BlankNullSequence[ ]]], 
                              Set[ readitem, 
                                Cell[ 
                                  TextData[ {readitem}], "Text"]], 
                              MatchQ[ readitem, 
                                Cell[ 
                                  Blank[ CellGroupData], 
                                  BlankNullSequence[ ]]], 
                              Set[ readitem, 
                                Cell[ 
                                  TextData[ 
                                    Part[ readitem, 1, 1]], "Text"]], 
                              MatchQ[ readitem, 
                                Blank[ TextData]], 
                              Set[ readitem, 
                                Cell[ readitem, "Text"]]], 
                            Set[ readitem, 
                              ReplaceRepeated[ 
                                ReplaceAll[ readitem, {TextData[ 
                                    Pattern[ a, 
                                      Blank[ String]]] :> TextData[ {a}], 
                                  Cell[ 
                                    Pattern[ a, 
                                      Blank[ String]], 
                                    BlankNullSequence[ ]] :> Cell[ 
                                    TextData[ {a}], "Text"], Condition[ 
                                    BoxData[ 
                                      Pattern[ x, 
                                        Blank[ ]]], 
                                    UnsameQ[ 
                                      Head[ x], List]] :> BoxData[ {x}]}], {
                                TextData[ {
                                  Pattern[ a1, 
                                    BlankNullSequence[ ]], 
                                  Pattern[ b1, 
                                    Blank[ ButtonBox]], 
                                  Pattern[ c1, 
                                    BlankNullSequence[ ]]}] :> 
                                TextData[ {a1, 
                                  Cell[ 
                                    BoxData[ {b1}], "Input"], c1}]}]], 
                            Set[ readitem, 
                              ReplaceAll[ readitem, {RowBox[ {"(*", 
                                  Pattern[ a1, 
                                    BlankNullSequence[ ]], "*)"}] :> 
                                RowBox[ {
                                  RowBox[ {"(", 
                                    FromCharacterCode[ 34], 
                                    Apply[ Sequence, 
                                      ReplaceAll[ {a1}, {Pattern[ x, 
                                        Blank[ String]] :> StringReplace[ 
                                        x, {FromCharacterCode[ 34] -> "\\\"", 
                                        "\\" -> "\\\\"}]}]], 
                                    FromCharacterCode[ 34], ")"}], ";"}]}]], 
                            Set[ readitem, 
                              ReplaceRepeated[ 
                                ReplaceRepeated[ 
                                  ReplaceRepeated[ readitem, {Condition[ 
                                      RowBox[ {
                                        Pattern[ g1, 
                                        Blank[ ]], 
                                        Pattern[ g2, 
                                        BlankNullSequence[ ]]}], 
                                      Not[ 
                                        
                                        MemberQ[ {String, List, RowBox, 
                                        FormBox}, 
                                        Head[ g1]]]] :> Block[ {
                                      Set[ $Messages, {}]}, 
                                      Check[ 
                                        StringDrop[ 
                                        StringDrop[ 
                                        ToString[ 
                                        InputForm[ 
                                        FullForm[ 
                                        ToExpression[ 
                                        StringJoin[ "\!", 
                                        ToString[ 
                                        RowBox[ {"HoldComplete", "[", 
                                        RowBox[ {g1, g2}], "]"}], 
                                        InputForm]]]]]], 22], -2], 
                                        RowBox[ {g1, g2}]]]}], {StyleBox[ 
                                    Pattern[ a1, 
                                      Blank[ ]], 
                                    BlankNullSequence[ ]] :> a1, FormBox[ 
                                    Pattern[ a1, 
                                      Blank[ List]], 
                                    Pattern[ b1, 
                                      Blank[ ]]] :> RowBox[ a1], FormBox[ 
                                    Pattern[ a1, 
                                      BlankSequence[ ]], 
                                    Pattern[ b1, 
                                      Blank[ ]]] :> RowBox[ {a1}]}], {
                                RowBox[ {
                                  Pattern[ g1, 
                                    BlankNullSequence[ ]], {
                                  Pattern[ g2, 
                                    Blank[ ]]}, 
                                  Pattern[ g3, 
                                    BlankNullSequence[ ]]}] :> 
                                RowBox[ {g1, g2, g3}]}]], 
                            Set[ readitem, 
                              ReplaceRepeated[ readitem, {RowBox[ {
                                  Pattern[ c1, 
                                    BlankNullSequence[ ]], 
                                  Pattern[ a1, 
                                    Blank[ String]], 
                                  Pattern[ b1, 
                                    Blank[ String]], 
                                  Pattern[ d1, 
                                    BlankNullSequence[ ]]}] :> RowBox[ {c1, 
                                  StringJoin[ a1, " ", b1], d1}], BoxData[ {
                                  Pattern[ a1, 
                                    Blank[ ]], 
                                  Pattern[ b1, 
                                    Blank[ ]], 
                                  Pattern[ c1, 
                                    BlankNullSequence[ ]]}] :> BoxData[ {
                                  RowBox[ {a1, "\n", b1}], c1}], BoxData[ {
                                  Pattern[ a1, 
                                    Blank[ String]]}] :> TextData[ {a1}]}]], 
                            Set[ readitem, 
                              ReplaceRepeated[ readitem, {BoxData[ {
                                  Pattern[ x, 
                                    Blank[ ]]}, 
                                  BlankNullSequence[ ]] :> Block[ {
                                  Set[ $Messages, {}]}, 
                                  Check[ 
                                    TextData[ {
                                      StringDrop[ 
                                        StringDrop[ 
                                        ToString[ 
                                        InputForm[ 
                                        FullForm[ 
                                        ToExpression[ 
                                        StringJoin[ "\!", 
                                        ToString[ 
                                        
                                        RowBox[ {"HoldComplete", "[", x, 
                                        "]"}], InputForm]]]]]], 22], -2]}], 
                                    ReplaceRepeated[ 
                                      ReplaceRepeated[ 
                                        ReplaceRepeated[ 
                                        BoxData[ {x}], {(Condition[ 
                                        Pattern[ x1, 
                                        Blank[ ]], 
                                        
                                        MemberQ[ {FontColor, FontFamily, 
                                        FontProperties, FontSize, FontSlant, 
                                        FontTracking, FontVariations, 
                                        FontWeight, Background}, x1]] -> 
                                        Blank[ ]) :> Sequence[ ], StyleBox[ 
                                        Pattern[ l1, 
                                        Blank[ ]], 
                                        BlankNullSequence[ ]] :> l1, 
                                        RowBox[ {
                                        Pattern[ c1, 
                                        BlankNullSequence[ ]], 
                                        Pattern[ a1, 
                                        Blank[ String]], 
                                        Pattern[ b1, 
                                        Blank[ String]], 
                                        Pattern[ d1, 
                                        BlankNullSequence[ ]]}] :> 
                                        RowBox[ {c1, 
                                        StringJoin[ a1, " ", b1], d1}], 
                                        RowBox[ {
                                        Pattern[ a1, 
                                        BlankNullSequence[ ]], 
                                        RowBox[ {
                                        Pattern[ b1, 
                                        BlankNullSequence[ ]]}], 
                                        Pattern[ c1, 
                                        BlankNullSequence[ ]]}] :> 
                                        RowBox[ {a1, " ", b1, " ", c1}], 
                                        BoxData[ 
                                        Pattern[ a1, 
                                        Blank[ String]]] :> TextData[ {a1}], 
                                        BoxData[ {
                                        Pattern[ a1, 
                                        Blank[ ]], 
                                        Pattern[ b1, 
                                        Blank[ ]], 
                                        Pattern[ c1, 
                                        BlankNullSequence[ ]]}] :> BoxData[ {
                                        RowBox[ {a1, "\n", b1}], c1}], 
                                        FormBox[ 
                                        Pattern[ a1, 
                                        Blank[ List]], 
                                        Pattern[ b1, 
                                        Blank[ ]]] :> RowBox[ a1], FormBox[ 
                                        Pattern[ a1, 
                                        BlankSequence[ ]], 
                                        Pattern[ b1, 
                                        Blank[ ]]] :> RowBox[ {a1}], 
                                        GridBox[ {
                                        Pattern[ a1, 
                                        BlankNullSequence[ ]], {
                                        Pattern[ c1, 
                                        BlankNullSequence[ ]], {
                                        Pattern[ d1, 
                                        BlankNullSequence[ ]]}, 
                                        Pattern[ e1, 
                                        BlankNullSequence[ ]]}, 
                                        Pattern[ b1, 
                                        BlankNullSequence[ ]]}, 
                                        Pattern[ f1, 
                                        BlankNullSequence[ ]]] :> 
                                        GridBox[ {a1, {c1, 
                                        RowBox[ {d1}], e1}, b1}, f1]}], {
                                        BoxData[ {
                                        RowBox[ 
                                        Pattern[ a1, 
                                        Blank[ List]]]}] :> TextData[ 
                                        Map[ Cell[ 
                                        BoxData[ {#}]]&, a1]]}], {TextData[ {
                                        Pattern[ b1, 
                                        BlankNullSequence[ ]], 
                                        Cell[ 
                                        BoxData[ {
                                        Pattern[ a1, 
                                        Blank[ String]]}], 
                                        BlankNullSequence[ ]], 
                                        Pattern[ c1, 
                                        BlankNullSequence[ ]]}] :> 
                                      TextData[ {b1, a1, " ", c1}]}]]]}]], 
                            Set[ readitem, 
                              ReplaceRepeated[ readitem, {BoxData[ {
                                  Pattern[ x, 
                                    Blank[ ]]}, 
                                  BlankNullSequence[ ]] :> TextData[ {
                                  ToString[ 
                                    ReplaceAll[ x, {Pattern[ a1, 
                                        Blank[ String]] :> StringJoin[ "\"", 
                                        StringReplace[ 
                                        a1, {FromCharacterCode[ 34] -> "\\\"",
                                         "\\" -> "\\\\"}], "\""]}]]}]}]], 
                            Set[ readitem, 
                              ReplaceAll[ 
                              readitem, {GraphicsData[ "PostScript", 
                                  Pattern[ graphics, 
                                    Blank[ String]]] :> TextData[ {""}]}]], 
                            Set[ readitem, 
                              ReplaceRepeated[ readitem, {(Condition[ 
                                  Pattern[ x1, 
                                    Blank[ ]], 
                                  
                                  MemberQ[ {FontColor, FontFamily, 
                                    FontProperties, FontSize, FontSlant, 
                                    FontTracking, FontVariations, FontWeight, 
                                    Background}, x1]] -> Blank[ ]) :> 
                                Sequence[ ], StyleBox[ 
                                  Pattern[ l1, 
                                    Blank[ ]], 
                                  BlankNullSequence[ ]] :> l1, TextData[ {
                                  Pattern[ a1, 
                                    BlankNullSequence[ ]], 
                                  Cell[ 
                                    TextData[ {
                                      Pattern[ b1, 
                                        BlankSequence[ ]]}], 
                                    BlankNullSequence[ ]], 
                                  Pattern[ c1, 
                                    BlankNullSequence[ ]]}] :> 
                                TextData[ {a1, " ", b1, " ", c1}], TextData[ 
                                  Cell[ 
                                    TextData[ {
                                      Pattern[ a1, 
                                        BlankSequence[ ]]}], 
                                    BlankNullSequence[ ]]] :> TextData[ {a1}],
                                 Cell[ 
                                  CellGroupData[ {
                                    Cell[ 
                                      Pattern[ a, 
                                        BlankSequence[ ]]]}, 
                                    BlankNullSequence[ ]]] :> Cell[ a], {
                                Pattern[ a1, 
                                  BlankNullSequence[ ]], 
                                Cell[ 
                                  TextData[ {
                                    Pattern[ b1, 
                                      BlankSequence[ ]]}], 
                                  BlankNullSequence[ ]], 
                                Cell[ 
                                  TextData[ {
                                    Pattern[ c1, 
                                      BlankSequence[ ]]}], 
                                  BlankNullSequence[ ]], 
                                Pattern[ d1, 
                                  BlankNullSequence[ ]]} :> {a1, 
                                Cell[ 
                                  TextData[ {b1, "\n", c1}], "Text"], d1}}]], 
                            
                            Set[ readitem, 
                              ReplaceRepeated[ readitem, {TextData[ {
                                  Pattern[ b1, 
                                    BlankNullSequence[ ]], 
                                  Pattern[ a1, 
                                    Blank[ String]], 
                                  Pattern[ d1, 
                                    Blank[ String]], 
                                  Pattern[ c1, 
                                    BlankNullSequence[ ]]}] :> 
                                TextData[ {b1, 
                                  StringJoin[ a1, " ", d1], c1}]}]], 
                            Set[ readitem, 
                              ReplaceAll[ readitem, {Cell[ 
                                  TextData[ {
                                    Pattern[ a, 
                                      Blank[ ]]}], 
                                  Pattern[ b, 
                                    BlankSequence[ ]]] :> a}]], 
                            Set[ readitem, 
                              ReplaceAll[ 
                                ReplaceAll[ 
                                  Union[ 
                                    Flatten[ 
                                      StringCases[ readitem, 
                                        Repeated[ WordCharacter]]]], {
                                  Condition[ 
                                    Pattern[ a1, 
                                      Blank[ String]], 
                                    StringMatchQ[ a1, NumberString]] :> 
                                  Sequence[ ], Condition[ 
                                    Pattern[ a1, 
                                      Blank[ String]], 
                                    Equal[ 
                                      StringLength[ a1], 1]] :> 
                                  Sequence[ ]}], {{
                                Pattern[ a, 
                                  BlankNullSequence[ String]], 
                                Pattern[ b, 
                                  Blank[ String]]} :> StringJoin[ {
                                  Apply[ Sequence, 
                                    Flatten[ 
                                      Map[ {#, "+"}&, {a}]]], b}]}]], 
                            If[ 
                              SameQ[ readitem, {}], 
                              Set[ readitem, {""}]], 
                            Set[ readitem, 
                              StringJoin[ 
                              "http://www.google.com/search?hl=en&q=", 
                                StringReplace[ readitem, " " -> "+"], 
                                "+site:forums.wolfram.com+OR+site:www.\
mathematica-users.org/webMathematica/wiki/&hl=en&lr=&safe=off&start=0&sa=N"]],\
 {
                            URL[ readitem], None}]]]],
                  ButtonStyle->"Hyperlink",
                  ButtonFrame->"DialogBox"], 
                ButtonBox[
                  StyleBox["Web",
                    FontFamily->"Courier",
                    FontSize->11,
                    FontWeight->"Bold",
                    FontColor->GrayLevel[0]],
                  ButtonEvaluator->Automatic,
                  ButtonData:>Module[ {readitem}, 
                      CompoundExpression[ 
                        Set[ readitem, 
                          NotebookRead[ 
                            InputNotebook[ ]]], 
                        Catch[ 
                          CompoundExpression[ 
                            Which[ 
                              SameQ[ readitem, {}], 
                              Throw[ Null], 
                              Greater[ 
                                Count[ readitem, 
                                  Blank[ InterpretationBox], Infinity], 0], 
                              Throw[ Null], 
                              UnsameQ[ 
                                Cases[ readitem, 
                                  FormBox[ 
                                    BoxData[ 
                                      BlankNullSequence[ ]], 
                                    BlankNullSequence[ ]]], {}], 
                              Throw[ Null], 
                              ListQ[ readitem], 
                              Set[ readitem, 
                                ReplaceRepeated[ 
                                  Cell[ 
                                    TextData[ readitem], "Text"], {Cell[ 
                                    CellGroupData[ {
                                      Pattern[ a1, 
                                        BlankSequence[ ]]}, 
                                      BlankNullSequence[ ]], 
                                    BlankNullSequence[ ]] :> Sequence[ a1]}]],
                               
                              MatchQ[ readitem, 
                                Blank[ String]], 
                              Set[ readitem, 
                                Cell[ 
                                  TextData[ {readitem}], "Text"]], 
                              StringMatchQ[ 
                                ToString[ 
                                  Head[ readitem]], 
                                StringExpression[ 
                                  BlankSequence[ ], "Box"]], 
                              Set[ readitem, 
                                Cell[ 
                                  TextData[ {
                                    Cell[ 
                                      BoxData[ {readitem}], "Text"]}], 
                                  "Text"]]], 
                            Which[ 
                              MatchQ[ readitem, 
                                Alternatives[ 
                                  Cell[ 
                                    Blank[ GraphicsData], 
                                    BlankNullSequence[ ]], 
                                  Blank[ GraphicsData]]], 
                              Throw[ Null], 
                              MatchQ[ readitem, 
                                Blank[ BoxData]], 
                              Set[ readitem, 
                                Cell[ 
                                  TextData[ {
                                    Cell[ readitem]}], "Text"]], 
                              MatchQ[ readitem, 
                                Cell[ 
                                  Blank[ BoxData], 
                                  BlankNullSequence[ ]]], 
                              Set[ readitem, 
                                Cell[ 
                                  TextData[ {readitem}], "Text"]], 
                              MatchQ[ readitem, 
                                Cell[ 
                                  Blank[ CellGroupData], 
                                  BlankNullSequence[ ]]], 
                              Set[ readitem, 
                                Cell[ 
                                  TextData[ 
                                    Part[ readitem, 1, 1]], "Text"]], 
                              MatchQ[ readitem, 
                                Blank[ TextData]], 
                              Set[ readitem, 
                                Cell[ readitem, "Text"]]], 
                            Set[ readitem, 
                              ReplaceRepeated[ 
                                ReplaceAll[ readitem, {TextData[ 
                                    Pattern[ a, 
                                      Blank[ String]]] :> TextData[ {a}], 
                                  Cell[ 
                                    Pattern[ a, 
                                      Blank[ String]], 
                                    BlankNullSequence[ ]] :> Cell[ 
                                    TextData[ {a}], "Text"], Condition[ 
                                    BoxData[ 
                                      Pattern[ x, 
                                        Blank[ ]]], 
                                    UnsameQ[ 
                                      Head[ x], List]] :> BoxData[ {x}]}], {
                                TextData[ {
                                  Pattern[ a1, 
                                    BlankNullSequence[ ]], 
                                  Pattern[ b1, 
                                    Blank[ ButtonBox]], 
                                  Pattern[ c1, 
                                    BlankNullSequence[ ]]}] :> 
                                TextData[ {a1, 
                                  Cell[ 
                                    BoxData[ {b1}], "Input"], c1}]}]], 
                            Set[ readitem, 
                              ReplaceAll[ readitem, {RowBox[ {"(*", 
                                  Pattern[ a1, 
                                    BlankNullSequence[ ]], "*)"}] :> 
                                RowBox[ {
                                  RowBox[ {"(", 
                                    FromCharacterCode[ 34], 
                                    Apply[ Sequence, 
                                      ReplaceAll[ {a1}, {Pattern[ x, 
                                        Blank[ String]] :> StringReplace[ 
                                        x, {FromCharacterCode[ 34] -> "\\\"", 
                                        "\\" -> "\\\\"}]}]], 
                                    FromCharacterCode[ 34], ")"}], ";"}]}]], 
                            Set[ readitem, 
                              ReplaceRepeated[ 
                                ReplaceRepeated[ 
                                  ReplaceRepeated[ readitem, {Condition[ 
                                      RowBox[ {
                                        Pattern[ g1, 
                                        Blank[ ]], 
                                        Pattern[ g2, 
                                        BlankNullSequence[ ]]}], 
                                      Not[ 
                                        
                                        MemberQ[ {String, List, RowBox, 
                                        FormBox}, 
                                        Head[ g1]]]] :> Block[ {
                                      Set[ $Messages, {}]}, 
                                      Check[ 
                                        StringDrop[ 
                                        StringDrop[ 
                                        ToString[ 
                                        InputForm[ 
                                        FullForm[ 
                                        ToExpression[ 
                                        StringJoin[ "\!", 
                                        ToString[ 
                                        RowBox[ {"HoldComplete", "[", 
                                        RowBox[ {g1, g2}], "]"}], 
                                        InputForm]]]]]], 22], -2], 
                                        RowBox[ {g1, g2}]]]}], {StyleBox[ 
                                    Pattern[ a1, 
                                      Blank[ ]], 
                                    BlankNullSequence[ ]] :> a1, FormBox[ 
                                    Pattern[ a1, 
                                      Blank[ List]], 
                                    Pattern[ b1, 
                                      Blank[ ]]] :> RowBox[ a1], FormBox[ 
                                    Pattern[ a1, 
                                      BlankSequence[ ]], 
                                    Pattern[ b1, 
                                      Blank[ ]]] :> RowBox[ {a1}]}], {
                                RowBox[ {
                                  Pattern[ g1, 
                                    BlankNullSequence[ ]], {
                                  Pattern[ g2, 
                                    Blank[ ]]}, 
                                  Pattern[ g3, 
                                    BlankNullSequence[ ]]}] :> 
                                RowBox[ {g1, g2, g3}]}]], 
                            Set[ readitem, 
                              ReplaceRepeated[ readitem, {RowBox[ {
                                  Pattern[ c1, 
                                    BlankNullSequence[ ]], 
                                  Pattern[ a1, 
                                    Blank[ String]], 
                                  Pattern[ b1, 
                                    Blank[ String]], 
                                  Pattern[ d1, 
                                    BlankNullSequence[ ]]}] :> RowBox[ {c1, 
                                  StringJoin[ a1, " ", b1], d1}], BoxData[ {
                                  Pattern[ a1, 
                                    Blank[ ]], 
                                  Pattern[ b1, 
                                    Blank[ ]], 
                                  Pattern[ c1, 
                                    BlankNullSequence[ ]]}] :> BoxData[ {
                                  RowBox[ {a1, "\n", b1}], c1}], BoxData[ {
                                  Pattern[ a1, 
                                    Blank[ String]]}] :> TextData[ {a1}]}]], 
                            Set[ readitem, 
                              ReplaceRepeated[ readitem, {BoxData[ {
                                  Pattern[ x, 
                                    Blank[ ]]}, 
                                  BlankNullSequence[ ]] :> Block[ {
                                  Set[ $Messages, {}]}, 
                                  Check[ 
                                    TextData[ {
                                      StringDrop[ 
                                        StringDrop[ 
                                        ToString[ 
                                        InputForm[ 
                                        FullForm[ 
                                        ToExpression[ 
                                        StringJoin[ "\!", 
                                        ToString[ 
                                        
                                        RowBox[ {"HoldComplete", "[", x, 
                                        "]"}], InputForm]]]]]], 22], -2]}], 
                                    ReplaceRepeated[ 
                                      ReplaceRepeated[ 
                                        ReplaceRepeated[ 
                                        BoxData[ {x}], {(Condition[ 
                                        Pattern[ x1, 
                                        Blank[ ]], 
                                        
                                        MemberQ[ {FontColor, FontFamily, 
                                        FontProperties, FontSize, FontSlant, 
                                        FontTracking, FontVariations, 
                                        FontWeight, Background}, x1]] -> 
                                        Blank[ ]) :> Sequence[ ], StyleBox[ 
                                        Pattern[ l1, 
                                        Blank[ ]], 
                                        BlankNullSequence[ ]] :> l1, 
                                        RowBox[ {
                                        Pattern[ c1, 
                                        BlankNullSequence[ ]], 
                                        Pattern[ a1, 
                                        Blank[ String]], 
                                        Pattern[ b1, 
                                        Blank[ String]], 
                                        Pattern[ d1, 
                                        BlankNullSequence[ ]]}] :> 
                                        RowBox[ {c1, 
                                        StringJoin[ a1, " ", b1], d1}], 
                                        RowBox[ {
                                        Pattern[ a1, 
                                        BlankNullSequence[ ]], 
                                        RowBox[ {
                                        Pattern[ b1, 
                                        BlankNullSequence[ ]]}], 
                                        Pattern[ c1, 
                                        BlankNullSequence[ ]]}] :> 
                                        RowBox[ {a1, " ", b1, " ", c1}], 
                                        BoxData[ 
                                        Pattern[ a1, 
                                        Blank[ String]]] :> TextData[ {a1}], 
                                        BoxData[ {
                                        Pattern[ a1, 
                                        Blank[ ]], 
                                        Pattern[ b1, 
                                        Blank[ ]], 
                                        Pattern[ c1, 
                                        BlankNullSequence[ ]]}] :> BoxData[ {
                                        RowBox[ {a1, "\n", b1}], c1}], 
                                        FormBox[ 
                                        Pattern[ a1, 
                                        Blank[ List]], 
                                        Pattern[ b1, 
                                        Blank[ ]]] :> RowBox[ a1], FormBox[ 
                                        Pattern[ a1, 
                                        BlankSequence[ ]], 
                                        Pattern[ b1, 
                                        Blank[ ]]] :> RowBox[ {a1}], 
                                        GridBox[ {
                                        Pattern[ a1, 
                                        BlankNullSequence[ ]], {
                                        Pattern[ c1, 
                                        BlankNullSequence[ ]], {
                                        Pattern[ d1, 
                                        BlankNullSequence[ ]]}, 
                                        Pattern[ e1, 
                                        BlankNullSequence[ ]]}, 
                                        Pattern[ b1, 
                                        BlankNullSequence[ ]]}, 
                                        Pattern[ f1, 
                                        BlankNullSequence[ ]]] :> 
                                        GridBox[ {a1, {c1, 
                                        RowBox[ {d1}], e1}, b1}, f1]}], {
                                        BoxData[ {
                                        RowBox[ 
                                        Pattern[ a1, 
                                        Blank[ List]]]}] :> TextData[ 
                                        Map[ Cell[ 
                                        BoxData[ {#}]]&, a1]]}], {TextData[ {
                                        Pattern[ b1, 
                                        BlankNullSequence[ ]], 
                                        Cell[ 
                                        BoxData[ {
                                        Pattern[ a1, 
                                        Blank[ String]]}], 
                                        BlankNullSequence[ ]], 
                                        Pattern[ c1, 
                                        BlankNullSequence[ ]]}] :> 
                                      TextData[ {b1, a1, " ", c1}]}]]]}]], 
                            Set[ readitem, 
                              ReplaceRepeated[ readitem, {BoxData[ {
                                  Pattern[ x, 
                                    Blank[ ]]}, 
                                  BlankNullSequence[ ]] :> TextData[ {
                                  ToString[ 
                                    ReplaceAll[ x, {Pattern[ a1, 
                                        Blank[ String]] :> StringJoin[ "\"", 
                                        StringReplace[ 
                                        a1, {FromCharacterCode[ 34] -> "\\\"",
                                         "\\" -> "\\\\"}], "\""]}]]}]}]], 
                            Set[ readitem, 
                              ReplaceAll[ 
                              readitem, {GraphicsData[ "PostScript", 
                                  Pattern[ graphics, 
                                    Blank[ String]]] :> TextData[ {""}]}]], 
                            Set[ readitem, 
                              ReplaceRepeated[ readitem, {(Condition[ 
                                  Pattern[ x1, 
                                    Blank[ ]], 
                                  
                                  MemberQ[ {FontColor, FontFamily, 
                                    FontProperties, FontSize, FontSlant, 
                                    FontTracking, FontVariations, FontWeight, 
                                    Background}, x1]] -> Blank[ ]) :> 
                                Sequence[ ], StyleBox[ 
                                  Pattern[ l1, 
                                    Blank[ ]], 
                                  BlankNullSequence[ ]] :> l1, TextData[ {
                                  Pattern[ a1, 
                                    BlankNullSequence[ ]], 
                                  Cell[ 
                                    TextData[ {
                                      Pattern[ b1, 
                                        BlankSequence[ ]]}], 
                                    BlankNullSequence[ ]], 
                                  Pattern[ c1, 
                                    BlankNullSequence[ ]]}] :> 
                                TextData[ {a1, " ", b1, " ", c1}], TextData[ 
                                  Cell[ 
                                    TextData[ {
                                      Pattern[ a1, 
                                        BlankSequence[ ]]}], 
                                    BlankNullSequence[ ]]] :> TextData[ {a1}],
                                 Cell[ 
                                  CellGroupData[ {
                                    Cell[ 
                                      Pattern[ a, 
                                        BlankSequence[ ]]]}, 
                                    BlankNullSequence[ ]]] :> Cell[ a], {
                                Pattern[ a1, 
                                  BlankNullSequence[ ]], 
                                Cell[ 
                                  TextData[ {
                                    Pattern[ b1, 
                                      BlankSequence[ ]]}], 
                                  BlankNullSequence[ ]], 
                                Cell[ 
                                  TextData[ {
                                    Pattern[ c1, 
                                      BlankSequence[ ]]}], 
                                  BlankNullSequence[ ]], 
                                Pattern[ d1, 
                                  BlankNullSequence[ ]]} :> {a1, 
                                Cell[ 
                                  TextData[ {b1, "\n", c1}], "Text"], d1}}]], 
                            
                            Set[ readitem, 
                              ReplaceRepeated[ readitem, {TextData[ {
                                  Pattern[ b1, 
                                    BlankNullSequence[ ]], 
                                  Pattern[ a1, 
                                    Blank[ String]], 
                                  Pattern[ d1, 
                                    Blank[ String]], 
                                  Pattern[ c1, 
                                    BlankNullSequence[ ]]}] :> 
                                TextData[ {b1, 
                                  StringJoin[ a1, " ", d1], c1}]}]], 
                            Set[ readitem, 
                              ReplaceAll[ readitem, {Cell[ 
                                  TextData[ {
                                    Pattern[ a, 
                                      Blank[ ]]}], 
                                  Pattern[ b, 
                                    BlankSequence[ ]]] :> a}]], 
                            Set[ readitem, 
                              ReplaceAll[ 
                                ReplaceAll[ 
                                  Union[ 
                                    Flatten[ 
                                      StringCases[ readitem, 
                                        Repeated[ WordCharacter]]]], {
                                  Condition[ 
                                    Pattern[ a1, 
                                      Blank[ String]], 
                                    StringMatchQ[ a1, NumberString]] :> 
                                  Sequence[ ], Condition[ 
                                    Pattern[ a1, 
                                      Blank[ String]], 
                                    Equal[ 
                                      StringLength[ a1], 1]] :> 
                                  Sequence[ ]}], {{
                                Pattern[ a, 
                                  BlankNullSequence[ String]], 
                                Pattern[ b, 
                                  Blank[ String]]} :> StringJoin[ {
                                  Apply[ Sequence, 
                                    Flatten[ 
                                      Map[ {#, "+"}&, {a}]]], b}]}]], 
                            If[ 
                              SameQ[ readitem, {}], 
                              Set[ readitem, {""}]], 
                            Set[ readitem, 
                              StringJoin[ 
                              "http://www.google.com/search?hl=en&q=", 
                                StringReplace[ readitem, " " -> "+"], ""]], {
                            URL[ readitem], None}]]]],
                  ButtonStyle->"Hyperlink",
                  ButtonFrame->"DialogBox"]}
              },
            ColumnSpacings->0]},
        {GridBox[{
              {
                ButtonBox[
                  StyleBox[\(Get\ Font\ Options\),
                    FontFamily->"Helvetica",
                    FontSize->12,
                    FontColor->GrayLevel[0]],
                  ButtonFunction:>CompoundExpression[ 
                      Set[ $FontPaintOptions, 
                        AbsoluteOptions[ 
                          NotebookSelection[ 
                            InputNotebook[ ]], {FontColor, FontFamily, 
                          FontProperties, FontSize, FontSlant, FontTracking, 
                          FontVariations, FontWeight, Background}]], 
                      NotebookFind[ 
                        ButtonNotebook[ ], "Button cell", All, CellTags], 
                      Module[ {cellcontent}, 
                        CompoundExpression[ 
                          Set[ cellcontent, 
                            NotebookRead[ 
                              ButtonNotebook[ ]]], 
                          Set[ 
                            Part[ cellcontent, 1, 1, 1, 8, 1, 1, 1, 2, 1], 
                            StyleBox[ 
                              RowBox[ {"Paint", " ", "Font", " ", "Options"}],
                               
                              Apply[ Sequence, 
                                Map[ Part[ 
                                    Cases[ 
                                      Join[ $FontPaintOptions, 
                                        Drop[ 
                                        Apply[ List, 
                                        Part[ 
                                        cellcontent, 1, 1, 1, 8, 1, 1, 1, 2, 
                                        1]], 1]], 
                                      Pattern[ x, 
                                        Alternatives[ # -> Pattern[ z, 
                                        Blank[ ]], 
                                        Pattern[ x, # :> Pattern[ z, 
                                        Blank[ ]]]]], {1}, 1], 1]&, {
                                  FontColor, FontFamily, FontProperties, 
                                  FontSlant, FontTracking, FontVariations, 
                                  FontWeight}]]]], 
                          Set[ 
                            Part[ cellcontent, 1, 1, 1, 8, 1, 1, 1, 2, -1], 
                            Apply[ Sequence, 
                              Map[ Part[ 
                                  Cases[ 
                                    
                                    Append[ $FontPaintOptions, Background -> 
                                      GrayLevel[ .90000000000000002]], 
                                    Pattern[ x, 
                                      Alternatives[ # -> Pattern[ z, 
                                        Blank[ ]], 
                                        Pattern[ x, # :> Pattern[ z, 
                                        Blank[ ]]]]], {1}, 1], 1]&, {
                                Background}]]], 
                          NotebookWrite[ 
                            ButtonNotebook[ ], cellcontent]]]],
                  ButtonEvaluator->Automatic,
                  Active->True,
                  ButtonFrame->"DialogBox",
                  Background->GrayLevel[0.900008]], 
                ButtonBox[
                  
                  StyleBox[\(\(\(\ \ \ \)\(Paint\)\)\ Font\ \(\(Options\)\(\ \
\ \ \ \ \)\)\),
                    FontFamily->"Helvetica",
                    FontSize->12,
                    FontColor->GrayLevel[0]],
                  ButtonFunction:>CompoundExpression[ 
                      If[ 
                        Not[ 
                          ListQ[ $FontPaintOptions]], 
                        CompoundExpression[ 
                          Set[ $FontPaintOptions, 
                            AbsoluteOptions[ 
                              NotebookSelection[ 
                                InputNotebook[ ]], {FontColor, FontFamily, 
                              FontProperties, FontSize, FontSlant, 
                              FontTracking, FontVariations, FontWeight, 
                              Background}]], 
                          NotebookFind[ 
                            ButtonNotebook[ ], "Button cell", All, CellTags], 
                          
                          Module[ {cellcontent}, 
                            CompoundExpression[ 
                              Set[ cellcontent, 
                                NotebookRead[ 
                                  ButtonNotebook[ ]]], 
                              Set[ 
                                Part[ cellcontent, 1, 1, 1, 8, 1, 1, 1, 2, 1],
                                 
                                StyleBox[ 
                                  
                                  RowBox[ {"Paint", " ", "Font", " ", 
                                    "Options"}], 
                                  Apply[ Sequence, 
                                    Map[ Part[ 
                                        Cases[ 
                                        Join[ $FontPaintOptions, 
                                        Drop[ 
                                        Apply[ List, 
                                        Part[ 
                                        cellcontent, 1, 1, 1, 8, 1, 1, 1, 2, 
                                        1]], 1]], 
                                        Pattern[ x, 
                                        Alternatives[ # -> Pattern[ z, 
                                        Blank[ ]], 
                                        Pattern[ x, # :> Pattern[ z, 
                                        Blank[ ]]]]], {1}, 1], 1]&, {
                                      FontColor, FontFamily, FontProperties, 
                                      FontSlant, FontTracking, FontVariations,
                                       FontWeight}]]]], 
                              Set[ 
                                Part[ 
                                cellcontent, 1, 1, 1, 8, 1, 1, 1, 2, -1], 
                                Apply[ Sequence, 
                                  Map[ Part[ 
                                      Cases[ 
                                        
                                        Append[ $FontPaintOptions, Background -> 
                                        GrayLevel[ .90000000000000002]], 
                                        Pattern[ x, 
                                        Alternatives[ # -> Pattern[ z, 
                                        Blank[ ]], 
                                        Pattern[ x, # :> Pattern[ z, 
                                        Blank[ ]]]]], {1}, 1], 1]&, {
                                    Background}]]], 
                              NotebookWrite[ 
                                ButtonNotebook[ ], cellcontent]]]]], 
                      SetOptions[ 
                        NotebookSelection[ 
                          InputNotebook[ ]], 
                        Apply[ Sequence, $FontPaintOptions]]],
                  ButtonEvaluator->Automatic,
                  Active->True,
                  ButtonFrame->"DialogBox",
                  Background->GrayLevel[0.900008]]}
              }]}
        },
      RowSpacings->0,
      ColumnSpacings->0]], NotebookDefault,
  PageBreakAbove->True,
  CellFrameMargins->1,
  InputAutoReplacements->{
    "->"->"\[Rule]", ":>"->"\[RuleDelayed]", "<="->"\[LessEqual]", 
      ">="->"\[GreaterEqual]", "!="->"\[NotEqual]", "=="->"\[Equal]", 
      Inherited},
  "TwoByteSyntaxCharacterAutoReplacement"->True,
  LineSpacing->{1.25, 0},
  StyleMenuListing->None,
  FontFamily->"Courier",
  Background->GrayLevel[0.800015],
  CellTags->"Button cell"]
},
FrontEndVersion->"5.1 for Microsoft Windows",
ScreenRectangle->{{0, 1280}, {0, 933}},
ClosingAutoSave->True,
Editable->False,
WindowToolbars->{},
Selectable->True,
PageWidth->472,
WindowSize->{Fit, Fit},
WindowMargins->{{6, Automatic}, {124, Automatic}},
WindowFrame->"Palette",
WindowElements->{},
WindowFrameElements->"CloseBox",
WindowClickSelect->False,
ScrollingOptions->{"PagewiseScrolling"->True,
"VerticalScrollRange"->Fit},
ShowCellBracket->False,
ShowSelection->True,
CellMargins->{{0, 0}, {Inherited, 0}},
Active->True,
CellOpen->True,
ShowCellLabel->False,
ShowCellTags->False,
ImageMargins->{{0, Inherited}, {Inherited, 0}},
Background->GrayLevel[1],
Magnification->1
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "Button cell"->{
    Cell[1755, 51, 248633, 4652, 181, NotebookDefault,
      PageBreakAbove->True,
      CellTags->"Button cell"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"Button cell", 251510, 4741}
  }
*)

(*NotebookFileOutline
Notebook[{
Cell[1755, 51, 248633, 4652, 181, NotebookDefault,
  PageBreakAbove->True,
  CellTags->"Button cell"]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

