(************** Content-type: application/mathematica **************
                     CreatedBy='Mathematica 5.1'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     14320,        500]*)
(*NotebookOutlinePosition[     14967,        522]*)
(*  CellTagsIndexPosition[     14923,        518]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["SetFaceAndFont Palette, Version History", "Title"],

Cell["Ingolf Dahl, Sweden", "Text"],

Cell[TextData[{
  "Version 1, published to MathGroup September 29, 2004:\nButtons ",
  StyleBox["Copy As InputForm",
    FontFamily->"Courier",
    FontWeight->"Plain",
    FontSlant->"Plain",
    FontVariations->{"Underline"->False}],
  StyleBox[", ",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  StyleBox["Plain",
    FontFamily->"Courier",
    FontSlant->"Plain"],
  ", ",
  StyleBox["Bold",
    FontWeight->"Bold"],
  ", ",
  StyleBox["Italic",
    FontSlant->"Italic"],
  ", ",
  StyleBox["Underline",
    FontVariations->{"Underline"->True}],
  ", ",
  StyleBox["Courier Plain",
    FontFamily->"Courier",
    FontSlant->"Plain"],
  ", Times Plain, ",
  StyleBox["Times Italic",
    FontFamily->"Times",
    FontSlant->"Italic"],
  " included.\n\nVersion 2.0, published to a limited set of people in October \
2004 and July 2005:\n1. Button ",
  StyleBox["Copy As InputForm",
    FontFamily->"Courier",
    FontWeight->"Plain",
    FontSlant->"Plain",
    FontVariations->{"Underline"->False}],
  " replaced by ",
  StyleBox["CopyAsInputFormK",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  " \n2. Buttons ",
  StyleBox["\"*\[Rule]_\", \"",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  Cell[BoxData[
      \(\[SelectionPlaceholder], \[SelectionPlaceholder]\)], "Text",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  StyleBox["\", \"",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  Cell[BoxData[
      \(\[SelectionPlaceholder]\)], "Text",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  StyleBox["\", ?, (",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  Cell[BoxData[
      \(\[SelectionPlaceholder]\)], "Text",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  StyleBox["), {",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  Cell[BoxData[
      \(\[SelectionPlaceholder]\)], "Text",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  StyleBox["}, [",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  Cell[BoxData[
      \(\[SelectionPlaceholder]\)], "Text",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  StyleBox["], [[",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  Cell[BoxData[
      \(\[SelectionPlaceholder]\)], "Text",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  StyleBox["]], (* ",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  Cell[BoxData[
      \(\[SelectionPlaceholder]\)], "Text",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  StyleBox[" *),",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  " ",
  StyleBox["Helvetica",
    FontFamily->"Helvetica",
    FontWeight->"Plain",
    FontSlant->"Plain"],
  ", font size buttons, ",
  StyleBox["Peel,",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  " ",
  StyleBox["StyleRemove, ",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  StyleBox["Black",
    FontFamily->"Helvetica",
    FontWeight->"Bold",
    FontSlant->"Plain",
    FontColor->GrayLevel[0]],
  StyleBox[", ",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  StyleBox["Red",
    FontFamily->"Helvetica",
    FontWeight->"Bold",
    FontSlant->"Plain",
    FontColor->RGBColor[1, 0, 0]],
  StyleBox[", ",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  StyleBox["Green",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain",
    FontColor->RGBColor[0, 0.6, 0]],
  StyleBox[", ",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  StyleBox["Blue",
    FontFamily->"Helvetica",
    FontWeight->"Bold",
    FontSlant->"Plain",
    FontColor->RGBColor[0, 0, 1]],
  StyleBox[", Search",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  ",  ",
  StyleBox["MG, ",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  StyleBox["background buttons,",
    FontFamily->"Times",
    FontWeight->"Plain",
    FontSlant->"Plain",
    FontVariations->{"Underline"->False}],
  StyleBox[" ",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  StyleBox["GetFontOptions",
    FontFamily->"Helvetica",
    FontWeight->"Plain",
    FontSlant->"Plain"],
  StyleBox[" and ",
    FontFamily->"Times",
    FontWeight->"Plain",
    FontSlant->"Plain"],
  StyleBox["PaintFontOptions",
    FontFamily->"Helvetica",
    FontWeight->"Plain",
    FontSlant->"Plain"],
  " included",
  StyleBox[" \n",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  StyleBox["3. Help implemented.",
    FontFamily->"Times",
    FontWeight->"Plain",
    FontSlant->"Plain",
    FontVariations->{"Underline"->False}],
  "\n\nVersion 2.0.1 published August 25, 2005\nChanges from version 2.0 to \
2.0.1:\n1: Button ",
  StyleBox["CopyAsInputFormK",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  " corrected to allow copying to external programs.\n2. Button ",
  StyleBox["CopyAsInputFormK",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  " corrected to allow copying of multiline multicommand cells.\n3.  Button \
",
  StyleBox["CopyAsInputFormK",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  " changed to do the following conversions: \
{\"\[LeftDoubleBracket]\"->\"[[\",\"\[RightDoubleBracket]\"->\"]]\",\"\[Equal]\
\"->\"==\",\n  \"\[LessEqual]\"->\"<=\",\"\[GreaterEqual]\"-> \">=\",\"\
\[NotEqual]\"->\"!=\", \n  \"\[Rule]\"->\"->\",\"\[RuleDelayed]\"->\":>\", \"\
\[Continuation]\"->\" \",\"\\t\"->\" \",\"\\[InvisibleSpace ]\"->\" \", \
FromCharacterCode[1]->\" \", \"  \"->\" \"}.\n 4. Button",
  StyleBox[" ",
    FontFamily->"Helvetica",
    FontWeight->"Plain",
    FontSlant->"Plain",
    FontVariations->{"Underline"->False}],
  StyleBox["(* ",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain",
    FontVariations->{"Underline"->False}],
  Cell[BoxData[
      \(\[SelectionPlaceholder]\)], "Text"],
  StyleBox[" *)",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain",
    FontVariations->{"Underline"->False}],
  " changed to create spaces inside comment brackets.\n 5. Button  ",
  StyleBox["\[LeftDoubleBracket]",
    FontFamily->"Helvetica",
    FontWeight->"Plain",
    FontSlant->"Plain"],
  Cell[BoxData[
      \(\[SelectionPlaceholder]\)], "Text"],
  StyleBox["\[RightDoubleBracket]",
    FontFamily->"Helvetica",
    FontWeight->"Plain",
    FontSlant->"Plain"],
  " changed to use LeftDoubleBracket and RightDoubleBracket instead of pairs \
of single brackets.\n 6. ",
  StyleBox["Web",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  " button added.\n 7. ",
  StyleBox["Courier B",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  " button added.\n 8. Cosmetic changes to the palette are made.\n 9. Code \
changes in the buttons ",
  StyleBox["Peel,",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  "  \"*\[Rule]_\", \"",
  Cell[BoxData[
      \(\[SelectionPlaceholder], \[SelectionPlaceholder]\)], "Text"],
  "\", \"",
  Cell[BoxData[
      \(\[SelectionPlaceholder]\)], "Text"],
  "\", ",
  StyleBox["Search",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  ", ",
  StyleBox["MG",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  ", ",
  StyleBox["Web",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  " to avoid interference with the external clipboard.\n 10. ",
  StyleBox["Courier",
    FontFamily->"Courier",
    FontWeight->"Plain",
    FontSlant->"Plain"],
  ", ",
  StyleBox["Helvetica",
    FontFamily->"Helvetica",
    FontWeight->"Plain",
    FontSlant->"Plain"],
  ", ",
  StyleBox["Times",
    FontFamily->"Times",
    FontWeight->"Plain",
    FontSlant->"Plain"],
  " and ",
  StyleBox["Times Italic",
    FontFamily->"Times",
    FontWeight->"Plain",
    FontSlant->"Italic"],
  " buttons corrected to remove bold font.\n 11.  ",
  StyleBox["CopyAsInputFormK",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  ", ",
  StyleBox["Peel",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  " and ",
  StyleBox["StyleRemove",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  " buttons corrected to avoid multiple line feeds at some occasions.\n 12. \
The action of ",
  StyleBox["Peel",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  " on GraphicsData cell is changed to allow reentering of the PostScript \
code.\n \n Changes from version 2.0.1 to 2.0.2:\n 1. ",
  StyleBox["Peel",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  " changed to return executable cell from a Graphics3D cell. ",
  StyleBox["CopyAsInputFormK",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  ", ",
  StyleBox["\"",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  Cell[BoxData[
      \(\[SelectionPlaceholder]\)], "Text",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  StyleBox["\"",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  " and ",
  StyleBox["StyleRemove",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  " buttons corrected in behavior in relation to Graphics3D cells.\n 2. The \
",
  StyleBox["CopyAsInputFormK",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  " button uses now the \"Convert to InputForm\" mechanism for sound cells.\n \
3. The file \"SetFaceAndFont2.nb\" is set to \"read-only\", to prevent \
unintended changes. \n \n Changes from version 2.0.2 to 2.0.3:\n 1.  ",
  StyleBox["CopyAsInputFormK,Search",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  ", ",
  StyleBox["MG",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  ", ",
  StyleBox["Web",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  " buttons changed to allow embedded ButtonBox objects in TextData.\n\n\
Version 2.0.4 published September 14, 2005  \nChanges from version 2.0.3 to \
2.0.4:\n1. ",
  StyleBox["Peel",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  " changed to return executable cell from a SurfaceGraphics cell rendered as \
a RealTime3D cell. ",
  StyleBox["CopyAsInputFormK",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  ", ",
  StyleBox["\"",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  Cell[BoxData[
      \(\[SelectionPlaceholder]\)], "Text",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  StyleBox["\"",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  " and ",
  StyleBox["StyleRemove",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  " buttons corrected in behavior in relation to a SurfaceGraphics cell \
rendered as a RealTime3D cell. If you are curious about such cells, see ",
  ButtonBox["http://forums.wolfram.com/mathgroup/archive/2001/Apr/msg00346.\
html",
    ButtonData:>{
      URL[ 
      "http://forums.wolfram.com/mathgroup/archive/2001/Apr/msg00346.html"], 
      None},
    ButtonStyle->"Hyperlink"],
  ". \n2. Some entries have been added to Help Master Index and some entries \
have been changed..\n3. The language in the search result pagess for ",
  StyleBox["Search",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  ", ",
  StyleBox["MG",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  ", ",
  StyleBox["Web",
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  " buttons has been changed to English. (Oops! Thanks John Jowett)\
\[IndentingNewLine]\[IndentingNewLine]"
}], "Text"]
}, Open  ]]
},
FrontEndVersion->"5.1 for Microsoft Windows",
ScreenRectangle->{{0, 1280}, {0, 933}},
WindowSize->{624, 748},
WindowMargins->{{118, Automatic}, {Automatic, -31}}
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1776, 53, 56, 0, 150, "Title"],
Cell[1835, 55, 35, 0, 33, "Text"],
Cell[1873, 57, 12431, 440, 1023, "Text"]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

